$page.load = function (cb) {
    $page.addButtons([{
        icon: "fa fa-plus",
        text: "新增",
        color: 3,
        click: function () {
            $.server.navigate('RC17', { 
                m_source: "RC4301", 
                sch_type: "00005WT59VSE0000000000", 
                sch_name: "日程", 
                start: $.date.parseDate($.date.format($.server.currentDate(), "yyyy-MM-dd"), 1), 
                end: $.date.parseDate($.date.format($.server.currentDate(), "yyyy-MM-dd"), 1) 
            });
        }
    }]);

    var query = new $.server.queryOptions();
    query.PrimaryTable = "RC202";
    query.Tables = "RC202, YH101, YH102";
    query.PageIndex = 1;
    query.FieldNameList = "RC202.*, YH101.A12, YH102.A03";
    query.ConditionExpr = "RC202.A03 = YH101.ID AND YH101.A06 = YH102.ID ";

    var lst = new mListView($("#lst"));

    lst.load(query, {
        layout: {
            icon: "YH101_A12",
            r0c0: "<span style='font-size:1em'>${RC202_A03MC}</span>&nbsp;&nbsp;<span style='color: #999; font-size:0.9em'>${YH102_A03}</span> ",
            r1c0: "<span style='color: #999; font-size:0.9em'>${$.date.format(RC202_A01, 'yyyy-MM-dd HH:mm')} 至 ${$.date.format(RC202_A02, 'yyyy-MM-dd HH:mm')}</span>",
            r2c0: "<div style='font-size:0.9em;white-space: nowrap; overflow: hidden; text-overflow: ellipsis'>${RC202_A05}</div>",
        }
    });

    lst.afterSelect = function (op) {
        var q = $.extend(new $.server.queryOptions(), lst.getQuery());
        q = $.extend(q, { PageSize: 200, PageIndex: 1 });
        
        var f = lst.getFilter();
        if (f) {
            if (q.ConditionExpr.length == 0) {
                q.ConditionExpr = '1=1';
            }
            q.ConditionExpr = "(" + q.ConditionExpr + ") AND (" + f + ")"
        }
        $.server.query(q, function (data) {
            $.server.navigate('RC18', { rcid: op.data.RC202_ID, m_source: "RC4302", sch_type: "00005WT59VSE0000000000", allDatas: data.DataSource });
        });
    };
};

$page.afterRefresh = function() {
    var lst = $("#lst").ctl();
    lst.refresh();
};
