$page.load = function (cb) {
    var rcCalendar = new MyCalendar("#calendar");
    var query = new $.server.queryOptions();
    query.PrimaryTable = "RC101";
    query.PrimaryKeyField = "ID";
    query.PageSize = 200;
    query.FieldNameList = "*";
    query.ConditionExpr = " RC101.A03 = '" + $.server.cache.CurrentUser.Uid + "' AND (RC101.A04 = '00005WT59OHT0000000000' OR RC101.A04 = '00005WT59VSE0000000000') ";
    
    var queryZl = new $.server.queryOptions();
    queryZl.PrimaryTable = "RC102";
    queryZl.PrimaryKeyField = "ID";
    queryZl.FieldNameList = "*";
    queryZl.OrderExpr = "ID ASC";
    
    rcCalendar.afterLoad = function(op,callback){
        var lst = new mListView($("#lst"));
        
        var queryL = new $.server.queryOptions();
        queryL.PrimaryTable = "RC101";
        queryL.Tables = "RC102, YH101, YH102";
        queryL.FieldNameList = "RC101.*, RC102.*, YH101.A06, YH101.A12, YH102.A03";
        queryL.ConditionExpr = "RC102.ID = RC101.A04 AND RC101.A03 = '" + $.server.cache.CurrentUser.Uid + "'" +
                                " AND RC101.A03 = YH101.ID AND YH101.A06 = YH102.ID"+
                                " AND RC101.A01 < '" + $.date.format(new Date($.server.currentDate().setDate($.server.currentDate().getDate() + 1)), "yyyy-MM-dd") + "'" +
                                " AND RC101.A02 >= '" + $.date.format($.server.currentDate(), "yyyy-MM-dd") + "'" +
                                " AND (RC101.A04 = '00005WT59OHT0000000000' OR RC101.A04 = '00005WT59VSE0000000000') ";
                                
        lst.beforeField = function(op, callback){
            callback();
        };
    
        lst.load(queryL, {
            layout: {
                icon: "YH101_A12",
                r0c0: "<span style='font-size:1em'>${RC101_A03MC}</span>&nbsp;&nbsp;<span style='color: #999; font-size:0.9em'>${RC102_A01}</span> ",
                r1c0: "<div style='font-size:0.9em;white-space: nowrap; overflow: hidden; text-overflow: ellipsis'>${RC101_A07}</div>",          
            }  
        });
    
        lst.afterSelect = function (op) {
            $.server.navigate('RC18', { rcid: op.data.RC101_A05, sch_type: op.data.RC101_A04, m_source: "RC16" });
        };
        
        $.server.query(queryZl, function(data){
            var buttonObj = [];
            $C.each(data.DataSource, function (key, val) {
                var obj = {};
                obj.icon = "fa fa-plus";
                obj.text = "新增" + val.RC102_A01;
                obj.color = 2;
                obj.click = function () {
                    $.server.navigate('RC17', {
                        sch_type: val.RC102_ID, 
                        sch_name: val.RC102_A01, 
                        start: $.date.parseDate($.date.format($.server.currentDate(), "yyyy-MM-dd"), 1), 
                        end: $.date.parseDate($.date.format($.server.currentDate(), "yyyy-MM-dd"), 1) 
                    });
                };
                buttonObj.push(obj);
            });
            $page.addButtons(buttonObj);
        });
    };
    
    rcCalendar.afterChange = function(op,callback){
        var lst = $("#lst").ctl();
        var start = op.data; 
        // var end = new Date(value.setDate(value.getDate() + 1)); 
        end = new Date(op.data.getTime() + 24 * 60 * 60 * 1000);
        var queryL = new $.server.queryOptions(); 
        queryL.PrimaryTable = "RC101";
        queryL.Tables = "RC102, YH101, YH102";
        queryL.FieldNameList = "RC101.*, RC102.*, YH101.A06, YH101.A12, YH102.A03";
        queryL.ConditionExpr = "RC102.ID = RC101.A04 AND RC101.A03 = '" + $.server.cache.CurrentUser.Uid + "'" +
                            " AND RC101.A03 = YH101.ID AND YH101.A06 = YH102.ID" +
                            " AND RC101.A01 < '" + $.date.format(end, "yyyy-MM-dd") + "'" +
                            " AND RC101.A02 >= '" + $.date.format(start, "yyyy-MM-dd") + "'" +
                            " AND (RC101.A04 = '00005WT59OHT0000000000' OR RC101.A04 = '00005WT59VSE0000000000') ";

        // var lst = new mListView($("#lst"));

        lst.load(queryL, {
            layout: {
                icon: "YH101_A12",
                r0c0: "<span style='font-size:1em'>${RC101_A03MC}</span>&nbsp;&nbsp;<span style='color: #999; font-size:0.9em'>${RC102_A01}</span>",
                r1c0: "<div style='font-size:0.9em;white-space: nowrap; overflow: hidden; text-overflow: ellipsis'>${RC101_A07}</div>",         
            }      
        });

        lst.afterSelect = function (op) {
            $.server.navigate('RC18', { rcid: op.data.RC101_A05, sch_type: op.data.RC101_A04, m_source: "RC16" });
        };
        
        $.server.query(queryZl, function(data){
            var buttonObj = [];
            $C.each(data.DataSource, function (key, val) {
                var obj = {};
                obj.icon = "fa fa-plus";
                obj.text = "新增" + val.RC102_A01;
                obj.color = 2;
                obj.click = function () {
                    $.server.navigate('RC17', {
                        sch_type: val.RC102_ID, 
                        sch_name: val.RC102_A01, 
                        start: start, 
                        end: start,
                    });
                };
                buttonObj.push(obj);
            });
            $page.addButtons(buttonObj);
        });
    };
    
    rcCalendar.load(query, {});
};

$page.afterRefresh = function() {
    var lst = $("#lst").ctl();
    var rcCalendar = $("#calendar").ctl();
    lst.refresh();
    rcCalendar.refresh();
};
