$page.load = function (cb) {
    var sch_type = $page.parms.sch_type || "00005WT59VSE0000000000";
    var sch_name = $page.parms.sch_name || "";
    var start = $page.parms.start || "";
    var end = $page.parms.end || "";
    var m_source = $page.parms.m_source || "";

    $page.addButtons([{
        icon: "fa fa-save",
        text: "保存",
        color: 3,
        click: function () {
            frm.save();
        }
    }]);

    var frm = new Form($("#frm"));
    //日程种类
    var queryZl = new $.server.queryOptions();
    queryZl.PrimaryTable = "RC102";
    queryZl.PrimaryKeyField = "ID";
    queryZl.FieldNameList = "*";

    $.server.query(queryZl, function (data) {
        $.each(data.DataSource, function (i, n) {

            if (n.RC102_ID == sch_type) {

                //表头
                if (n.RC102_A02 != null) {
                    var query = new $.server.queryOptions();
                    query.PrimaryTable = n.RC102_A02;
                    query.PrimaryKeyField = "ID";
                    query.FieldNameList = "*";
                    query.PageSize = 1;

                    frm.beforeField = function (op, callback) {
                        if (sch_type == "00005WT59VSE0000000000") {//日程
                            $.each(op.table.FieldList, function (k, val) {
                                if (val.ColName == "A05") {
                                    val.ColVisible = 0;
                                }
                            });
                        };

                        if (sch_type == "00005WT59OHT0000000000") {//日志
                            $.each(op.table.FieldList, function (k, val) {
                                if (val.ColName == "A07") {
                                    val.ColVisible = 0;
                                }
                            });
                        };

                        if (sch_type == "00005WT5A2DU0000000000" || sch_type == "00005XHN1YZB0000000000" || sch_type == "0000620C2TFQ0000000000") {//周计划或月计划或年计划
                            $.each(op.table.FieldList, function (k, val) {
                                if (val.ColName == "A05") {
                                    val.ColVisible = 0;
                                }
                                if (val.ColName == "A06") {
                                    val.ColVisible = 2;
                                }
                                if (val.ColName == "A02") {
                                    val.ColVisible = 2;
                                }
                            });
                        };
                        callback();
                    }

                    frm.beforeLoad = function (op, callback) {
                        //设置默认值
                        op.datas[0].set(n.RC102_A02 + "_A01", start);
                        op.datas[0].set(n.RC102_A02 + "_A02", start);
                        op.datas[0].set(n.RC102_A02 + "_A03", $.server.cache.CurrentUser.Uid);
                        op.datas[0].set(n.RC102_A02 + "_A03MC", $.server.cache.CurrentUser.UserName);
                        if (sch_type == "00005WT59VSE0000000000") { //日程
                            op.datas[0].set(n.RC102_A02 + "_A02", $.date.parseDate($.date.format(start, "yyyy-MM-dd") + " 23:59", 1));
                        };

                        if (sch_type == "00005WT59OHT0000000000") {//日志
                            var nextDate = new Date(op.datas[0][n.RC102_A02 + "_A01"].getTime() + 24 * 60 * 60 * 1000);
                            op.datas[0].set(n.RC102_A02 + "_A06", nextDate);
                        };

                        if (sch_type == "00005WT5A2DU0000000000") {//周计划
                            var monday = $.date.getWeekFirst(start);
                            var sunday = $.date.getWeekLast(start);

                            op.datas[0].set(n.RC102_A02 + "_A01", monday);
                            op.datas[0].set(n.RC102_A02 + "_A02", sunday);

                            op.datas[0].set(n.RC102_A02 + "_A06", "0001");
                            op.datas[0].set(n.RC102_A02 + "_A06MC", "未总结");

                            var queryZjh = new $C.server.queryOptions();

                            queryZjh.PrimaryTable = n.RC102_A02;
                            queryZjh.PrimaryKeyField = "ID";
                            queryZjh.FieldNameList = "*";
                            queryZjh.ConditionExpr = n.RC102_A02 + ".A03 = '" + $.server.cache.CurrentUser.Uid + "' AND " + n.RC102_A02 + ".A01 <= '" + $.date.format(sunday, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A02 >= '" + $.date.format(monday, "yyyy-MM-dd") + "'";

                            $C.server.query(queryZjh, function (data) {
                                if (data.DataSource.length > 0) {
                                    $C.util.info("您添加所在周的周计划已经存在，请重新选择日期！");
                                };
                            });
                        };

                        if (sch_type == "00005XHN1YZB0000000000") {//月计划
                            var firstday = $.date.getMonFirst(start); //当前月第一天
                            var lastday = $.date.getMonLast(start);//当前月最后一天

                            //op.datas[0][n.RC102_A02 + "_A01"] = firstday;
                            //op.datas[0][n.RC102_A02 + "_A02"] = lastday;
                            op.datas[0].set(n.RC102_A02 + "_A01", firstday);
                            op.datas[0].set(n.RC102_A02 + "_A02", lastday);

                            op.datas[0].set(n.RC102_A02 + "_A06", "0001");
                            op.datas[0].set(n.RC102_A02 + "_A06MC", "未总结");

                            var queryYjh = new $C.server.queryOptions();

                            queryYjh.PrimaryTable = n.RC102_A02;
                            queryYjh.PrimaryKeyField = "ID";
                            queryYjh.FieldNameList = "*";
                            queryYjh.ConditionExpr = n.RC102_A02 + ".A03 = '" + $.server.cache.CurrentUser.Uid + "' AND " + n.RC102_A02 + ".A01 <= '" + $.date.format(lastday, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A02 >= '" + $.date.format(firstday, "yyyy-MM-dd") + "'";

                            $C.server.query(queryYjh, function (data) {
                                if (data.DataSource.length > 0) {
                                    $C.util.info("您添加所在月的月计划已经存在，请重新选择日期！");
                                };
                            });
                        };

                        if (sch_type == "0000620C2TFQ0000000000") {//年计划
                            var firstYearDay = new Date(start.getFullYear(), 0, 1);
                            var lastYearDay = new Date(start.getFullYear(), 11, 31);

                            //op.datas[0][n.RC102_A02 + "_A01"] = firstYearDay;
                            //op.datas[0][n.RC102_A02 + "_A02"] = lastYearDay;
                            op.datas[0].set(n.RC102_A02 + "_A01", firstYearDay);
                            op.datas[0].set(n.RC102_A02 + "_A02", lastYearDay);

                            op.datas[0].set(n.RC102_A02 + "_A06", "0001");
                            op.datas[0].set(n.RC102_A02 + "_A06MC", "未总结");

                            var queryNjh = new $C.server.queryOptions();

                            queryNjh.PrimaryTable = n.RC102_A02;
                            queryNjh.PrimaryKeyField = "ID";
                            queryNjh.FieldNameList = "*";
                            queryNjh.ConditionExpr = n.RC102_A02 + ".A03 = '" + $.server.cache.CurrentUser.Uid + "' AND " + n.RC102_A02 + ".A01 <= '" + $.date.format(lastYearDay, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A02 >= '" + $.date.format(firstYearDay, "yyyy-MM-dd") + "'";

                            $C.server.query(queryNjh, function (data) {
                                if (data.DataSource.length > 0) {
                                    $C.util.info("您添加所在年的年计划已经存在，请重新选择日期！");
                                };
                            });
                        };
                        callback();
                    }

                    frm.load(query, {
                        opeMode: 1,	//操作方式：0查看,1新增，2编辑
                    });

                    frm.afterLoad = function (op, callback) {
                        if (sch_type == "00005WT59VSE0000000000") {//日程
                            frm.afterChange = function (op, callback) {
                                if (op.field == "RC202_A01") {
                                    op.data.set("RC202_A02", $.date.parseDate($.date.format(op.data.RC202_A01, "yyyy-MM-dd") + " 23:59", 1));//计划时间附值
                                };
                            };
                        };
                        if (sch_type == "00005WT59OHT0000000000") {//日志
                            frm.afterChange = function (op, callback) {
                                if (op.field == "RC201_A01") {
                                    var nextDate = new Date(op.data.RC201_A01.getTime() + 24 * 60 * 60 * 1000);
                                    op.data.set("RC201_A06", nextDate);//计划时间附值
                                    op.data.RC201_A02 = op.data.RC201_A01;//结束时间附值
                                    
                                    var lstYjh = new mListView($("#lstYjh"));
                                    loadRzPlan(n, op.data.RC201_A01, lstYjh);//动态加载日志原计划
                                };
                            };
                        };
                        if (sch_type == "00005WT5A2DU0000000000") {//周计划
                            frm.afterChange = function (op, callback) {
                                if (op.field == "RC203_A01") {
                                    var firstWeekDay = $.date.getWeekFirst(op.data.RC203_A01);
                                    var lastWeekDay = $.date.getWeekLast(op.data.RC203_A01);
                                    if ($.date.format(firstWeekDay, "yyyy-MM-dd") != $.date.format(op.data.RC203_A01, "yyyy-MM-dd")) {
                                        op.data.set("RC203_A01", firstWeekDay);//开始时间符值 
                                    };
                                    op.data.set("RC203_A02", lastWeekDay);//结束时间符值 
                                
                                    var lstYjh = new mListView($("#lstYjh"));
                                    loadZjhPlan(n, op.data.RC203_A01, lstYjh);//动态加载日志原计划
                                };
                            };
                        };
                        if (sch_type == "00005XHN1YZB0000000000") {//月计划
                            frm.afterChange = function (op, callback) {
                                if (op.field == "RC204_A01") {
                                    var firstMonDay = $.date.getMonFirst(op.data.RC204_A01);
                                    var lastMonDay = $.date.getMonLast(op.data.RC204_A01);
                                    if ($.date.format(firstMonDay, "yyyy-MM-dd") != $.date.format(op.data.RC204_A01, "yyyy-MM-dd")) {
                                        op.data.set("RC204_A01", firstMonDay);//开始时间符值 
                                    };
                                    op.data.set("RC204_A02", lastMonDay);//结束时间符值 
                                    
                                    var lstYjh = new mListView($("#lstYjh"));
                                    loadYjhPlan(n, op.data.RC204_A01, lstYjh);//动态加载日志原计划
                                };
                            };
                        };
                        if (sch_type == "0000620C2TFQ0000000000") {//年计划
                            frm.afterChange = function (op, callback) {
                                if (op.field == "RC205_A01") {
                                    var firstYearDay = new Date(op.data.RC205_A01.getFullYear(), 0, 1);
                                    var lastYearDay = new Date(op.data.RC205_A01.getFullYear(), 11, 31);
                                    
                                    if ($.date.format(firstYearDay, "yyyy-MM-dd") != $.date.format(op.data.RC205_A01, "yyyy-MM-dd")) {
                                        op.data.set("RC205_A01", firstYearDay);//开始时间符值 
                                    };
                                    op.data.set("RC205_A02", lastYearDay);//结束时间符值 
                                    
                                    var lstYjh = new mListView($("#lstYjh"));
                                    loadNjhPlan(n, op.data.RC205_A01, lstYjh);//动态加载日志原计划
                                };
                            };
                        };
                    };

                    frm.beforeSave = function (op, callback) {
                        if (sch_type == "00005WT59OHT0000000000") {//日志
                            op.datas[0][n.RC102_A02 + "_A02"] = op.datas[0][n.RC102_A02 + "_A01"];
                        };
                        if (op.datas[0][n.RC102_A02 + "_A01"] > op.datas[0][n.RC102_A02 + "_A02"]) {
                            $.util.error("开始时间不能大于结束时间！");
                            return false;
                        } else {
                            if (sch_type == "00005WT59OHT0000000000") {//日志
                                var qRz = new $.server.queryOptions();
                                qRz.PrimaryTable = "RC101";
                                qRz.PrimaryKeyField = "ID";
                                qRz.FieldNameList = "*";
                                qRz.ConditionExpr = " RC101.A03 = '" + $.server.cache.CurrentUser.Uid + "' AND RC101.A04 = '00005WT59OHT0000000000' AND RC101.A01 = '" + $.date.format(op.datas[0][n.RC102_A02 + "_A01"], "yyyy-MM-dd") + "'  ";
                                $.server.query(qRz, function (data) {
                                    if (data.DataSource.length > 0) {
                                        $.util.info("当天日志已经存在！不能重复添加！");
                                        return false;
                                    } else {
                                        var NrDataSource = frmNr.getDataSource(); 
                                        if (op.datas[0][n.RC102_A02 + "_A07"] == null) {
                                            op.datas[0][n.RC102_A02 + "_A07"] = NrDataSource[n.RC102_A04 + "_A02"];
                                        } else {
                                            if (val[n.RC102_A04 + "_A02"] != null) {
                                                op.datas[0][n.RC102_A02 + "_A07"] += "\r\n" + NrDataSource[n.RC102_A04 + "_A02"];
                                            }
                                        }
                                        callback();
                                    }
                                });
                            } else if (sch_type == "00005WT59VSE0000000000"){//日程
                                var NrDataSource = frmNr.getDataSource();
                                if (op.datas[0][n.RC102_A02 + "_A05"] == null) {
                                    op.datas[0][n.RC102_A02 + "_A05"] = NrDataSource[n.RC102_A04 + "_A02"];
                                } else {
                                    if (val[n.RC102_A04 + "_A02"] != null) {
                                        op.datas[0][n.RC102_A02 + "_A05"] += "\r\n" + NrDataSource[n.RC102_A04 + "_A02"];
                                    }
                                };
                                
                                callback();
                            }else if (n.RC102_ID == "00005WT5A2DU0000000000") {//周计划
                                var monday = $.date.getWeekFirst(op.datas[0][n.RC102_A02 + "_A01"]);
                                var sunday = $.date.getWeekLast(op.datas[0][n.RC102_A02 + "_A01"]);

                                var queryZjh = new $.server.queryOptions();

                                queryZjh.PrimaryTable = n.RC102_A02;
                                queryZjh.PrimaryKeyField = "ID";
                                queryZjh.FieldNameList = "*";
                                queryZjh.ConditionExpr = n.RC102_A02 + ".A03 = '" + $.server.cache.CurrentUser.Uid + "' AND " + n.RC102_A02 + ".A01 <= '" + $.date.format(sunday, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A02 >= '" + $.date.format(monday, "yyyy-MM-dd") + "'";

                                $C.server.query(queryZjh, function (data) {
                                    if (data.DataSource.length > 0) {
                                        $C.util.info("您添加所在周的周计划已经存在，不能重复添加！");
                                        return false;
                                    } else {
                                        var JhDataSource = frmJh.getDataSource();
                                        if (op.datas[0][n.RC102_A02 + "_A05"] == null) {
                                            op.datas[0][n.RC102_A02 + "_A05"] = JhDataSource[n.RC102_A03 + "_A02"];
                                        } else {
                                            if (val[n.RC102_A03 + "_A02"]) {
                                                op.datas[0][n.RC102_A02 + "_A05"] += "\r\n" + JhDataSource[n.RC102_A03 + "_A02"];
                                            }
                                        }
        
                                        var NrDataSource = frmNr.getDataSource(); 
        
                                        if (NrDataSource[n.RC102_A04 + "_A02"] != null) {
                                            op.datas[0][n.RC102_A02 + "_A06"] = '0002';
                                        } else {
                                            op.datas[0][n.RC102_A02 + "_A06"] = '0001';
                                        };

                                        callback();
                                    };
                                });
                            } else if (n.RC102_ID == "00005XHN1YZB0000000000") {//月计划
                                var firstday = $.date.getMonFirst(op.datas[0][n.RC102_A02 + "_A01"]); //当前月第一天
                                var lastday = $.date.getMonLast(op.datas[0][n.RC102_A02 + "_A01"]);//当前月最后一天

                                var queryYjh = new $C.server.queryOptions();

                                queryYjh.PrimaryTable = n.RC102_A02;
                                queryYjh.PrimaryKeyField = "ID";
                                queryYjh.FieldNameList = "*";
                                queryYjh.ConditionExpr = n.RC102_A02 + ".A03 = '" + $.server.cache.CurrentUser.Uid + "' AND " + n.RC102_A02 + ".A01 <= '" + $.date.format(lastday, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A02 >= '" + $.date.format(firstday, "yyyy-MM-dd") + "'";

                                $C.server.query(queryYjh, function (data) {
                                    if (data.DataSource.length > 0) {
                                        $C.util.info("您添加所在月的月计划已经存在，不能重复添加！");
                                        return false;
                                    } else {
                                        ///月计划周计划计划给表头计划
                                        var JhDataSource = frmJh.getDataSource();
                                        if (op.datas[0][n.RC102_A02 + "_A05"] == null) {
                                            op.datas[0][n.RC102_A02 + "_A05"] = JhDataSource[n.RC102_A03 + "_A02"];
                                        } else {
                                            if (val[n.RC102_A03 + "_A02"]) {
                                                op.datas[0][n.RC102_A02 + "_A05"] += "\r\n" + JhDataSource[n.RC102_A03 + "_A02"];
                                            }
                                        }
    
                                        var NrDataSource = frmNr.getDataSource(); 
    
                                        if (NrDataSource[n.RC102_A04 + "_A02"] != null) {
                                            op.datas[0][n.RC102_A02 + "_A06"] = '0002';
                                        } else {
                                            op.datas[0][n.RC102_A02 + "_A06"] = '0001';
                                        };
                                        
                                        callback();
                                    };
                                });
                            } else if (n.RC102_ID == "0000620C2TFQ0000000000") {//年计划
                                var firstYearDay = new Date(op.datas[0][n.RC102_A02 + "_A01"].getFullYear(), 0, 1);
                                var lastYearDay = new Date(op.datas[0][n.RC102_A02 + "_A01"].getFullYear(), 11, 31);

                                var queryNjh = new $C.server.queryOptions();

                                queryNjh.PrimaryTable = n.RC102_A02;
                                queryNjh.PrimaryKeyField = "ID";
                                queryNjh.FieldNameList = "*";
                                queryNjh.ConditionExpr = n.RC102_A02 + ".A03 = '" + $.server.cache.CurrentUser.Uid + "' AND " + n.RC102_A02 + ".A01 <= '" + $.date.format(lastYearDay, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A02 >= '" + $.date.format(firstYearDay, "yyyy-MM-dd") + "'";

                                $C.server.query(queryNjh, function (data) {
                                    if (data.DataSource.length > 0) {
                                        $C.util.info("您添加所在年的年计划已经存在，不能重复添加！");
                                        return false;
                                    } else {
                                        ///年计划计划给表头计划
                                        var JhDataSource = frmJh.getDataSource();
                                        if (op.datas[0][n.RC102_A02 + "_A05"] == null) {
                                            op.datas[0][n.RC102_A02 + "_A05"] = JhDataSource[n.RC102_A03 + "_A02"];
                                        } else {
                                            if (val[n.RC102_A03 + "_A02"]) {
                                                op.datas[0][n.RC102_A02 + "_A05"] += "\r\n" + JhDataSource[n.RC102_A03 + "_A02"];
                                            }
                                        }
    
                                        var NrDataSource = frmNr.getDataSource(); 
    
                                        if (NrDataSource[n.RC102_A04 + "_A02"] != null) {
                                            op.datas[0][n.RC102_A02 + "_A06"] = '0002';
                                        } else {
                                            op.datas[0][n.RC102_A02 + "_A06"] = '0001';
                                        };

                                        callback();
                                    };
                                });
                            };
                        };
                    };

                    frm.afterSave = function (op, callback) {
                        var is_end = 0;
                        if (n.RC102_A04 != null) {
                            is_end++;
                        };

                        if (n.RC102_A03 != null) {
                            is_end++;
                        };

                        if (n.RC102_A06 != null) {
                            is_end++;
                        };

                        if (n.RC102_A04 != null) {
                            frmNr.beforeSave = function (opNr, callback) {
                                if (opNr.datas[0][n.RC102_A04 + "_A02"] != null) {
                                    opNr.datas[0][n.RC102_A04 + "_A01"] = op.data[0];
                                    callback();
                                } else {
                                    is_end--;
                                    if (is_end == 0) {
                                        $.util.info("保存成功！");
                                        $page.close(1);
                                    };
                                };
                            };

                            frmNr.save();

                            frmNr.afterSave = function (opNr, callback) {
                                is_end--;
                                if (is_end == 0) {
                                    $.util.info("保存成功！");
                                    $page.close(1);
                                };
                            };
                        };

                        if (n.RC102_A03 != null) {
                            frmJh.beforeSave = function (opJh, callback) {
                                if (opJh.datas[0][n.RC102_A03 + "_A02"] != null) {
                                    opJh.datas[0][n.RC102_A03 + "_A01"] = op.data[0];
                                    callback();
                                } else {
                                    is_end--;
                                    if (is_end == 0) {
                                        $.util.info("保存成功！");
                                        $page.close(1);
                                    };
                                };
                            };

                            frmJh.save();

                            frmJh.afterSave = function (opJh, callback) {
                                is_end--;
                                if (is_end == 0) {
                                    $.util.info("保存成功！");
                                    $page.close(1);
                                };
                            };
                        };

                        if (n.RC102_A06 != null) {
                            frmJy.beforeSave = function (opJy, callback) {
                                if (opJy.datas[0][n.RC102_A06 + "_A02"] != null) {
                                    opJy.datas[0][n.RC102_A06 + "_A01"] = op.data[0];
                                    callback();
                                } else {
                                    is_end--;
                                    if (is_end == 0) {
                                        $.util.info("保存成功！");
                                        $page.close(1);
                                    };
                                };
                            };

                            frmJy.save();

                            frmJy.afterSave = function (opJy, callback) {
                                is_end--;
                                if (is_end == 0) {
                                    $.util.info("保存成功！");
                                    $page.close(1);
                                };
                            };
                        };
                    };
                };
                
                //绑定原计划
                if (n.RC102_ID == "00005WT59OHT0000000000") {//日志
                    $("#frmYjh").show();
                    var lstYjh = new mListView($("#lstYjh"));
                    loadRzPlan(n, start, lstYjh);//动态加载日志原计划
                }else if(n.RC102_ID == "00005WT5A2DU0000000000"){//周计划
                    $("#frmYjh").show();
                    var lstYjh = new mListView($("#lstYjh"));
                    loadZjhPlan(n, start, lstYjh);//动态加载周计划原计划
                }else if(n.RC102_ID == "00005XHN1YZB0000000000"){//月计划
                    $("#frmYjh").show();
                    var lstYjh = new mListView($("#lstYjh"));
                    loadYjhPlan(n, start, lstYjh);//动态加载月计划原计划
                }else if (n.RC102_ID == "0000620C2TFQ0000000000") {
                    $("#frmYjh").show();
                    var lstYjh = new mListView($("#lstYjh"));
                    loadNjhPlan(n, start, lstYjh);//动态加载年计划原计划
                };

                ///内容
                if (n.RC102_A04 != null) {
                    var frmNr = new Form($("#frmNr"));

                    var queryNr = new $.server.queryOptions();
                    queryNr.PrimaryTable = n.RC102_A04;
                    queryNr.PrimaryKeyField = "ID";
                    queryNr.FieldNameList = "*";
                    queryNr.PageSize = 1;

                    frmNr.load(queryNr, {
                        opeMode: 1,	//操作方式：0查看,1新增，2编辑
                    });
                };

                //计划
                if (n.RC102_A03 != null) {
                    var frmJh = new Form($("#frmJh"));

                    var queryJh = new $.server.queryOptions();
                    queryJh.PrimaryTable = n.RC102_A03;
                    queryJh.PrimaryKeyField = "ID";
                    queryJh.FieldNameList = "*";
                    queryJh.PageSize = 1;

                    frmJh.load(queryJh, {
                        opeMode: 1,	//操作方式：0查看,1新增，2编辑
                    });
                };

                ///经验
                if (n.RC102_A06 != null) {
                    var frmJy = new Form($("#frmJy"));

                    var queryJy = new $.server.queryOptions();
                    queryJy.PrimaryTable = n.RC102_A06;
                    queryJy.PrimaryKeyField = "ID";
                    queryJy.FieldNameList = "*";
                    queryJy.PageSize = 1;

                    frmJy.load(queryJy, {
                        opeMode: 1,	//操作方式：0查看,1新增，2编辑
                    });
                };
            };
        });
    });
};

///日志原计划
function loadRzPlan(n, date, lstYjh) {
    queryOld = new $C.server.queryOptions();
    
    queryOld.PrimaryTable = n.RC102_A03;
    queryOld.Tables = n.RC102_A02;
    queryOld.FieldNameList = n.RC102_A03 + ".*";
    queryOld.ConditionExpr = n.RC102_A03 + ".A01 = " + n.RC102_A02 + ".ID AND " + n.RC102_A02 + ".A06 = '" + $.date.format(date, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A03 = '" + $.server.cache.CurrentUser.Uid + "'";
    queryOld.OrderExpr = n.RC102_A03 + ".ID ASC";
    
    $C.server.query(queryOld, function (data) {
        //console.log(data);
        queryOldRc = new $C.server.queryOptions();
        queryOldRc.PrimaryTable = "RC302";
        queryOldRc.Tables = "RC202";
        queryOldRc.FieldNameList = "RC302.*";
        queryOldRc.ConditionExpr = "RC302.A01 = RC202.ID AND RC202.A01 <= '" + $C.date.format(date, "yyyy-MM-dd") + "' AND RC202.A02 >= '" + $C.date.format(date, "yyyy-MM-dd") + "' AND RC202.A03 = '" + $C.server.cache.CurrentUser.Uid + "'";
        queryOldRc.OrderExpr = "RC302.ID ASC";

        $C.server.query(queryOldRc, function (d) {
            $C.each(d.DataSource, function (k, v) {
                var arr = {};
                arr["RC401_A02"] = v.RC302_A02;
                data.DataSource.push(arr);
            });
            
            
            lstYjh.beforeField = function (op, callback) {
                $C.each(op.table.FieldList, function (k, val) {
                    if (val.ColName == "A02") {
                        val.DisplayLabel = "原计划";
                    }
                });
                
                $.each(op.data, function(key, val){
                    if(val[n.RC102_A03 + "_A02"].indexOf("\n") > -1){
                        val[n.RC102_A03 + "_A02"]=val[n.RC102_A03 + "_A02"].replaceAll("\n","<br>");
                    };
                });
                        
                callback();
            };
            
            lstYjh.afterLoad = function(op,callback){
                $($("#lstYjh").find(".line1").find("div")).each(function(key){
                    $(this).html($(this).html().replaceAll("&lt;br&gt;","\r\n"));
                });
            };
            
            lstYjh.bind(data, {
                enableBounce : false,
                layout: {
                    //icon: "fa-list-alt",
                    r0c0: "<div style='font-size:0.9em;height:100%; word-wrap:break-word; white-space:pre-wrap;'>${RC401_A02}</div>",
                }
            });
        });
    });
};

///周计划原计划
function loadZjhPlan(n, date, lstYjh) {
    var OldDay = new Date(date.getTime() - 7 * 24 * 60 * 60 * 1000);
    var monday = $.date.getWeekFirst(OldDay);
    var sunday = $.date.getWeekLast(OldDay);
    queryOld = new $.server.queryOptions();
    queryOld.PrimaryTable = n.RC102_A03;
    queryOld.Tables = n.RC102_A02;
    queryOld.FieldNameList = n.RC102_A03 + ".*";
    queryOld.ConditionExpr = n.RC102_A03 + ".A01 = " + n.RC102_A02 + ".ID AND " + n.RC102_A02 + ".A01 >= '" + $.date.format(monday, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A02 <= '" + $.date.format(sunday, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A03 = '" + $.server.cache.CurrentUser.Uid + "'";
    queryOld.OrderExpr = n.RC102_A03 + ".ID ASC";

    lstYjh.beforeField = function (opOld, callback) {
        //console.log(op.table.FieldList);
        $C.each(opOld.table.FieldList, function (k, val) {
            if (val.ColName == "A02") {
                val.DisplayLabel = "原计划";
            }
        });
        
        $.each(opOld.data, function(key, val){
            if(val[n.RC102_A03 + "_A02"].indexOf("\n") > -1){
                val[n.RC102_A03 + "_A02"]=val[n.RC102_A03 + "_A02"].replaceAll("\n","<br>");
            };
        });
        
        callback();
    }
    
    lstYjh.afterLoad = function(opOld,callback){
        $($("#lstYjh").find(".line1").find("div")).each(function(key){
            $(this).html($(this).html().replaceAll("&lt;br&gt;","\r\n"));
        });
    };

    lstYjh.load(queryOld, {
        enableBounce : false,
        layout: {
            //icon: "fa-list-alt",
            r0c0: "<div style='font-size:0.9em;height:100%; word-wrap:break-word; white-space:pre-wrap;'>${" + n.RC102_A03 + "_A02}</div>",
        }
    });
};

///动态加载月计划原计划
function loadYjhPlan(n, date, lstYjh) {
    if (date.getMonth() == 0) {
        var OldDate = new Date(date.getFullYear() - 1, 11, 1);
    } else {
        var OldDate = new Date(date.getFullYear(), date.getMonth() - 1, 1);
    };
    queryOld = new $C.server.queryOptions();
    queryOld.PrimaryTable = n.RC102_A03;
    queryOld.Tables = n.RC102_A02;
    queryOld.FieldNameList = n.RC102_A03 + ".*";
    queryOld.ConditionExpr = n.RC102_A03 + ".A01 = " + n.RC102_A02 + ".ID AND " + n.RC102_A02 + ".A01 <= '" + $.date.format(OldDate, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A02 >= '" + $.date.format(OldDate, "yyyy-MM-dd") + "' AND " + n.RC102_A02 + ".A03 = '" + $C.server.cache.CurrentUser.Uid + "'";
    queryOld.OrderExpr = n.RC102_A03 + ".ID ASC";

    lstYjh.beforeField = function (opOld, callback) {
        //console.log(op.table.FieldList);
        $C.each(opOld.table.FieldList, function (k, val) {
            if (val.ColName == "A02") {
                val.DisplayLabel = "原计划";
            }
        });
        
        $.each(opOld.data, function(key, val){
            if(val[n.RC102_A03 + "_A02"].indexOf("\n") > -1){
                val[n.RC102_A03 + "_A02"]=val[n.RC102_A03 + "_A02"].replaceAll("\n","<br>");
            };
        });
        
        callback();
    }
    
    lstYjh.afterLoad = function(opOld,callback){
        $($("#lstYjh").find(".line1").find("div")).each(function(key){
            $(this).html($(this).html().replaceAll("&lt;br&gt;","\r\n"));
        });
    };

    lstYjh.load(queryOld, {
        enableBounce : false,
        layout: {
            //icon: "fa-list-alt",
            r0c0: "<div style='font-size:0.9em;height:100%; word-wrap:break-word; white-space:pre-wrap;'>${" + n.RC102_A03 + "_A02}</div>",
        }
    });
};

///动态加载年计划原计划
function loadNjhPlan(n, date, lstYjh) {
    var oldYear = date.getFullYear() - 1;
    queryOld = new $C.server.queryOptions();
    queryOld.PrimaryTable = n.RC102_A03;
    queryOld.Tables = n.RC102_A02;
    queryOld.FieldNameList = n.RC102_A03 + ".*";
    queryOld.ConditionExpr = n.RC102_A03 + ".A01 = " + n.RC102_A02 + ".ID AND " + n.RC102_A02 + ".A01 = '" + oldYear + "' AND " + n.RC102_A02 + ".A03 = '" + $C.server.cache.CurrentUser.Uid + "'";
    queryOld.OrderExpr = n.RC102_A03 + ".ID ASC";

    lstYjh.beforeField = function (opOld, callback) {
        //console.log(op.table.FieldList);
        $C.each(opOld.table.FieldList, function (k, val) {
            if (val.ColName == "A02") {
                val.DisplayLabel = "原计划";
            }
        });
        
        $.each(opOld.data, function(key, val){
            if(val[n.RC102_A03 + "_A02"].indexOf("\n") > -1){
                val[n.RC102_A03 + "_A02"]=val[n.RC102_A03 + "_A02"].replaceAll("\n","<br>");
            };
        });
        
        callback();
    }
    
    lstYjh.afterLoad = function(opOld,callback){
        $($("#lstYjh").find(".line1").find("div")).each(function(key){
            $(this).html($(this).html().replaceAll("&lt;br&gt;","\r\n"));
        });
    };

    lstYjh.load(queryOld, {
        enableBounce : false,
        layout: {
            //icon: "fa-list-alt",
            r0c0: "<div style='font-size:0.9em;height:100%; word-wrap:break-word; white-space:pre-wrap;'>${" + n.RC102_A03 + "_A02}</div>",
        }
    });
};
