require.config({
    baseUrl : "../",
    map : {
        '*' : {
            'css' : 'mobiles/frame/css.min'
        }
    },
    paths : {
        "jquery" : "src/jquery/js/jquery", 
        "jquery-ui" : "src/jquery/js/jquery-ui.min",
        "jquery.cookie" : "src/jquery/js/jquery.cookie",
        "jquery-json" : "src/jquery/js/jquery.json-v2.5.1",
        "jquery-tmpl" : "src/jquery/js/jquery.tmpl.min",
        "placeholder" : "src/jquery/js/placeholder.min",
        "flextext" : "src/jquery/js/jquery.flexText",
        "jquery-scrollbar" : "src/jquery/js/jquery-scrollbar.min",
        "bootstrap" : "src/beyondadmin/js/bootstrap.min",
        "skins" : "src/beyondadmin/js/skins.min",
        "beyond" : "src/beyondadmin/js/beyond.min",
        "underscore" : "mobiles/appcan/js/underscore.min",
        "backbone" : "mobiles/appcan/js/backbone.min",
        "appcan" : "mobiles/appcan/js/appcan",
        "appcan.control" : "mobiles/appcan/js/appcan.control",
        "appcan.listview" : "mobiles/appcan/js/appcan.listview",
        "appcan.optionList" : "mobiles/appcan/js/appcan.optionList",
        "appcan.slider" : "mobiles/appcan/js/appcan.slider",
        "appcan.tab" : "mobiles/appcan/js/appcan.tab",
        "appcan.treeview" : "mobiles/appcan/js/appcan.treeview",
        "kendo.core" : "src/kendo/js/kendo.core",
        "kendo.data" : "src/kendo/js/kendo.data",
        "kendo.data.odata" : "src/kendo/js/kendo.data.odata",
        "kendo.data.xml" : "src/kendo/js/kendo.data.xml",
        "kendo.validator" : "src/kendo/js/kendo.validator",
        "kendo.binder" : "src/kendo/js/kendo.binder",
        "kendo.calendar" : "src/kendo/js/kendo.calendar",
        "kendomsg" : "src/kendo/js/messages/kendo.messages.zh-CN.min",
        "kendocul" : "src/kendo/js/cultures/kendo.culture.zh-CN.min",
        "util" : "src/base/js/Util",
        "form" : "src/base/js/Form",
        "grid" : "src/base/js/Grid2",
        "dialog" : "mobiles/frame/js/DialogWindow",
        "download" : "src/base/js/Download",
        "lookup" : "src/base/js/Lookup",
        "lookupGrid" : "mobiles/frame/js/lookupGrid",
        "MyCalendar" : "src/base/js/MyCalendar",
        "photo" : "mobiles/frame/js/Photo",
        "upload" : "mobiles/frame/js/Upload",
        "doc" : "mobiles/frame/js/Doc",
        "gaode" : "src/base/gaode",
        "map" : "mobiles/frame/js/map",
        "mListView" : "mobiles/frame/js/mListView",
        "mutil" : "mobiles/frame/js/mutil",
        "gr": "config"
    },
    shim : {
        'jquery' : ['css!mobiles/appcan/css/appcan.icon.css', 'css!mobiles/appcan/css/appcan.control.css', 'css!mobiles/frame/css/index.css', 'css!src/jquery/css/flexText.css'],

        //<link href="src/beyondadmin/css/font-awesome.min.css" rel="stylesheet" />
        //<link href="src/beyondadmin/css/weather-icons.min.css" rel="stylesheet" />
        //<link id="beyond-link" href="src/beyondadmin/css/beyond.min.css" rel="stylesheet" type="text/css" />
        //<link href="src/beyondadmin/css/demo.min.css" rel="stylesheet" />
        //<link href="src/beyondadmin/css/typicons.min.css" rel="stylesheet" />
        //<link href="src/beyondadmin/css/animate.min.css" rel="stylesheet" />
        //<link id="skin-link" href="" rel="stylesheet" type="text/css" />
        //<link href="src/index/css/index.css" rel="stylesheet" />

        //<!--<link href="src/bootstrap/css/bootstrap.css" rel="stylesheet" />-->
        //<link href="src/kendo/css/kendo.rtl.min.css" rel="stylesheet">
        //<link href="Viewssrc/baiduMap/baiduMap.css" rel="stylesheet" />
        //<link href="src/jquery/smartMenu.css" rel="stylesheet" />
        //<link rel="stylesheet" href="http://api.map.baidu.com/library/SearchControl/1.4/src/SearchControl_min.css" />
        //<link rel="stylesheet" href="http://cache.amap.com/lbs/static/main1119.css" />
        'jquery-ui' : ['jquery'
        , 'css!src/kendo/css/kendo.common-material.core.min.css'
        , 'css!src/kendo/css/kendo.material.min.css'
        , 'css!src/kendo/css/kendo.material.mobile.min.css'
        , 'css!mobiles/frame/css/gr-icon.css'
        ],
        "jquery.cookie" : ['jquery'],
        "jquery-json" : ['jquery'],
        "jquery-tmpl" : ['jquery'],
        "jquery.slimscroll" : ['jquery'],
        "flextext": ['jquery'],
        "jquery-scrollbar" : ['jquery'],
        'backbone' : ['underscore'],
        'appcan' : ['jquery', 'backbone'],
        'appcan.control' : ['appcan'],
        'appcan.listview' : ['appcan.control'],
        'appcan.optionList' : ['appcan.control'],
        'appcan.slider' : ['appcan.control'],
        'appcan.tab' : ['appcan.control'],
        'appcan.treeview' : ['appcan.control'],
        'kendo.core' : ['jquery'],
        'kendo.validator' : ['kendo.core'],
        'kendo.data.xml' : ['kendo.core'],
        'kendo.data.odata' : ['kendo.core'],
        'kendo.data' : ['kendo.data.xml','kendo.data.odata'],
        'kendo.binder' : ['kendo.data.odata'],
        'kendo.calendar' : ['kendo.core'],
        'kendomsg' : ['kendo.core'],
        'kendocul' : ['kendo.core'],
        "util" : ['jquery'],
        "dialog" : ['util'],
        "form" : ['util', "dialog","kendo.binder","kendo.validator"],
        "lookup" : ['util'],
        "lookupGrid" : ['util', 'lookup', "dialog", "mListView"],
        "MyCalendar" : ['util'],
        "photo" : ['util'],
        "upload" : ['util'],
        "doc" : ['upload'],
        "mutil" : ['jquery', 'util', 'appcan'],
        "mListView" : ['mutil', 'appcan.listview'],
        "gaode" : ["jquery"],
        "map" : ["jquery"],
        "gr" : ["jquery", "jquery-ui", "jquery.cookie", "jquery-json", "jquery-tmpl", "appcan", "appcan.control", "appcan.listview", "appcan.optionList", "appcan.slider", "appcan.tab", "appcan.treeview", "kendo.calendar", "util", "form", "dialog", "lookup", "lookupGrid", "MyCalendar", "photo", "upload", "doc", "mutil", "mListView", "map","kendomsg","kendocul"]
    },
});

require(['gr'], function(f) {
    $.server.initData(0, function() {
        kendo.culture("zh-CN");
        window_load();
    });
});
