function DialogWindow(options) {
    var _that = this;
    this._options = $.extend({
        title: "请选择",
        beforeClose: null,
        afterClose: null
    }, options);
    this._id = $.util.guid();
    this._$that = $('<div id="' + this._id + '" class="cd-user-modal is-visible"></div>');
    
    if($('body').find('.cd-user-modal').length == 0){
        _that._$that.appendTo($('body'));
        _that._notExists = 1;
    }
    
    _that._$that.hide();
    this._dialog = null;

    this._init = function () {
        var html = [];
        html.push('<div class="cd-user-modal-container">');
        html.push('<div class="ub ub-ac bc-head">');
        html.push('<div class="nav-btn dialog-cancel">');
        html.push('<div class="umw1 umh1 ub-img img-cancel"></div>');
        html.push('</div>');
        html.push('<div class=" tx-c bc-text ub-f1">' + _that._options.title + '</div>');
        html.push('<div class="nav-btn dialog-ok">');
        html.push('<div class="umw1 umh1 ub-img img-ok"></div>');
        html.push('</div>');
        html.push('</div>');
        html.push('<div class="dialog-content">');
        html.push('</div>');
        html.push('<div style="padding:'+$.mobile.bottom() * 0.5+'px"></div>');
        html.push('</div>');
        _that._$that.append($.util.join("", html));
        $(".dialog-ok", _that._$that).click(function () {
            _that._close(true);
            return false;
        });
        $(".dialog-cancel", _that._$that).click(function () {
            _that._close(false);
            return false;
        });
        return $(".dialog-content", _that._$that);
    }

    this.getContent = function () {
        return this._$content;
    };

    this.open = function () {
        if(_that._notExists){
            $('input,textarea').blur();
            _that._$that.show();
        }
    }
    
    this._close = function (ret){
        var isClose = true;
        if ($.isFunction(_that._options.beforeClose)) {
            isClose = _that._options.beforeClose(false, function (ret) {
                if (ret !== false)
                    _that.close(ret);
            });
        }
        if (isClose !== false) {
            _that.close(ret);
        }
    }

    this.close = function (ret) {
        setTimeout(function () {
            _that._$that.remove();
            if ($.isFunction(_that._options.afterClose)) {
                options.afterClose(ret);
            }
        }, 200);
    }

    this.addContent = function ($content) {
        $content.appendTo(_that._$content);
        return this;
    }

    this._$content = _that._init();

}
