function mListView($this) {
    var _that = this;
    this._$that = $this;
    this._selector = this._$that.selector + " .grid";
    this._$that.data("ctrl", _that);
    this._$that.empty();
    this._$grd = null;
    this._lst = null;
    this._frm = null;
    this._init = 0;
    this._loading = false;
    this._options = {
        enableBounce : true,
        enableFilter : true,
        layout : {
            icon : null,
            r0c0 : null,
            r0c1 : null,
            r1c0 : null,
            r1c1 : null,
            r2c0 : null,
            r2c1 : null
        },
        isNavigate : true
    };
    this._query = null;
    this._table = null;
    this._data = null;
    this._total = 0;

    this._parseData = function(data) {
        var list = [];
        if (_that._options.layout.group) {

        }
        $(data).each(function() {
            var group = null;
            if (_that._options.layout.group) {
                var groupTitle = $($.tmpl('<div>' + _that._options.layout.group + '</div>', this)[0]).html();
                for (var i = 0; i < list.length; i++) {
                    if (list[i].title == groupTitle) {
                        group = list[i];
                        break;
                    }
                }
                if (group == null) {
                    group = {
                        title : groupTitle,
                        groupId : $.util.guid(),
                        items : []
                    }
                    list.push(group);
                }
            }
            var d = {
                data : this
            };
            if (_that._options.layout.icon) {
                d.icon = $.mobile.imgUrl(this[_that._options.layout.icon]);
            }
            if (_that._options.layout.r0c0) {
                d.title = $($.tmpl('<div>' + _that._options.layout.r0c0 + '</div>', this)[0]).html();
            }
            if (_that._options.layout.r1c0) {
                d.describe = $($.tmpl('<div>' + _that._options.layout.r1c0 + '</div>', this)[0]).html();
            }
            if (_that._options.layout.r2c0) {
                d.note = $($.tmpl('<div>' + _that._options.layout.r2c0 + '</div>', this)[0]).html();
            }
            if (_that._options.layout.r0c1) {
                d.subTitle = $($.tmpl('<div>' + _that._options.layout.r0c1 + '</div>', this)[0]).html();
            }
            if (_that._options.layout.r1c1) {
                d.subDescribe = $($.tmpl('<div>' + _that._options.layout.r1c1 + '</div>', this)[0]).html();
            }
            if (_that._options.layout.r2c1) {
                d.subNote = $($.tmpl('<div>' + _that._options.layout.r2c1 + '</div>', this)[0]).html();
            }
            if (group != null) {
                group.items.push(d);
            } else {
                list.push(d);
            }
        });
        return list;
    }

    this._iconRegister = function() {
        $(_that._$that.find('.ub-img')).each(function() {
            if ($(this).hasClass('lis-icon') && !$(this).hasClass('list-btn')) {
                $(this).addClass('list-btn');
            }
        });
        $.mobile.click(_that._selector + ' .list-btn:not(.list-btn-reg)', function(sender) {
            if ($(sender).hasClass('ub-img')) {
                var url = $(sender).css('background-image').replaceAll('"','');
                if (url.length > 0) {
                    url = url.substr(4, url.length - 5).split('?')[0];           
                    var daparms = {
                        enableGrid:false,
                        data : [{
                            src : url
                        }]
                    }
                    var jon = JSON.stringify(daparms);
                    uexImage.openBrowser(jon);
                }
                return;
            }
            $.util.trigger(_that.afterCommand, {
                target : sender,
                data : _that._selData
            });
        });
        _that._$that.find('.list-btn:not(.list-btn-reg)').addClass('list-btn-reg');
    }
    ///列生成前事件
    this.beforeField = $.util.defaultEvent;
    ///绑定前事件
    this.beforeLoad = $.util.defaultEvent;
    ///绑定后事件
    this.afterLoad = $.util.defaultEvent;
    ///选中后事件
    this.afterSelect = $.util.defaultEvent;
    ///命令点击后事件
    this.afterCommand = $.util.defaultEvent;
    ///删除后事件
    this.afterDel = $.util.defaultEvent;

    ///数据加载
    this.load = function(q, options) {
        _that._query = $.extend(new $.server.queryOptions(), q);
        _that._options = $.extend(_that._options, options);
        if (_that._query != null && _that._query.PageSize == 10000) {
            _that._
        }
        var q = $.extend(new $.server.queryOptions(), _that._query);
        if (_that._filter) {
            if (q.ConditionExpr.length == 0) {
                q.ConditionExpr = '1=1';
            }
            q.ConditionExpr = "(" + q.ConditionExpr + ") AND (" + _that._filter + ")"
        }
        $.server.query(q, function(data) {
            _that.bind(data, _that._options);
        }, _that._options.isCache);
    }
    ///数据绑定
    this.bind = function(data, options) {
        _that._init = 0;
        // 避免重复查询 zxilu 2015-10-02
        if (_that._$grd != null) {
            _that._$grd.remove();
        }

        _that._options = $.extend({
        }, options);

        _that._$grd = $("<div class='grid'></div>");
        _that._$grd.appendTo(_that._$that);

        _that._table = data.Table;
        _that._data = data.DataSource;
        _that._total = data.Total;
        $.util.trigger(_that.beforeField, {
            table : _that._table,
            data : _that._data
        }, function() {
            if (_that._options.isMulti) {
                //gridOptions.selectable = "multiple,row";
            } else {
                //gridOptions.selectable = "row"
            }

            var lstOp = {
                selector : _that._selector,
                type : "thickLine",
                multiLine : 1,
                hasIcon : false,
                hasControl : false, //包含控件
                hasSubTitle : true,
                hasTouchEffect : true,
                hasAngle : false
            }
            if (_that._options.layout.icon) {
                lstOp.hasIcon = true;
            }
            if (_that._options.layout.r0c1 || _that._options.layout.r1c1 || _that._options.layout.r2c1) {
                lstOp.hasSubTitle = true;
            }
            if (_that._options.layout.group) {
                lstOp.hasGroup = true;
            }
            _that._lst = appcan.listview(lstOp);

            _that._lst.set(_that._parseData(_that._data));

            _that._lst.on("click", function(ele, d) {
                if ($(event.target).hasClass('list-btn') || $(event.target).closest('.list-btn').length > 0) {
                    _that._selData = d.data;
                    return false;
                }
                $.util.trigger(_that.afterSelect, {
                    data : d.data
                });
            });
            _that._iconRegister();
            if (_that._data == null || _that._data.length == 0) {
                $(_that._selector).html("<div class='ut ub-f1 ut-s tx-c'><div style='margin:.5em;color: rgba(140, 140, 140,1);'>没有查询到相关数据!</div></div>");
            }
            if ($page && _that._options.enableBounce) {
                $page.enableBounce();
                if ($page.afterRefresh == null) {
                    $page.afterRefresh = function() {
                        _that._query.PageIndex = 1;
                        _that.refresh();
                    }
                }
                if ($page.afterMore == null) {
                    $page.afterMore = function() {
                        _that.nextPage();
                    }
                }
            }
            if ($page && _that._options.enableFilter && _that._table) {
                var newType = 'M_' + _that._query.PrimaryTable + "_" + _that._query.ProjectType;
                var oldType = _that._projectType || "";
                if (newType != oldType) {
                    _that._projectType = newType;
                    var q = new $.server.queryOptions();
                    q.PrimaryTable = "SS206";
                    q.ConditionExpr = "SS206.A01 = '" + newType + "' AND ID LIKE '0000________0000______'";

                    $.server.query(q, function(datas) {
                        _that._filterTable = $.extend(true, {}, _that._table);
                        _that._filterTable.FieldList = [];
                        if (_that._table != null && _that._table.FieldList != null && datas.DataSource.length > 0) {
                            for (var i = 0; i < _that._table.FieldList.length; i++) {
                                var f = $.extend(true, {}, _that._table.FieldList[i]);
                                f.RelationRule = "";
                                $(datas.DataSource[0]["SS206_A02"].split(",")).each(function() {
                                    if (this == f.TableName + "." + f.ColName) {
                                        _that._filterTable.FieldList.push(f);
                                        f.ColVisible = 1;
                                    }
                                });
                            }
                        }
                        if (_that._filterTable.FieldList.length > 0) {
                            $page.filterData = {
                                table : _that._filterTable,
                                data : {}
                            };
                            $page.enableFilter();
                            $page.afterFilter = function(filterData) {
                                _that._filter = '1=1';
                                $(_that._filterTable.FieldList).each(function() {
                                    if ((this.EditFormat == null || this.EditFormat == "") && (this.ColType == "DATETIME" || this.ColType == "NUMERIC")) {
                                        var val1 = filterData[this.TableName + "_" + this.ColName];
                                        var val2 = filterData[this.TableName + "_" + this.ColName + "_T"];
                                        if (this.ColType == "DATETIME") {
                                            if (val1 != null) {
                                                val1 = $C.date.format(val1, "yyyy-MM-dd");
                                            }
                                            if (val2 != null) {
                                                val2.setHours(23);
                                                val2.setMinutes(59);
                                                val2.setSeconds(59);
                                                val2 = $C.date.format(val2, "yyyy-MM-dd HH:mm:ss");
                                            }
                                        }
                                        if (val1 != null) {
                                            _that._filter += " AND " + this.TableName + "." + this.ColName + " >= '" + val1 + "'";
                                        }
                                        if (val2 != null) {
                                            _that._filter += " AND " + this.TableName + "." + this.ColName + " <= '" + val2 + "'";
                                        }
                                    } else if (this.EditFormat == "CHECK(|1|0)") {
                                        var val = filterData[this.TableName + "_" + this.ColName];
                                        val = val == 1 ? 1 : 0;
                                        _that._filter += " AND " + this.TableName + "." + this.ColName + " = " + val;
                                    } else {
                                        var val = filterData[this.TableName + "_" + this.ColName];
                                        if (val != null && val.trim() != "") {
                                            _that._filter += " AND " + this.TableName + "." + this.ColName + " LIKE '%" + val.trim() + "%'";
                                        }
                                    }
                                });
                                _that.refresh();
                            }
                        }
                    });
                }
            }
            $.util.trigger(_that.afterLoad, {
                data : _that._data
            });
        });
    };
    ///重新绑定
    this.refresh = function(options) {
        _that._options = $.extend(_that._options, options);
        _that.load(_that._query);
    }
    ///重新绑定
    this.totalPage = function(options) {
        return Math.ceil(_that._total / _that._query.PageSize);
    }

    this.nextPage = function() {
        if (_that._lst && _that._query) {
            if (_that._query.PageIndex >= _that.totalPage()) {
                return;
            }
            if (_that._loading) {
                return;
            }
            _that._query.PageIndex++;
            _that._loading = true;
            var q = $.extend(new $.server.queryOptions(), _that._query);
            if (_that._filter) {
                if (q.ConditionExpr.length == 0) {
                    q.ConditionExpr = '1=1';
                }
                q.ConditionExpr = "(" + q.ConditionExpr + ") AND (" + _that._filter + ")"
            }
            $.server.query(q, function(data) {
                _that._loading = false;
                if (data.DataSource.length > 0) {
                    $(data.DataSource).each(function() {
                        _that._data.push(this);
                    });
                    _that._lst.add(_that._parseData(data.DataSource), 1);
                }
                _that._iconRegister();
                $.util.trigger(_that.afterLoad, {
                    data : _that._data
                });
            }, _that._options.isCache);
        }
    }

    this.del = function() {
        var data = _that._selData;
        $.util.confirm("确定删除数据？", function(res) {
            if (res) {
                data["_ROWSTATE"] = 3;
                var updateOptions = $.server.updateOptions(_that._table, [data], _that._query.PrimaryTable, "ID");
                //四个参数Table,DataSource,tablename,keyField
                $.server.update(updateOptions, function(result) {
                    if (result) {
                        $.util.trigger(_that.afterDel, {
                        }, function() {
                            $.util.info("删除成功！");
                            _that.refresh();
                        });
                    };
                });
            }
        });

    }
    ///获取查询参数
    this.getQuery = function() {
        return _that._query;
    };

    ///获取页面查询过滤条件
    this.getFilter = function() {
        return _that._filter;
    };
}
