function Map($this, options) {
    var _that = this;
    this._gdmap = null;
    this._id = "gd-" + $.util.guid();
    this._markers = [];
    this._isBusy = false;
    this._$that = $this;
    this._options = $.extend({
        top : null,
        height : null,
        width : null,
        datas : [], //格式为{name:null,point:null,address:{fullAddress}}
        isTrail : false, //轨迹
        enable : false
    }, options);

    this._init = function(data) {
        //alert($.mobile.getEmSize());
        var openps = {
            left : 0,
            top : _that._options.top || $.mobile.getHHeight(),
            width : _that._options.width || $(window).width(),
            height : _that._options.height,
            isScrollWithWeb : false,
            longitude : 118.187619,
            latitude : 24.484679
        };
        openps.top += $.mobile.top();
        openps = JSON.stringify(openps);
        //alert("打开地图");
        uexGaodeMap.open(openps);
        $.util.cache("GAODE_OPEN", $page.name);
        //手势缩放
        var zoom = {
            type : 1
        };
        zoom = JSON.stringify(zoom);
        uexGaodeMap.setZoomEnable(zoom);
        var mapt = {
            type : 1
        };
        var mty = JSON.stringify(mapt);
        uexGaodeMap.setMapType(mty);
        //手势拖动
        var scroll = {
            type : 1
        };
        scroll = JSON.stringify(scroll);
        uexGaodeMap.setScrollEnable(scroll);

        //比例标尺
        var scale = {
            visible : true
        }
        var scale = JSON.stringify(scale);
        uexGaodeMap.setScaleVisible(scale);

        //标尺级别
        var zooml = {
            level : 12
        }
        zooml = JSON.stringify(zooml);
        uexGaodeMap.setZoomLevel(zooml);

        if (_that._options.enable) {
            uexGaodeMap.onMapClickListener = function(ret) {
                //alert("点击或者拖动地图");
                var p = $.evalJSON(ret);
                var point = {
                    point : [p.longitude, p.latitude]
                };
                _that.addMarkers([point]);
            }
        }
        // uexGaodeMap.cbGetDownloadList = function(json) {
        // alert("cbGetDownloadList: " + json);
        // }
        // uexGaodeMap.getDownloadList();
        // uexGaodeMap.cbDownload = function(json) {
        // alert("cbDownload: " + json);
        // }
        // var dtdata = [{
        // city : '厦门'
        // }, {
        // province : '福建省'
        // }];
        // var dtload = JSON.stringify(dtdata);
        // uexGaodeMap.download(dtload);
        // uexGaodeMap.onDownload = function(json) {
        // var data = JSON.parse(info);
        // if (data.status == 0) {
        // uexWindow.toast(1, 5, data.name + " 正在下载...", 0);
        // }
        // if (data.status == 1) {
        // uexWindow.toast(1, 5, data.name + " 正在解压...", 0);
        // }
        // if (data.status == 4) {
        // uexWindow.closeToast();
        // alert(data.name + " 离线地图下载成功!");
        // }
        // if (data.status == 3) {
        // uexWindow.toast(0, 5, data.name + " 暂停下载...", 2000);
        // }
        // if (data.status == -1) {
        // uexWindow.closeToast();
        // alert(data.name + " 下载失败!");
        // }
        // }
        //alert("初始化完毕");
         //标尺级别
        var zoml = {
            level : 14
        }
        zoml = JSON.stringify(zoml);
        uexGaodeMap.setZoomLevel(zoml);
    }

    this.setCenter = function(point) {
        //alert("设置中心点:"+point[0]+","+point[1]);
        var setcent = {
            longitude : point[0],
            latitude : point[1]
        };
        setcent = JSON.stringify(setcent);
        //alert("setcent:"+setcent);
        uexGaodeMap.setCenter(setcent);
        //alert("设置中心点结束");
    }
    
    this.setMyLocationEnable = function(v) {
        var setmy = {
            type : v
        }
        var sdata = JSON.stringify(setmy);
        uexGaodeMap.setMyLocationEnable(sdata);
    }
    
    this.markerID = 1000;
    this.addMarkers = function(points, callback) {
        this.clearMarker();
        this._options.datas = points;
        _that.markerID++;
        if (points.length == 1) {
            //alert("定位加点");
            var codeps = {
                longitude : points[0].point[0],
                latitude : points[0].point[1]
            };
            var ncode = JSON.stringify(codeps);
            //alert("ncode:"+ncode);
            uexGaodeMap.cbReverseGeocode = function(ret) {
                //alert("逆地址解析");
                ret = $.evalJSON(ret);
               // alert("逆地址解析结果:"+ret);
                if (!points[0].address) {
                    points[0].address = {};
                }
                points[0].address.fullAddress = ret.address;
                if ($.isFunction(callback)) {
                    callback(points);
                }
                _that.markerID++;
                //alert("markerID:"+_that.markerID);
                var marker = [{
                    id : _that.markerID,
                    longitude : points[0].point[0],
                    latitude : points[0].point[1],
                    bubble : {
                        title : points[0].name,
                        subTitle : points[0].address.fullAddress
                    }
                }];
                var mda = JSON.stringify(marker);
                //alert("mda:"+mda)
                uexGaodeMap.addMarkersOverlay(mda);
                //alert("addMarkersOverlay结束");
                _that._markers.push(marker);
            }
            uexGaodeMap.reverseGeocode(ncode);
        } else {
            var marker = [];
            if (_that._options.isTrail == true) {
                var polys = {
                    id : 1010,
                    fillColor : "#3366FF",
                    lineWidth : "8.0",
                    property : []
                };
                for (var i = 0; i < points.length; i++) {
                    if (i == 0) {
                        var m = {
                            id : i + 1,
                            longitude : points[i].point[0],
                            latitude : points[i].point[1],
                            bubble : {
                                title : points[i].name,
                                subTitle : points[i].address.fullAddress
                            }
                        }
                        marker.push(m);
                        _that._markers.push(m);
                    } else if (i == points.length - 1) {
                        var m = {
                            id : i + 1,
                            longitude : points[i].point[0],
                            latitude : points[i].point[1],
                            bubble : {
                                title : points[i].name,
                                subTitle : points[i].address.fullAddress
                            }
                        }
                        marker.push(m);
                        _that._markers.push(m);
                    }
                    polys.property.push({
                        longitude : points[i].point[0],
                        latitude : points[i].point[1]
                    });
                }
                var npoly = JSON.stringify(polys);
                uexGaodeMap.addPolylineOverlay(npoly);
            } else {
                for (var i = 0; i < points.length; i++) {
                    var m = {
                        id : i + 1,
                        longitude : points[i].point[0],
                        latitude : points[i].point[1],
                        bubble : {
                            title : points[i].name,
                            subTitle : points[i].address.fullAddress
                        }
                    }
                    marker.push(m);
                    _that._markers.push(m);
                }
            }

            var mda = JSON.stringify(marker);
            uexGaodeMap.addMarkersOverlay(mda);
        }
        //TODO enable drag
    }

    this.clearMarker = function() {
        uexGaodeMap.clear();
        _that._markers = [];
    }

    this.placeSearch = function(k1) {
        var search = {
            city : "",
            address : k1
        };
        search = JSON.stringify(search);
        uexGaodeMap.cbGeocode = function(ret) {
            ret = $.evalJSON(ret);
            _that.clearMarker();
            var point = [ret.longitude, ret.latitude];
            _that.setCenter(point);
            _that._options.datas = [];
            _that._options.datas.push({
                point : point,
                address : {
                    fullAddress : null
                }
            })
            _that.addMarkers([_that._options.datas[0]]);
        };
        uexGaodeMap.geocode(search);
    }

    this.MapClose = function() {
        uexGaodeMap.close();
    }

    this.load = function(options, callback) {
        _that._options = $.extend(_that._options, options);
        _that._options.height = _that._options.height || (($(window).height() - $.mobile.getHHeight()) * 0.618);
        _that._$that.height(_that._options.height);
        if (_that._options.datas.length > 0) {
            uexGaodeMap.cbOpen = function() {
                _that.addMarkers(_that._options.datas, function(ret) {
                    if ($.isFunction(callback)) {
                        callback(ret);
                    }
                });

            }
            _that._init(_that._options.datas[0]);
        } else {
            uexGaodeMap.cbOpen = function() {
                //alert("开始获取当前位置");
                _that.getCurrentLocation(callback);
                //alert("结束获取当前位置");
            }
            _that._init();
        }
    }

    this.getCurrentLocation = function(callback) {
        //alert("执行获取位置!")
        uexGaodeMap.getCurrentLocation();
        //alert(2);
        uexGaodeMap.cbGetCurrentLocation = function(json) {
            //alert("获取位置回调");
            var point = $.evalJSON(json);
            //alert("位置回调:"+point);
            _that._options.datas = [];
            _that._options.datas.push({
                point : [point.longitude, point.latitude],
                address : {
                    fullAddress : null
                }
            });

            _that.setCenter(_that._options.datas[0].point);
            _that.addMarkers([_that._options.datas[0]], function(ret) {
                if ($.isFunction(callback)) {
                    callback(ret);
                }
            });
        }
    }

    this.AddressInfo = function() {
        if (_that._isBusy) {
            return null;
        }
        if (_that._options.datas.length > 0)
            return _that._options.datas[0];
    }
}