$.extend({
    mobile : {
        downUrl : function(data) {
            data = $.extend({
                guid : "",
                def : "headimg"
            }, data);
            var ret = $.gr.getServer() + "/handlers/DownloadHandler.ashx?guid=" + data.guid + "&def=" + data.def;
            if ($.util.cache(".GRAUTH")) {
                ret += "&u=" + $.util.cache(".GRAUTH");
            }
            ret += "&t=" + Math.random();
            return ret;
        },
        getDownPath : function() {
            var platform = $.util.cache('platform');
            if (platform == 0) {
                return "../../widgets/";
            } else if (platform == 1) {
                return "/storage/emulated/0/widgetone/widgets/";
            }
        },
        imgUrl : function(guid, def) {
            var data = {
                guid : guid || "",
                def : def || "headimg",
            }
            if (data.guid == "") {
                return "../src/images/" + data.def + ".jpg";
            }
            var ret = '';
            if ($page.cache.files[data.guid]) {
                ret = $.mobile.getDownPath() + "temp/img/" + data.guid + '.jpg?' + Math.random();
                $page.cache.files[data.guid].loading = 1;
                $.mobile.fileCacheUpdate();
            } else {
                $.mobile.download(data);
                ret = '../src/images/loading.jpg?' + data.guid;
            }
            return ret;
        },
        uploadUrl : function(guid) {
            guid = guid || "";
            return $.gr.getServer() + "/handlers/UpLoadHandler.ashx?guid=" + guid;
        },
        getDownData : function(opId) {
            var dds = $.util.cache("DOWNLOAD_DATA") || [];
            var data = null;
            for (var i = 0; i < dds.length; i++) {
                if (dds[i].opId == opId) {
                    data = dds[i];
                    break;
                }
            }
            return data;
        },
        getDefaultOpid : function() {
            var version = $.util.cache('version') || '01.01.01';
            var flag = parseInt(version.split('.')[0]);
            return flag * 10000;
        },
        getUploadId : function() {
            var opId = $.util.cache("APP_OPID") || $.mobile.getDefaultOpid();
            opId += 1;
            $.util.cache("APP_OPID", opId);
            return opId;
        },
        getDownloadId : function() {
            var opId = $.util.cache("APP_OPID") || $.mobile.getDefaultOpid();
            opId += 1;
            $.util.cache("APP_OPID", opId);
            return opId;
        },
        download : function(data, callback) {
            var data = $.extend({
                guid : "",
                def : "headimg"
            }, data);
            data.opId = $.mobile.getDownloadId();
            data.savePath = "wgts://temp/img/" + data.guid + ".jpg";
            data.downPath = $.mobile.downUrl(data);
            var dds = $.util.cache("DOWNLOAD_DATA") || [];
            dds.push(data);
            $.util.cache("DOWNLOAD_DATA", dds);
            uexDownloaderMgr.cbCreateDownloader = function(opId, dataType, d) {
                var data = $.mobile.getDownData(opId);
                if (data != null) {
                    if (d == 0) {
                        uexDownloaderMgr.download(data.opId, data.downPath, data.savePath, '1');
                    }
                }
            }
            uexDownloaderMgr.createDownloader(data.opId);
            uexDownloaderMgr.onStatus = function(opId, fileSize, percent, status) {
                switch (status) {
                case 0:
                    //uexWindow.toast("1", "5", percent + "%", "0");
                    break;
                case 1:
                    uexDownloaderMgr.closeDownloader(opId);
                    //关闭下载对象
                    var data = $.mobile.getDownData(opId);
                    if (data != null) {
                        $.mobile.reloadImg(data.guid);
                        $page.cache.files[data.guid] = $.extend(data, {
                            fileSize : fileSize,
                            cdate : $.server.currentDate()
                        });
                        $.util.cacheLong('DOWN_FILEINFO', $page.cache.files, function() {

                        });
                    }
                    break;
                case 2:
                    uexDownloaderMgr.closeDownloader(opId);
                    break;
                case 3:
                    break;
                }
            }
            return data.savePath;
        },
        fileCacheUpdate : function() {
            if ($page) {
                if ($page.cache.updateTime) {
                    clearTimeout($page.cache.updateTime);
                }
                $page.cache.updateTime = setTimeout(function() {
                    var guids = {};
                    for (var guid in $page.cache.files) {
                        if ($page.cache.files[guid].loading) {
                            $page.cache.files[guid].loading = 0;
                            guids[guid] = $page.cache.files[guid].fileSize;
                        }
                    }
                    $.server.api({
                        path : 'Attach/AttachManager/FileCacheUpdate',
                        parms : [$.toJSON(guids)],
                        isShow : false
                    }, function(ret) {
                        var files = [];
                        for (var guid in ret) {
                            if ($page.cache.files[guid]) {
                                files.push($page.cache.files[guid]);
                            }
                            guids[guid] = null;
                        }
                        var fileExists = [];
                        for(var guid in guids){
                            if(guids[guid] && $page.cache.files[guid]){
                                fileExists.push($page.cache.files[guid]);
                            }
                        }
                        $.mobile.fileCacheExists(fileExists, 0, function (){
                            $.mobile.delFile(files, 0, function() {
                                for (var i = 0; i < files.length; i++) {
                                    $.mobile.download(files[i]);
                                }
                            });
                        });
                    });
                }, 1000);
            }
        },
        reloadImg : function(guid) {
            setTimeout(function() {
                var $img = $("*[style*='" + guid + "']");
                $($img).each(function() {
                    var img = $(this).css("background-image");
                    var path = img.replaceAll('url\\("', '').replaceAll('url\\(', '').replaceAll('"\\)', '').replaceAll('\\)', '');
                    var strs = path.split('?');
                    if (path.indexOf('loading.jpg') > -1) {
                        var g = strs[strs.length - 1];
                        if (g == guid) {
                            var newPath = $.mobile.getDownPath() + "temp/img/" + guid + '.jpg\\?' + Math.random();
                            var url = img.replaceAll(strs[0] + '\\?' + strs[1], newPath);
                            $(this).css("background-image", url);
                        }
                    } else {
                        var strs2 = strs[0].split('/');
                        var g = strs2[strs2.length - 1];
                        if (g == guid) {
                            var url = img.replaceAll(strs[1], Math.random());
                            $(this).css("background-image", url);
                        }
                    }
                });
            }, 500);
        },
        delFile : function(guids, index, callback) {
            if (index < guids.length) {
                $page.cache.files[guids[index].guid] = null;
                uexFileMgr.deleteFileByPath($.mobile.getDownPath() + "temp/img/" + guids[index].guid + ".jpg");
                uexFileMgr.cbDeleteFileByPath = function() {
                    $.mobile.delFile(guids, index + 1, callback);
                };
            } else {
                if ($.isFunction(callback)) {
                    callback();
                }
            }
        },
        fileCacheExists : function(guids, index, callback) {
            if (index < guids.length) {
                uexFileMgr.isFileExistByPath("wgts://temp/img/" + guids[index].guid + ".jpg");
                uexFileMgr.cbIsFileExistByPath = function(opId, dataType, data) {
                    if(data == 0){
                        $.mobile.download($page.cache.files[guids[index].guid]);
                    }
                    $.mobile.fileCacheExists(guids, index + 1, callback);
                };
            } else {
                if ($.isFunction(callback)) {
                    callback();
                }
            }
        },
        getRang : function(met) {
            var y = 8.983152841152322;
            var x = 11.71330378704031;
            var x1 = met * x * 0.000001;
            var y1 = met * y * 0.000001;
            return [x1.toFixed(6), y1.toFixed(6)];
        },
        getEmSize : function() {
            var size = parseInt($('body').css('font-size'));
            return size;
        },
        getHHeight : function() {
            var size = Math.ceil($.mobile.getEmSize() * 2.54);
            return size;
        },
        top : function() {
            var platform = $.util.cache('platform');
            if (platform == 1 || platform == 2) {
                return 0;
            } else {
                return 20;
            }
        },
        bottom : function() {
            var platform = $.util.cache('platform');
            if (platform == 1 || platform == 2) {
                return 0;
            } else {
                return $.mobile.getHHeight() + $.mobile.top();
            }
        },
        setHeader : function(header) {
            appcan.window.evaluateScript({
                name : $page.name,
                scriptContent : "$page.setHeader('" + header + "')"
            });
        },
        click : function(selector, callback) {
            /*$(selector).click(function() {
             var $sender = $(this);
             var isBusy = $sender.attr('busy') || 0;
             if (isBusy) {
             return;
             }
             $sender.attr('busy', 1);
             setTimeout(function() {
             $sender.attr('busy', null);
             if ($.isFunction(callback)) {
             callback($sender, event);
             }
             }, 50);
             })*/
            appcan.button(selector, "ani-act", function(a, b) {
                var $sender = $(this);
                var isBusy = $sender.attr('busy') || 0;
                if (isBusy) {
                    return;
                }
                $sender.attr('busy', 1);
                setTimeout(function() {
                    $sender.attr('busy', null);
                    if ($.isFunction(callback)) {
                        callback($sender, event);
                    }
                }, 50);
            });
        }
    },
    dialog : {
        open : function(op) {
            var options = $.extend({
                name : null,
                content : null,
                ///这个事件内部无法引用外部变量
                afterLoad : function() {
                },
                beforeClose : function(ret, callback) {
                    callback(true);
                },
                afterClose : null
            }, op);
            if (!options.name) {
                options.name = $.util.guid();
            }
            $page.dialog.options = op;
            $.util.cache("dialog_options", op);
            $.util.cache("parent_name", $page.name);

            if (!options.name) {
                options.name = $.util.guid();
            }
            $.util.cache("dialog_name", options.name);
            appcan.window.open({
                name : options.name,
                data : "dialog.html",
                dataType : 0,
                aniId : 12,
                type : 4,
                animDuration : 500
            });
        },
        openMenu : function(op) {
            var name = $.util.guid();
            var options = $.extend({
                type : 0, //0为4格布局,1为单列布局
                data : null //格式为[{text:'',icon:'',click:function(){}}]
            }, op);

            var colors = ['bg-blue', 'bg-red', 'bg-azure', 'bg-palegreen', 'bg-yellow', 'bg-darkorange', 'bg-sky', 'bg-magenta', 'bg-purple', 'bg-maroon'];
            var html = [];
            if (options.type == 0) {
                html.push('<div class="uinn bg-wh">');
                html.push('<div class="ub">');
                $(options.data).each(function(index) {
                    this.guid = $.util.guid();
                    if (index > 1 && index % 4 == 1) {
                        html.push('</div>');
                        html.push('</div>');
                        html.push('<div class="uinn bg-wh">');
                        html.push('<div class="ub">');
                    }
                    html.push('<div class="ub-f1 ub ub-ver ub-ac">');
                    html.push('<div class="btn-radius3 ub ub-ac ub-pc btn-trigger ' + colors[this.color] + '" guid="' + this.guid + '">');
                    html.push('<div class="fa-2x ' + this.icon + '"></div>');
                    html.push('</div>');
                    html.push('<div class="tx-c btn-text">');
                    html.push(this.text);
                    html.push('</div>');
                    html.push('</div>');
                });
                html.push('</div>');
                html.push('</div>');
            } else if (options.type == 1) {
                html.push('<div class="uinn bg-btn btn-margin"">');
                $(options.data).each(function(index) {
                    this.guid = $.util.guid();
                    if (index > 0) {
                        html.push('<hr style=" margin: 0.5em -0.5em 0.5em  -0.5em;" />');
                    }
                    html.push('<div class="ub ub-ac bc-text-head ub-pc t-gra btn-trigger" guid="' + this.guid + '">');
                    html.push(this.text);
                    html.push('</div>');
                });
                html.push('</div>');
            }
            var dialog = new DialogWindow({
                title : "操作",
                afterClose : function() {

                }
            });
            var page = '<div class="ub ub-ver ub-f1 ub-con">' + '<div class="ub-f1 ub-con ub-fh ub-fv" id="bg" ontouchstart="appcan.touch(\'btn-act\')"></div>' + '<div id="content" class="bg-gra ub-ver">' + $.util.join('', html) + '</div>' + '<div class="bg-gra ub-ver">' + '  <div class="uinn btn-cancel bg-btn">' + '    <div class="ub ub-ac bc-text-head ub-pc t-gra">取 消</div></div></div></div>';
            dialog.addContent($(page));
            dialog.open();
            $.mobile.click(".btn-trigger", function($ele) {
                var guid = $ele.attr('guid');
                $(options.data).each(function() {
                    if (this.guid == guid) {
                        dialog.close();
                        this.click();
                        return;
                    }
                });
            })
            $.mobile.click(".btn-cancel", function(e) {
                dialog.close();
            })
        }
    }
});
