function BaiduMap(options) {
	$.util.debug();
	var _that = this;
	this._$k = null;
	this._data = null;
	this._parms = null;
	this._options = $.extend({
		title: "请选择",
		data: null,
		afterClose: function (op) { }
	}, options);
	this._lmap = null;
	this._navigationControl = null;
	this._geolocationControl = null;
	this._enableGeolocation = null;
	this._mapheight = 300;
	this._mapwidth = 570;
	this._x = 118.10388605;
	this._y = 24.48923061;
	this._level = 15;
	this._addOverlay = null;
	this._mkrTool = null;
	this._curMkr = null;
	this._infoWin = null;
	this._hidden = null;
	this._province = null;
	this._city = null;
	this._street = null;
	this._district = null;
	this._DialogAD = null;
	this._DialogCL = null;
	this._theLocation = null;
	this._searchByStationName = null;
	this._html = null;

	////地图控件添加函数：
	this._addMapControl = function () {
		var ctrl_sca = new BMap.ScaleControl({ anchor: BMAP_ANCHOR_BOTTOM_LEFT });
		this._lmap.addControl(ctrl_sca);
		var navigationControl = new BMap.NavigationControl({
			// 靠左上角位置
			anchor: BMAP_ANCHOR_TOP_LEFT,
			// LARGE类型
			type: BMAP_NAVIGATION_CONTROL_LARGE,
			// 启用显示定位
			enableGeolocation: true
		});
		this._lmap.addControl(navigationControl);
		this._geolocationControl = new BMap.GeolocationControl();
		this._geolocationControl.addEventListener("locationSuccess", function (e) {
			var geoc = new BMap.Geocoder();
			var pt = e.point;
			geoc.getLocation(pt, function (rs) {
				var addComp = rs.addressComponents;
				var address = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
				alert("当前定位地址为：" + address);
			});
		});
		this._geolocationControl.addEventListener("locationError", function (e) {
			alert(e.message);
		});
		this._lmap.addControl(this._geolocationControl);
	}
	this._hidden = function () {
		document.getElementById("TextArea").style.display = "none";
	}
	this._searchByStationName = function () {
		var localSearch = new BMap.LocalSearch(this._lmap);
		localSearch.enableAutoViewport(); //允许自动调节窗体大小
		this._lmap.clearOverlays();//清空原来的标注
		var keyword = document.getElementById("text_").value;
		localSearch.setSearchCompleteCallback(function (searchResult) {
			var poi = searchResult.getPoi(0);
			document.getElementById("result_").value = poi.point.lng + "," + poi.point.lat;
			_that._lmap.centerAndZoom(poi.point, 18);
			var marker = new BMap.Marker(new BMap.Point(poi.point.lng, poi.point.lat));  // 创建标注，为要查询的地方对应的经纬度
			_that._lmap.addOverlay(marker);
			var point = new BMap.Point(poi.point.lng, poi.point.lat);
			var geoc = new BMap.Geocoder();
			$.util.debug();
			geoc.getLocation(point, function (pt) {
				var addComp = pt.addressComponents;
				var address = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
				console.log(address);
				this._province = addComp.province;
				this._city = addComp.city;
				this._district = addComp.district;
				this._street = addComp.street;
				$("#address").val(address);
				var content = address;
				$("#text_").val(content);
				var infoWindow = new BMap.InfoWindow("<p style='font-size:14px;'>" + content + "</p>");
				marker.addEventListener("click", function () { this.openInfoWindow(infoWindow); });
				marker.enableDragging();	
			});			
			var content = $("#text_").val();
			var infoWindow = new BMap.InfoWindow("<p style='font-size:14px;'>" + content + "</p>");
			marker.addEventListener("click", function () {
				this.openInfoWindow(infoWindow);
				var geoc = new BMap.Geocoder();
					_that._lmap.addEventListener("click", function (e) {   //由于baidu和google经纬度放置顺序不一样，在这统一为google的顺序  
						var point = new BMap.Point(e.point.lng, e.point.lat);   //创建要标注的点  
						geoc.getLocation(point, function (rs) {
							var addComp = rs.addressComponents;
							var address = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
							this._province = addComp.province;
							this._city = addComp.city;
							this._district = addComp.district;
							this._street = addComp.street;
							$("#address").val(address);							
							$("#text_").val(address);
							$("#p1").val(this._province);
							$("#c1").val(this._city);
							$("#d1").val(this._district);
							var content = address;
							$("#text_").val(content);
							var infoWindow = new BMap.InfoWindow("<p style='font-size:14px;'>" + content + "</p>");
							marker.addEventListener("click", function () { this.openInfoWindow(infoWindow); });
							marker.enableDragging();
						});
						$("#a1").val(e.point.lng);
						$("#b1").val(e.point.lat);
					});
			});
			marker.enableDragging();
		});
		localSearch.search(keyword);
	}
	
	this._DialogAD = function () {
		this._dialog = new DialogWindow({
			afterClose: function (op) {
				if (op == true) {
					$.util.debug();
					var name = $("#name").val();
					var lng = $("#a1").val();
					var lat = $("#b1").val();
					var address = $("#address").val();
					var province = $("#p1").val();
					var city = $("#c1").val();
					var area = $("#d1").val();
					if (name != "" && lng != "" && lat != "" && address != "" && province != "" && city != "" && area != "") {
						var data = new Array();
						data.push(name);	//名称
						data.push(lng);		//横坐标
						data.push(lat);		//纵坐标
						data.push(address); //地址
						data.push(province);//省
						data.push(city);    //市
						data.push(area);    //区
						var querymap = {
							path: "Permission/GetMap/getMap",
							parms: data
						}
						$.server.api(querymap, function (result) {
							$.util.debug();
							if (result != null) {
								var ret = {
									datas: result,
									dialogResult: op    //判断确定或取消.
								};
								if ($.isFunction(_that._options.afterClose)) {
									_that._options.afterClose(ret);
								}
								$.util.info("位置定位成功!");
							} else {
								$.util.error("定位失败!");
							}
						});
					} else {
						$.util.info("请先定位！！");
					}
				}
			}
		});
	}
	this._DialogCL = function () {
		this._dialog = new DialogWindow({
			afterClose: function (op) {
				_that._options = $.extend(_that._options, options);
				this._dialog = new DialogWindow({
					title: _that._options.title,
					afterClose: function (op) {
						var grd = _that.getGrid();
						if (grd) {
							var selDatas = grd.select();
							var result = {
								datas: selDatas,
								dialogResult: op
							};
							if ($.isFunction(_that._options.afterClose)) {
								_that._options.afterClose(result);
							}
						}
					}
				});
			}
		});
	}
	this.open = function (options) {
		_that._options = $.extend(_that._options, options);
		if (options.data.table == 'KQ106' && options.data.enable == false) {
			var query = new $.server.queryOptions();
			query.PrimaryTable = "SS204";
			query.FieldNameList = "*";
			var bm = options.data.BM;
			var BMS = "'0'";
			if (options.data.BM == null) {
				$.util.info("当天尚无签到记录！！");
			} else {
				for (var i = 0; i < bm.length; i++) {
					BMS += ",'" + bm[i] + "'";
				}
				query.ConditionExpr = "SS204.ID IN (" + BMS + ")";
				$.server.query(query, function (data) {
					var pointPT = [];
					var pointName = [];
					var pointAds = [];
					var pointTime = [];
					var pointXY = [];
					var marker = [];
					var pointJL = [];
					var label = [];
					var infoWindow = [];
					$.each(data.DataSource, function (key, val) {       //数组循环
						pointPT = new BMap.Point(val['SS204_A02'], val["SS204_A03"]);
						marker.push(new BMap.Marker(pointPT));
						pointName.push(val["SS204_A01"]);
						pointAds.push(val["SS204_A06"]);
						pointTime = options.data.MC;
						pointJL = options.data.MCS;
						var opts = {
							position: marker[key],    //指定文本标注所在的地理位置
							offset: new BMap.Size(20, 0)   //设置文本偏移量
						}
						label[key] = new BMap.Label(pointJL[key], opts);
						label[key].setStyle({
							"max-width": "none"
						});
						inf = {
							width: 180,     // 信息窗口宽度
							height: 70,     // 信息窗口高度
							enableMessage: true,//设置允许信息窗发送短息
						}
						infoWindow[key] = new BMap.InfoWindow(pointTime[key] + "<br/> " + pointAds[key], inf);
						pointXY.push(pointPT);
					});
					var polyline = new BMap.Polyline(pointXY, { strokeColor: "blue", strokeWeight: 2, strokeOpacity: 0.3 });
					var $lmap = $("<div id='lkmap'style='border:1px solid gray;width:" + _that._mapwidth + "px;height:" + _that._mapheight + "px;'></div>");
					_that._dialog.addContent($lmap);
					_that._dialog.open();
					_that._lmap = new BMap.Map("lkmap");
					_that._lmap.width = _that._mapwidth;
					_that._lmap.height = _that._mapheight;
					_that._lmap.addOverlay(polyline);
					$.util.debug();
					var point = new BMap.Point(data.DataSource[0]["SS204_A02"],data.DataSource[0]["SS204_A03"]);
					_that._lmap.centerAndZoom(point,17);
					for (var i = 0; i < data.DataSource.length; i++) {
						if (i == 0 || i == (data.DataSource.length - 1)) {
							_that._lmap.addOverlay(marker[i]);
							marker[i].num = i;
							marker[i].addEventListener("click", function (e) {
								_that._lmap.openInfoWindow(infoWindow[this.num], pointXY[this.num]);
							});
							marker[i].setLabel(label[i]);
							marker[i].disableDragging();       //点不可拖拽，可拖拽是enableDragging（）
						}
					}
					_that._addMapControl();
				});
				this._DialogCL();
			}
		} else if (options.data.table == 'KQ106' && options.data.enable == true) {
			this._DialogAD();
			var $lmap = $("<div id='lkmap'style='border:1px solid gray;width:" + _that._mapwidth + "px;height:" + _that._mapheight + "px;'></div><div id='TextArea'style='display: none' onMouseout='hidden();'>名称：<input type='text' id='name'/><br/>经度：<input type='text' id='a1'/><br/>纬度：<input type='text' id='b1'/><br/>地址：<input type='text' id='address'/>省份：<input type='text' id='p1'/><input type='text' id='c1'/><input type='text' id='d1'/><input type='text' id='s1'/></div>");
			_that._dialog.addContent($lmap);
			_that._dialog.open();
			_that._lmap = new BMap.Map("lkmap");
			_that._lmap.width = _that._mapwidth;
			_that._lmap.height = _that._mapheight;
			var point = new BMap.Point(_that._x, _that._y);
			_that._lmap.centerAndZoom(point,19);
			_that._addMapControl();

			var geolocation = new BMap.Geolocation();
			geolocation.getCurrentPosition(function (r) {
				if (this.getStatus() == BMAP_STATUS_SUCCESS) {
					var mk = new BMap.Marker(r.point);
					_that._lmap.addOverlay(mk);
					_that._lmap.panTo(r.point);
					var geoc = new BMap.Geocoder();
					var point = new BMap.Point(r.point.lng,r.point.lat);
					geoc.getLocation(point, function (rs) {
						var addComp = rs.addressComponents;
						var address = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
						this._province = addComp.province;
						this._city = addComp.city;
						this._district = addComp.district;
						this._street = addComp.street;
						$("#address").val(address);
						$("#p1").val(this._province);
						$("#c1").val(this._city);
						$("#d1").val(this._district);
					});
					$("#a1").val(r.point.lng);
					$("#b1").val(r.point.lat);
				}
				else {
					alert('failed' + this.getStatus());
				}
			}, { enableHighAccuracy: true });
			$("#name").val(options.data.MC);
			//$("#SearchL").bind("click", function () {
			//	_that._searchByStationName();                       //调用定位当前位置事件
			//});
			_that._hidden();
			//_that._lmap.addEventListener("dragend", function () {
			//	//$.util.debug();
			//	alert("拖动事件");
			//	var centerPoint = _that._lmap.getCenter();
			//	_that._lmap.clearOverlays();
			//	var marker = new BMap.Marker(new BMap.Point(centerPoint.lng, centerPoint.lat));  // 创建标注
			//	_that._lmap.addOverlay(marker);
			//});
		} 
		else if (options.data.table == 'KH101' && options.data.enable == false) {
			var query = new $.server.queryOptions();
			query.PrimaryTable = "SS204";
			query.FieldNameList = "*";
			query.ConditionExpr = "SS204.ID IN ('" + options.data.BM + "')";
			$.server.query(query, function (data) {
				var pointX = [];
				var pointY = [];
				var pointName = [];
				var pointAds = [];
				$.each(data.DataSource, function (key, val) {       //数组循环
					pointX.push(val['SS204_A02']);
					pointY.push(val["SS204_A03"]);
					pointName.push(val["SS204_A01"]);
					pointAds.push(val["SS204_A06"]);
				});
				var $lmap = $("<div id='lkmap'style='border:1px solid gray;width:" + _that._mapwidth + "px;height:" + _that._mapheight + "px;'></div>");
				_that._dialog.addContent($lmap);
				_that._dialog.open();
				_that._lmap = new BMap.Map("lkmap");
				_that._lmap.width = _that._mapwidth;
				_that._lmap.height = _that._mapheight;
				var point = new BMap.Point(pointX, pointY);
				var marker = new BMap.Marker(point);
				_that._lmap.centerAndZoom(point, _that._level);
				var opts = {
					width: 230,
					height: 40,
					title: "名称：" + pointName + "",
					enableMessage: true,
					message: "稍等片刻，猛戳我"
				}
				var infoWindow = new BMap.InfoWindow("地址:" + pointAds + "", opts);
				_that._lmap.openInfoWindow(infoWindow, point);
				marker.addEventListener("click", function () {
					_that._lmap.openInfoWindow(infoWindow, point);
				});
				_that._addMapControl();
				_that._lmap.addOverlay(marker);
				marker.disableDragging();       //点不可拖拽，可拖拽是enableDragging（）
			});
			this._DialogCL();
		} else if (options.data.table == "KH101" && options.data.enable == true) {
			if (options.data.BM != "") {
				var query = new $.server.queryOptions();
				query.PrimaryTable = "SS204";
				query.FieldNameList = "*";
				query.ConditionExpr = "SS204.ID IN ('" + options.data.BM + "')";
				$.server.query(query, function (data) {
					var ptX = [];
					var ptY = [];
					var ptName = [];
					var ptAds = [];
					$.each(data.DataSource, function (key, val) {       //数组循环
						ptX.push(val['SS204_A02']);
						ptY.push(val["SS204_A03"]);
						ptName.push(val["SS204_A01"]);
						ptAds.push(val["SS204_A06"]);
					});
					var $lmap = $("<div id='lkmap'style='border:1px solid gray;width:" + _that._mapwidth + "px;height:" + _that._mapheight + "px;'></div><div id='TextArea'style='display: none' onMouseout='hidden();'>名称：<input type='text' id='name'/><br/>经度：<input type='text' id='a1'/><br/>纬度：<input type='text' id='b1'/><br/>地址：<input type='text' id='address'/>省份：<input type='text' id='p1'/><input type='text' id='c1'/><input type='text' id='d1'/><input type='text' id='s1'/></div> 请输入地址: <input id='text_' type='text' style='width:200px; margin-right:20px;' />查询结果(经纬度)：<input id='result_' type='text' /><input type='button' value='查询' id='SearchL'/>");
					_that._dialog.addContent($lmap);
					_that._dialog.open();
					_that._lmap = new BMap.Map("lkmap");
					_that._lmap.width = _that._mapwidth;
					_that._lmap.height = _that._mapheight;
					var point = new BMap.Point(ptX, ptY);
					var marker = new BMap.Marker(point);
					_that._lmap.centerAndZoom(point, _that._level);
					var opts = {
						width: 230,
						height: 40,
						title: "名称：" + ptName + "",
						enableMessage: true,
						message: "稍等片刻，猛戳我"
					}
					var infoWindow = new BMap.InfoWindow("地址:" + ptAds + "", opts);
					_that._lmap.openInfoWindow(infoWindow, point);
					_that._addMapControl();
					_that._lmap.addOverlay(marker);
					marker.enableDragging();       //点不可拖拽，可拖拽是enableDragging（）	
					$("#name").val(options.data.MC);
					$("#SearchL").bind("click", function () {
						_that._searchByStationName();                       //调用定位当前位置事件
					});
					_that._hidden();
				});
				this._DialogAD();
			} else {
				this._DialogAD();
				var $lmap = $("<div id='lkmap'style='border:1px solid gray;width:" + _that._mapwidth + "px;height:" + _that._mapheight + "px;'></div><div id='TextArea'style='display: none' onMouseout='hidden();'>名称：<input type='text' id='name'/><br/>经度：<input type='text' id='a1'/><br/>纬度：<input type='text' id='b1'/><br/>地址：<input type='text' id='address'/>省份：<input type='text' id='p1'/><input type='text' id='c1'/><input type='text' id='d1'/><input type='text' id='s1'/></div> 请输入地址: <input id='text_' type='text' style='width:200px; margin-right:20px;' />查询结果(经纬度)：<input id='result_' type='text' /><input type='button' value='查询' id='SearchL'/>");
				_that._dialog.addContent($lmap);
				_that._dialog.open();
				_that._lmap = new BMap.Map("lkmap");
				_that._lmap.width = _that._mapwidth;
				_that._lmap.height = _that._mapheight;
				var point = new BMap.Point(_that._x, _that._y);
				_that._lmap.centerAndZoom(point, _that._level);
				_that._addMapControl();
				var geolocation = new BMap.Geolocation();
				geolocation.getCurrentPosition(function (r) {
					if (this.getStatus() == BMAP_STATUS_SUCCESS) {
						var mk = new BMap.Marker(r.point);
						_that._lmap.addOverlay(mk);
						_that._lmap.panTo(r.point);
						mk.enableDragging();
						var geoc = new BMap.Geocoder();
						var point = new BMap.Point(r.point.lng, r.point.lat);
						geoc.getLocation(point, function (rs) {
							var addComp = rs.addressComponents;
							var address = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
							this._province = addComp.province;
							this._city = addComp.city;
							this._district = addComp.district;
							this._street = addComp.street;
							$("#address").val(address);
							$("#p1").val(this._province);
							$("#c1").val(this._city);
							$("#d1").val(this._district);
						});
						$("#a1").val(r.point.lng);
						$("#b1").val(r.point.lat);
					}
					else {
						alert('failed' + this.getStatus());
					}
				}, { enableHighAccuracy: true });
				$("#name").val(options.data.MC);
				$("#SearchL").bind("click", function () {
					_that._searchByStationName();                       //调用定位当前位置事件
				});
				_that._hidden();
			}
		}
	}
}
this.getMap = function () {
	return $("#lkmap", this_dialog.getContent()).ctl();
}
this.afterClose = function (ev) {
	if ($.isFunction(ev)) {
		this._options.afterClose = ev;
	}
}
