function FieldSet(options) {
    var _that = this;
    this._dialog = null;
    this._table = null;
    this._options = $.extend({
        data: null,
        afterClose: function (op) { }
    }, options);

    this._new = function (isNew) {
        if (isNew) {
            _that._isNew = true;
            $("#fieldset_Cancel", _that._dialog.getContent()).show();
            $("#fieldset_Add", _that._dialog.getContent()).hide();
            $("#fieldset_Del", _that._dialog.getContent()).hide();
            $("#fieldset_Def", _that._dialog.getContent()).hide();
            $("#fieldset_txt", _that._dialog.getContent()).show().focus();
            $("#fieldset_prj_pnl", _that._dialog.getContent()).hide();
            _that._showField();
        } else {
            _that._isNew = false;
            $("#fieldset_Cancel", _that._dialog.getContent()).hide();
            $("#fieldset_Add", _that._dialog.getContent()).show();
            $("#fieldset_Del", _that._dialog.getContent()).show();
            $("#fieldset_Def", _that._dialog.getContent()).show();
            $("#fieldset_txt", _that._dialog.getContent()).val("").hide();
            $("#fieldset_prj_pnl", _that._dialog.getContent()).show();
        }
    }

    this.open = function (options) {
        _that._options = $.extend(_that._options, options);
        _that._dialog = new DialogWindow({
            title: "字段显示方案",
            beforeClose: function (op) {
                if (op) {
                    
                    var data = _that._getData();
                    _that._save(data, function (result) {
                        _that._dialog.close();
                        if ($.isFunction(_that._options.afterClose)) {
                            _that._options.afterClose({
                                projectId: result[0]
                            });
                        }
                    });
                    return false;
                }
                return true;
            }
        });
        var $content = $("<div class='container-fluid' style='padding-top:15px'></div>");
        var $rh = $("<div class='row'></div>");
        $content.append($rh);
        $rh.append("<div class='col-sm-2'><label>方案名称</label></div>");
        $rh.append("<div class='col-sm-4'><div id='fieldset_prj_pnl'><div id='fieldset_prj'></div></div><input id='fieldset_txt' /></div>");
        $rh.append("<div class='col-sm-6'><div id='fieldset_grp'></div></div>");
        $content.append("<div class='row'><hr/></div>");
        var $tlb = $("#fieldset_grp", $rh);
        var tlb = new ToolBar($tlb);
        tlb.bind([{
            id: "fieldset_Cancel",
            text: "取消",
            click: function () {
                _that._new(false);
                _that._showField();
            }
        }, {
            id: "fieldset_Add",
            text: "新增",
            click: function () {
                _that._new(true);
            }
        }, {
            id: "fieldset_Del",
            text: "删除",
            click: function () {
                var data = _that._getData();
                data["_ROWSTATE"] = 3;
                _that._save(data, function () {
                    _that._showProject();
                });
            }
        }, {
            id: "fieldset_Def",
            text: "设置成默认",
            click: function () {
                var data = _that._getData();
                data["SS205_A06"] = $C.server.currentDate();
                _that._save(data, function () {
                    _that._showProject();
                });
            }
        }]);
        $("#fieldset_Save", $tlb).hide();
        $("#fieldset_Cancel", $tlb).hide();
        var $rc = $("<div class='row'><div id='fieldset_rc'></div></div>");
        $content.append($rc);
        new TabPanel($("#fieldset_rc", $rc), { full: 1 }).bind([{
            title: "显示字段",
            content: "<div class='row'><div class=''></div><div class='col-xs-5'><div id='fieldset_s_tvAll'></div></div><div class='col-xs-1'></div><div class='col-xs-5'><div id='fieldset_s_tvShow'></div></div></div></div>"
        }, {
            title: "排序字段",
            content: "<div class='row'><div class=''></div><div class='col-xs-5'><div id='fieldset_o_tvAll'></div></div><div class='col-xs-0'></div><div class='col-xs-5'><div id='fieldset_o_tvShow'></div></div><div class='col-xs-2'><div id='fieldset_sort_a'></div><div id='fieldset_sort_d'></div></div></div></div>"
        }]);

        new ToolBar($("#fieldset_sort_a", $rc)).bind([{
            text: "升序",
            click: function () {
                var d = $("#fieldset_o_tvShow", _that._dialog.getContent()).ctl().selectItem();
                if (d.data["id"] === undefined) {
                    return;
                }
                d.data.order = true;
                d.set("text", d.data.text.split(" ")[0] + _that._getOrder(d.data.order));
            }
        }]);
        new ToolBar($("#fieldset_sort_d", $rc)).bind([{
            text: "降序",
            click: function () {
                var d = $("#fieldset_o_tvShow", _that._dialog.getContent()).ctl().selectItem();
                if (d.data["id"] === undefined) {
                    return;
                }
                d.data.order = false;
                d.set("text", d.data.text.split(" ")[0] + _that._getOrder(d.data.order));
            }
        }]);

        this._dialog.addContent($content);
        this._showProject();
        this._dialog.open();
    }

    this._showProject = function () {
        _that._new(false);
        var q = new $.server.queryOptions();
        q.PrimaryTable = "SS205";
        q.ConditionExpr = "SS205.A02 = '" + _that._options.type + "' AND (ID LIKE '____________0000______' OR ID LIKE '____________" + $.server.cache.CurrentUser.UserNo.substr(4, 4) + "______')";
        q.OrderExpr = "SS205.A06 DESC";

        $.server.query(q, function (datas) {
            _that._table = datas.Table;
            $("#fieldset_txt", _that._dialog.getContent()).hide().kendoMaskedTextBox({ required: true });
            $("#fieldset_prj", _that._dialog.getContent()).kendoDropDownList({
                dataTextField: "SS205_A01",
                dataValueField: "SS202_ID",
                dataSource: datas.DataSource,
                change: _that._showField
            });
            _that._showField();
        });
    };

    this._showField = function () {
        var data = {};
        var hasPm = true;
        if (!_that._isNew) {
            data = _that.getDdl().dataItem();
            if (data != null && (data["SS205_ID"].substr(0, 4) != $.server.cache.CurrentUser.UserNo.substr(0, 4)
                || data["SS205_ID"].substr(12, 4) != $.server.cache.CurrentUser.UserNo.substr(4, 4))) {
                hasPm = false;
                $("#fieldset_Del", _that._dialog.getContent()).hide();
                $("#fieldset_Def", _that._dialog.getContent()).hide();
                $("#fieldset_sort_a", _that._dialog.getContent()).hide();
                $("#fieldset_sort_d", _that._dialog.getContent()).hide();
            }
            else {
                $("#fieldset_Del", _that._dialog.getContent()).show();
                $("#fieldset_Def", _that._dialog.getContent()).show();
                $("#fieldset_sort_a", _that._dialog.getContent()).show();
                $("#fieldset_sort_d", _that._dialog.getContent()).show();
            }
        }
        if (data == null) {
            return;
        }
        var sad = [{ text: "请拖动字段...", pid: 0 }];
        var ssd = [{ text: "请拖动字段...", pid: 0 }];
        var oad = [{ text: "请拖动字段...", pid: 0 }];
        var osd = [{ text: "请拖动字段...", pid: 0 }];

        var sfield = data["SS205_A03"] == null ? [] : data["SS205_A03"].split(",");
        var ofieldTmp = data["SS205_A04"] == null ? [] : data["SS205_A04"].split(",");
        var ofield = [];
        $(ofieldTmp).each(function () {
            var tmp = this.split(" ");
            ofield.push({
                field: tmp[0],
                order: tmp[1] != "DESC"
            })
        });
        $(_that._options.table.FieldList).each(function () {
            var isShow = false;
            if (this.ColVisible == 0)
                return;
            for (var i = 0; i < sfield.length; i++) {
                if (sfield[i] == this.TableName + "." + this.ColName) {
                    isShow = true;
                    break;
                }
            }
            if (isShow) {
                ssd.push({ id: this.TableName + "." + this.ColName, text: this.TableLable + "."+ this.DisplayLabel, pid: 0 });
            } else {
                sad.push({ id: this.TableName + "." + this.ColName, text: this.TableLable + "." + this.DisplayLabel, pid: 0 });
            }
            var of = null;
            for (var i = 0; i < ofield.length; i++) {
                if (ofield[i].field == this.TableName + "." + this.ColName) {
                    of = ofield[i];
                    break;
                }
            }
            if (of) {
                osd.push({ id: this.TableName + "." + this.ColName, text: this.TableLable + "." + this.DisplayLabel + _that._getOrder(of.order), pid: 0, order: of.order });
            } else {
                oad.push({ id: this.TableName + "." + this.ColName, text: this.TableLable + "." + this.DisplayLabel + _that._getOrder(true), pid: 0, order: true });
            }
        });
        var op = {
            valueField: "id",
            textField: "text",
            parentField: "pid",
            endField: "",
            height: 260
        }
        if (hasPm) {
            op.drag = true;
        }

        new Tree($("#fieldset_s_tvAll", _that._dialog.getContent())).bind(sad, op);
        new Tree($("#fieldset_s_tvShow", _that._dialog.getContent())).bind(ssd, op);
        new Tree($("#fieldset_o_tvAll", _that._dialog.getContent())).bind(oad, op);
        new Tree($("#fieldset_o_tvShow", _that._dialog.getContent())).bind(osd, op);
    }

    this._getOrder = function (order) {
        return " [" + (order ? "升序" : "降序") + "]"
    }

    this.getDdl = function () {
        return $("#fieldset_prj", this._dialog.getContent()).data("kendoDropDownList");
    }

    this._getData = function () {
        var data = null;
        if (_that._isNew) {
            var prjName = $("#fieldset_txt", _that._dialog.getContent()).val();
            data = $.server.create(_that._table);
            data["SS205_A01"] = $("#fieldset_txt", _that._dialog.getContent()).val();
            data["SS205_A02"] = _that._options.type;
        } else {
            data = _that.getDdl().dataItem();
        }
        return data;
    }

    this._save = function (data, callback) {
        if (data["SS205_A01"].length == 0) {
            $.util.info("方案名称不能为空");
            return;
        }

        var sfs = $("#fieldset_s_tvShow", _that._dialog.getContent()).ctl().getDatas();
        var showField = "";
        for (var i = 0; i < sfs.length; i++) {
            if (sfs[i].data.id)
                showField += sfs[i].data.id + ","
        }
        if (showField.length == 0) {
            $.util.info("请先设置显示字段");
            return;
        }

        data["SS205_A03"] = showField.trimEnd(",");

        var ofs = $("#fieldset_o_tvShow", _that._dialog.getContent()).ctl().getDatas();
        var orderField = "";
        for (var i = 0; i < ofs.length; i++) {
            if (ofs[i].data.id)
                orderField += ofs[i].data.id + (ofs[i].data.order ? " ASC" : " DESC") + ","
        }
        data["SS205_A04"] = orderField.trimEnd(",");
        var upData = $.server.updateOptions(_that._table, [data], "SS205", "ID");
        $.server.update(upData, function (ret) {
            callback(ret);
        });
    }

    this.afterClose = function (ev) {
        if ($.isFunction(ev)) {
            this._options.afterClose = ev;
        }
    }
}
