function Filters(options) {
    var _that = this;
    this._dialog = null;
    this._table = null;
    this._options = $.extend({
        data: null,
        afterClose: function (op) { }
    }, options);

    this.open = function (options) {
        _that._options = $.extend(_that._options, options);
        _that._dialog = new DialogWindow({
            title: "列表查询方案",
            beforeClose: function (op) {
                if (op) {
                    _that._save(function (result) {
                        _that._dialog.close();
                        if ($.isFunction(_that._options.afterClose)) {
                            _that._options.afterClose({
                                projectId: result[0]
                            });
                        }
                    });
                    return false;
                }
                return true;
            }
        });
        var $content = $("<div class='container-fluid' style='padding-top:15px'></div>");
        var $rc = $("<div class='row'><div id='fieldset_rc'></div></div>");
        $content.append($rc);
        new TabPanel($("#fieldset_rc", $rc), { full: 1 }).bind([{
            title: "简单查询",
            content: "<div class='row'><div class=''></div><div class='col-xs-5'><div id='fieldset_s_tvAll'></div></div><div class='col-xs-1'></div><div class='col-xs-5'><div id='fieldset_s_tvShow'></div></div></div></div>"
        }, {
            title: "高级查询",
            content: "<div class='row'><div class=''></div><div class='col-xs-5'><div id='fieldset_o_tvAll'></div></div><div class='col-xs-0'></div><div class='col-xs-5'><div id='fieldset_o_tvShow'></div></div><div class='col-xs-2'><div id='fieldset_sort_a'></div><div id='fieldset_sort_d'></div></div></div></div>"
        }]);

        this._dialog.addContent($content);
        this._showProject();
        this._dialog.open();
    }

    this._showProject = function () {
        var q = new $.server.queryOptions();
        q.PrimaryTable = "SS206";
        q.ConditionExpr = "SS206.A01 = '" + _that._options.type + "' AND ID LIKE '0000________0000______'";

        $.server.query(q, function (datas) {
            _that._table = datas.Table;
            if (datas.DataSource == null || datas.DataSource.length == 0) {
                _that._data = $.server.create(_that._table);
                _that._data["SS206_A01"] = _that._options.type;
            } else {
                _that._data = datas.DataSource[0];
            }
            _that._showField();
        });
    };

    this._showField = function () {

        var sad = [{ text: "请拖动字段...", pid: 0 }];
        var ssd = [{ text: "请拖动字段...", pid: 0 }];
        var mad = [{ text: "请拖动字段...", pid: 0 }];
        var msd = [{ text: "请拖动字段...", pid: 0 }];

        var sfield = _that._data["SS206_A02"] == null ? [] : _that._data["SS206_A02"].split(",");
        //var ofieldTmp = data["SS206_A03"] == null ? [] : data["SS206_A03"].split(",");
        //var ofield = [];
        //$(ofieldTmp).each(function () {
        //    var tmp = this.split(" ");
        //    ofield.push({
        //        field: tmp[0],
        //        order: tmp[1] != "DESC"
        //    })
        //});
        $(_that._options.table.FieldList).each(function () {
            var isShow = false;
            if (this.ColVisible == 0)
                return;
            for (var i = 0; i < sfield.length; i++) {
                if (sfield[i] == this.TableName + "." + this.ColName) {
                    isShow = true;
                    break;
                }
            }
            if (isShow) {
                ssd.push({ id: this.TableName + "." + this.ColName, text: this.DisplayLabel, pid: 0 });
            } else {
                sad.push({ id: this.TableName + "." + this.ColName, text: this.DisplayLabel, pid: 0 });
            }
            //var of = null;
            //for (var i = 0; i < ofield.length; i++) {
            //    if (ofield[i].field == this.TableName + "." + this.ColName) {
            //        of = ofield[i];
            //        break;
            //    }
            //}
            //if (of) {
            //    osd.push({ id: this.TableName + "." + this.ColName, text: this.DisplayLabel + _that._getOrder(of.order), pid: 0, order: of.order });
            //} else {
            //    oad.push({ id: this.TableName + "." + this.ColName, text: this.DisplayLabel + _that._getOrder(true), pid: 0, order: true });
            //}
        });
        var op = {
            drag: true,
            valueField: "id",
            textField: "text",
            parentField: "pid",
            endField: "",
            height: 260
        }

        new Tree($("#fieldset_s_tvAll", _that._dialog.getContent())).bind(sad, op);
        new Tree($("#fieldset_s_tvShow", _that._dialog.getContent())).bind(ssd, op);
        //new Tree($("#fieldset_o_tvAll", _that._dialog.getContent())).bind(oad, op);
        //new Tree($("#fieldset_o_tvShow", _that._dialog.getContent())).bind(osd, op);
    }

    this._save = function (callback) {
        var sfs = $("#fieldset_s_tvShow", _that._dialog.getContent()).ctl().getDatas();
        var showField = "";
        for (var i = 0; i < sfs.length; i++) {
            if (sfs[i].data.id)
                showField += sfs[i].data.id + ","
        }
        if (showField.length == 0) {
            $.util.info("请先设置查询字段");
            return;
        }

        _that._data["SS206_A02"] = showField.trimEnd(",");

        //var ofs = $("#fieldset_o_tvShow", _that._dialog.getContent()).ctl().getDatas();
        //var orderField = "";
        //for (var i = 0; i < ofs.length; i++) {
        //    if (ofs[i].data.id)
        //        orderField += ofs[i].data.id + (ofs[i].data.order ? " ASC" : " DESC") + ","
        //}
        //data["SS206_A04"] = orderField.trimEnd(",");
        var upData = $.server.updateOptions(_that._table, [_that._data], "SS206", "ID");
        $.server.update(upData, function (ret) {
            callback(ret);
        });
    }

    this.afterClose = function (ev) {
        if ($.isFunction(ev)) {
            this._options.afterClose = ev;
        }
    }
}
