function Gaode($this, options) {
	var _that = this;
	this._$that = $this;
	this._$that.data("ctrl", _that);
	this._$that.empty();
	this._gdmap = null;
	this._id = "gd-" + $.util.guid();
	this._markers = [];
	this._marker = [];
	this._geoPlaceSearch = null;
	this._geocoder = null;
	this._google = false;
	this._googleLayer = null;
	this._addressInfo = {
		point: null,
		address: null
	};
	this._isBusy = false;
	this._options = $.extend({
		height: null,
		width: null,
		datas: [],
		isTrail: false,
		isReview: true,
		range: 5000,//米
		isSearch: true,
		enable: false
	}, options);

	this._init = function () {    //初始化
		var wh = '';
		if (_that._options.width) {
			wh += "width:" + _that._options.width + ";";
		}
		if (_that._options.height) {
			wh += "height:" + _that._options.height + ";";
		}
		var $gdmap = $("<div id='" + _that._id + "' style='" + wh + "border:1px solid gray;'></div>");
		//<div id='TextArea'style='display: none' onMouseout='hidden();'>名称：<input type='text' id='name'/><br/>经度：<input type='text' id='a1'/><br/>纬度：<input type='text' id='b1'/><br/>地址：<input type='text' id='address'/>省份：<input type='text' id='p1'/><input type='text' id='c1'/><input type='text' id='d1'/><input type='file' capture='camera' accept='image/*'/></div>
		var $addinfo = $("<div class='tip'><input type='text' class='tip-content' disabled='true'/></div>");
		var $google = $("<div class='button-group'><input type='button' class='btn-google-add' value='叠加google地图'/><input type='button' class='btn-google-del' value='移除google地图'/></div>");
		var $search = $("<div><input class='txt-search' type='text'/><input type='button' class='btn-search' value='关键字定位'/></div>")
		var $review = $("<div><input type='button' class='review-start' value='开始回放'/></div>");

		_that._$that.append($gdmap);
		_that._$that.append($addinfo);
		_that._$that.append($google);
		_that._$that.append($search);
		_that._$that.append($review);
		if (!_that._options.isSearch) {
			$search.hide();
		}
		if (!_that._options.isReview) {
			$review.hide();
		}

		_that._getC(".btn-search").click(function () {
			var k1 = $(".txt-search").val();
			_that.placeSearch(k1);
		});
		_that._getC(".btn-google-add").click(function () {
			$C.util.debug();
			_that.enableGoogle(true);
		});
		_that._getC(".btn-google-add").click(function () {
			_that.enableGoogle(false);
		});

		_that._gdmap = new AMap.Map(_that._id, { resizeEnable: true, zoom: 15, height: 200, width: 200 });
		_that._gdmap.setFitView();
		//_that._gdmap.plugin(["AMap.ToolBar"], function () {
		//	//设置地位标记为自定义标记
		//	_that._gdmap.addControl(new AMap.ToolBar());
		//});

		_that._gdmap.plugin(["AMap.PlaceSearch"], function () {
			_that._geoPlaceSearch = new AMap.PlaceSearch({
				pageSize: 1,
				pagendex: 1
			});
		});
	}

	this._loadMap = function (points) {
		$C.util.debug();
		if (_that._options.enable) {
			_that._gdmap.on('click', function (e) {
				_that.clearMarker();
				var point = [e.lnglat.getLng(), e.lnglat.getLat()];
				_that.setMarker(point);
				_that._regeocoder(point);
			});
		}
		_that._gdmap.setCenter(new AMap.LngLat(points[0][0], points[0][1]));
		_that.setMarker(points[0]);
	}

	this._getC = function (selector) {
		return $(selector, _that._$that);
	}

	this.setMarker = function (point) {
		var marker = new AMap.Marker({  //加点
			map: _that._gdmap,
			position: point,
			draggable: true,
			icon: new AMap.Icon({
				size: new AMap.Size(40, 50),  //图标大小
				image: "http://gr.wodeoa.com/images/1.png",
				imageOffset: new AMap.Pixel(0, 0)
			})
		});
		//	_that._markers.push(marker);
		if (_that._options.enable) {
			_that._regeocoder(point);
			marker.on('dragend', function (e) {
				_that._regeocoder(point);
			});
		}
	}

	this.completeEventHandler = function (point) {
		_that._marker = new AMap.Marker({
			map: _that._gdmap,
			position: point[0],
			icon: "http://code.mapabc.com/images/car_03.png",
			offset: new AMap.Pixel(-26, -13),
			autoRotation: true
		});
		// 绘制轨迹
		_that._polyline = new AMap.Polyline({
			path: point,
			strokeColor: "#3366FF",  //线颜色
			strokeOpacity: 5,     //线透明度
			strokeWeight: 2,      //线宽
			strokeStyle: "solid"  //线样式
		});
		_that._polyline.setMap(_that._gdmap);
		_that._getC(".review-start").click(function (point) {
			$C.util.debug();
			_that._marker.moveAlong(point);
		});
	}

	this.addMarker = function (point) {
		for (var i = 0; i < point.length; i++) {
			_that._marker = new AMap.Marker({  //加点
				map: _that._gdmap,
				position: point[i]
			});
			_that._markers.push(_that._marker);
		}

	}

	this.clearMarker = function () {
		$C.util.debug();
		//for (var i = 0; i < _that._markers.length - 1; i++) {
			_that._gdmap.remove(_that._markers);
		//}
		//_that._markers = [];
		//_that._gdmap.clearMap();
	}

	this._getGeocoder = function () {
		if (_that._geocoder == null) {
			_that._geocoder = new AMap.Geocoder({
				radius: 1000,
				extensions: "all"
			});
		}
		return _that._geocoder;
	}

	this._regeocoder = function (point) {  //逆地理编码
		_that._isBusy = true;
		this._geocoder.getAddress(point, function (status, result) {
			_that._isBusy = false;
			if (status === 'complete' && result.info === 'OK') {
				var addcom = result.regeocode.addressComponent;
				var address = {
					province: addcom.province,
					city: addcom.city,
					district: addcom.district,
					fullAddress: addcom.province + addcom.city + addcom.district + addcom.street + addcom.streetNumber
				}
				_that._addressInfo = {
					point: point,
					address: address
				};
			} else {
				$.util.info("地址解析失败");
			}
		});
	}

	this.enableGoogle = function (enabled) {
		if (enabled) {
			if (!_that._google) {
				_that._googleLayer = new AMap.TileLayer({
					tileUrl: 'http://mt{1,2,3,0}.google.cn/vt/lyrs=m@142&hl=zh-CN&gl=cn&x=[x]&y=[y]&z=[z]&s=Galil'
				});
				_that._googleLayer.setMap(_that._gdmap);
				_that._google = true;
			}
		}
		else {
			if (_that._googleLayer && _that._google) {
				_that._googleLayer.setMap(null);
			}
		}
	}

	this.placeSearch = function (k1) {
		if (_that._geoPlaceSearch != null) {
			AMap.event.addListener(_that._geoPlaceSearch, "complete", function (data) {
				_that.clearMarker();
				var loc = data.poiList.pois[0].location;
				var point = [loc.getLng(), loc.getLat()]
				_that._gdmap.setCenter(new AMap.LngLat(point[0], point[1]));
				_that.setMarker(point);
				$(".tip-content").val(data.poiList.pois[0].address);
			});
			_that._geoPlaceSearch.search(k1);
		}
		else {
			$.util.info("初始化地图查询定位初始化失败");
		}
	}

	this.load = function (options) {
		_that._options = $.extend(_that._options, options);
		$C.util.debug();
		if ($.util.isMobile()) {
			$.server.location(function (point) {
				_that._loadMap([point]);
			});
		} else {
			_that._gdmap.plugin('AMap.Geolocation', function () {
				_that._geolocation = new AMap.Geolocation({
					enableHighAccuracy: true,       //默认使用高精度定位
					timeout: 10000,                 //超过10秒后停止定位
					convert: true,
					showMarker: false,
					buttomOffset: new AMap.Pixel(10, 20), //定位按钮与设置的停靠位置的偏移量
					zoomToAccuracy: true,           //定位成功后调整地图视野范围使定位位置及精度范围视野内可见
					buttonPosition: 'RB'
				});
				//_that._gdmap.addControl(_that._geolocation);
				_that._geolocation.getCurrentPosition();
				AMap.event.addListener(_that._geolocation, 'complete', function (data) {
					_that._point = [data.position.getLng(), data.position.getLat()];
					_that._loadMap([point]);
				});//返回定位成功信息
			});
		}

	}

	this.AddressInfo = function () {
		if (_that._isBusy) {
			return null;
		}
		return _that._addressInfo;
	}
	this._init();
}
