function GaodeMap(options) {
	var _that = this;
	this._$k = null;
	this._data = null;
	this._options = $.extend({
		title: "高德地图",
		data: null,
		afterClose: function (op) { }
	}, options);
	this._mapheight = 300;
	this._mapwidth = 600;
	this._gdmap = null;
	this._regeocoder = null;
	this._geocoder = null;
	this._geocoder_CallBack = null;
	this._geolocation = null;
	this._point = null;
	this._marker = [];
	this._onComplete = null; 
	this._infoWindow = null;
	this._openInfo = null;
	this._province = null;
	this._city = null;
	this._district = null;
	this._googleLayer = null;
	this._addGoogleLayer = null;
	this._markers = [];
	this._MSearch = null;
	this._placeSearch = null;
	this._completeEventHandler = null;
	this._polyline = null;
	this._pointXY = [];
	this._potlnlg = [];
	this._compute = null;
	this._cirlpoint = [];
	this._dist = null;
	this._addmarker = null;
	this._comname = [];
	this._comaddress = [];

	this._regeocoder = function () {  //逆地理编码
		this._geocoder = new AMap.Geocoder({
			radius: 1000,
			extensions: "all"
		});
		this._geocoder.getAddress(_that._point, function (status, result) {
			//$C.util.debug();
			for (var i = 0; i < _that._markers.length - 1; i++) {
				_that._gdmap.remove(_that._markers[i]);
			}
			result.regeocode.formattedAddress = result.regeocode.addressComponent.province + result.regeocode.addressComponent.city + result.regeocode.addressComponent.district + result.regeocode.addressComponent.street + result.regeocode.addressComponent.streetNumber;
			var address = result.regeocode.addressComponent.province + result.regeocode.addressComponent.city + result.regeocode.addressComponent.district + result.regeocode.addressComponent.street + result.regeocode.addressComponent.streetNumber;
			this._province = result.regeocode.addressComponent.province;
			this._city = result.regeocode.addressComponent.city;
			this._district = result.regeocode.addressComponent.district;
			if (status === 'complete' && result.info === 'OK') {
				_that._geocoder_CallBack(result);
			}
			$("#address").val(address);
			$("#p1").val(this._province);
			$("#c1").val(this._city);
			$("#d1").val(this._district);
			$("#a1").val(_that._point[0]);
			$("#b1").val(_that._point[1]);
		});
		_that._marker = new AMap.Marker({  //加点
			map: this._gdmap,
			position: _that._point,
			draggable: true
		});
		_that._markers.push(_that._marker);
		this._gdmap.setFitView();
	}
	this._geocoder_CallBack = function (data) {
		var address = data.regeocode.formattedAddress; //返回地址描述
		document.getElementById("result").innerHTML = address;
	}
	this._onComplete = function (data) {
		var str = ['定位成功'];
		_that._point = [data.position.getLng(), data.position.getLat()];
		_that._mark = new AMap.Marker({
			map: this._gdmap,
			position: _that._point,
			draggable: true,
			zoom: 10
		});
		_that._regeocoder();
		AMap.event.addListener(_that._marker, 'click', function () {
			_that._regeocoder();
		});
	}
	this._addGoogleLayer = function () {
		_that._googleLayer = new AMap.TileLayer({
			tileUrl: 'http://mt{1,2,3,0}.google.cn/vt/lyrs=m@142&hl=zh-CN&gl=cn&x=[x]&y=[y]&z=[z]&s=Galil'
		});
		_that._googleLayer.setMap(_that._gdmap);
	}
	//在指定位置打开信息窗体
	this._openInfo = function (options, pointAds, lnglatXY) {
		//构建信息窗体中显示的内容
		var info = [];
		var content;
		info.push("名称 :" + options.data.MC + "");
		info.push("地址 :" + pointAds + "");
		infoWindow = new AMap.InfoWindow({
			content: info.join("<br/>")  //使用默认信息窗体框样式，显示信息内容
		});
		infoWindow.open(_that._gdmap, lnglatXY);
	}
	this._placeSearch = function () {
		var k1 = document.getElementById("k1").value;
		_that._gdmap.plugin(["AMap.PlaceSearch"], function () {
			_that._MSearch = new AMap.PlaceSearch({
				pageSize: 10,
				pagendex: 1
			});
			var lngX = null;
			var latY = null;
			AMap.event.addListener(_that._MSearch, "complete", function (data) {
				for (var i = 0; i < _that._markers.length - 1; i++) {
					_that._gdmap.remove(_that._markers[i]);
				}
				var poiArr = data.poiList.pois;
				lngX = poiArr[0].location.getLng();
				latY = poiArr[0].location.getLat();
				_that._gdmap.setCenter(new AMap.LngLat(lngX, latY));
				_that._point = [lngX, latY];
				_that._gdmap.remove(_that._markers);
				_that._marker = new AMap.Marker({  //加点
					map: _that._gdmap,
					position: _that._point,
					draggable: true
				});
				_that._markers.push(_that._marker);
				_that._regeocoder();
				_that._gdmap.setFitView();
			});
			_that._MSearch.search(k1);
		});
	}
	//计算距离
	this._compute = function (p1, p2) {
		var pt1 = p1;
		var pt2 = p2;
		var pk = 180 / 3.14169;
		pt1.x = pt1.x / pk;
		pt1.y = pt1.y / pk;
		pt2.x = pt2.x / pk;
		pt2.y = pt2.y / pk;
		t1 = Math.cos(pt1.y) * Math.cos(pt1.x) * Math.cos(pt2.y) * Math.cos(pt2.x);
		t2 = Math.cos(pt1.y) * Math.sin(pt1.x) * Math.cos(pt2.y) * Math.sin(pt2.x);
		t3 = Math.sin(pt1.y) * Math.sin(pt2.y);
		tt = Math.acos(t1 + t2 + t3);
		_that._dist = 6366000 * tt;  //距离
		return _that._dist;
	}

	this._DialogAD = function (options) {
		this._dialog = new DialogWindow({
			title: _that._options.title,
			afterClose: function (op) {
				if (op == true) {
					$.util.debug();
					var name = $("#name").val();
					var lng = $("#b1").val();
					var lat = $("#a1").val();
					var address = $("#address").val();
					var province = $("#p1").val();
					var city = $("#c1").val();
					var area = $("#d1").val();
					if (options.data.table == 'KH101' && options.data.BM != '') {
						var zbtype = '1';
						var zt = '1'            //判断新增还是修改的状态,默认为0新增，1位修改
					} else if (options.data.table == 'KH101' && options.data.BM == '') {
						var zbtype = '1';
						var zt = '0';
					}
					else {
						var zbtype = '0';
						var zt = '0';
					}
					if (name != "" && lng != "" && lat != "" && address != "" && province != "" && city != "" && area != "") {
						var data = new Array();
						data.push(name);	//名称
						data.push(lng);		//横坐标
						data.push(lat);		//纵坐标
						data.push(zbtype);  //坐标类型,1位客户坐标，2位考勤坐标
						data.push(address); //地址
						data.push(province);//省
						data.push(city);    //市
						data.push(area);    //区
						data.push(zt);
						var querymap = {
							path: "Permission/GetMap/getMap",
							parms: data
						}
						$.server.api(querymap, function (result) {
							$.util.debug();
							if (result != null) {
								var ret = {
									datas: result,
									dialogResult: op    //判断确定或取消.
								};
								if ($.isFunction(_that._options.afterClose)) {
									_that._options.afterClose(ret);
								}
								$.util.info("位置定位成功!");
							} else {
								$.util.error("定位失败!");
							}
						});
					} else {
						$.util.info("请先定位！！");
					}
				}
			}
		});
	}
	this._DialogCL = function () {
		this._dialog = new DialogWindow({
			title: _that._options.title,
			afterClose: function (op) {
				_that._options = $.extend(_that._options, options);
				this._dialog = new DialogWindow({
					title: _that._options.title,
					afterClose: function (op) {
						var grd = _that.getGrid();
						if (grd) {
							var selDatas = grd.select();
							var result = {
								datas: selDatas,
								dialogResult: op
							};
							if ($.isFunction(_that._options.afterClose)) {
								_that._options.afterClose(result);
							}
						}
					}
				});
			}
		});
	}
	this.open = function (options) {
		_that._options = $.extend(_that._options, options);
		this._DialogAD(options);
		if (options.data.table == 'KH101' && options.data.enable == true) {
			var $gdmap = $("<div id='gdmap' style='border:1px solid gray;width:" + _that._mapwidth + "px;height:" + _that._mapheight + "px;'></div><div id='tip'><span id='result'></span></div><div class='button-group' style='top:260px;'><input type='button' id='ad' value='叠加google地图'/><input type='button' id='de' value='移除google地图'/></div><div id='TextArea'style='display: none' onMouseout='hidden();'>名称：<input type='text' id='name'/><br/>经度：<input type='text' id='a1'/><br/>纬度：<input type='text' id='b1'/><br/>地址：<input type='text' id='address'/>省份：<input type='text' id='p1'/><input type='text' id='c1'/><input type='text' id='d1'/><input type='file' capture='camera' accept='image/*'/></div><div><input type='text' id='k1'/><input type='button' id='gjz' value='关键字定位'/></div>");
			_that._dialog.addContent($gdmap);
			_that._dialog.open();
			_that._gdmap = new AMap.Map('gdmap', { resizeEnable: true, zoom: 15 });
			lnglatXY = [118.10388605, 24.48923061]; //已知点坐标
			_that._gdmap.plugin(['AMap.ToolBar'], function () {
				//设置地位标记为自定义标记
				var toolBar = new AMap.ToolBar();
				_that._gdmap.addControl(toolBar);
			});
			$("#name").val(options.data.MC);
			_that._gdmap.on('click', function (e) {
				_that._point = [e.lnglat.getLng(), e.lnglat.getLat()];
				// 实例化点标记
				_that._regeocoder();
			});
			_that._gdmap.plugin('AMap.Geolocation', function () {
				_that._geolocation = new AMap.Geolocation({
					enableHighAccuracy: true,       //默认使用高精度定位
					timeout: 10000,                 //超过10秒后停止定位
					convert: true,
					showMarker: false,
					buttomOffset: new AMap.Pixel(10, 20), //定位按钮与设置的停靠位置的偏移量
					zoomToAccuracy: true,           //定位成功后调整地图视野范围使定位位置及精度范围视野内可见
					buttonPosition: 'RB'
				});
				_that._gdmap.addControl(_that._geolocation);
				_that._geolocation.getCurrentPosition();
				AMap.event.addListener(_that._geolocation, 'complete', _that._onComplete);//返回定位成功信息
			});
			$("#gjz").bind("click", function () {
				_that._placeSearch();
			});

			$("#ad").bind("click", function () {
				_that._addGoogleLayer();
			});
			$("#de").bind("click", function () {
				_that._googleLayer.setMap(null);
			});
		} else if (options.data.table == 'KH101' && options.data.enable == false) {			
			var query = new $.server.queryOptions();
			query.PrimaryTable = "SS204";
			query.FieldNameList = "*";
			query.ConditionExpr = "SS204.ID IN ('" + options.data.BM + "')";
			$.server.query(query, function (data) {
				var pointX = [];
				var pointY = [];
				var pointName = [];
				var pointAds = [];
				var zbmarker = [];//周边点坐标标记
				$.each(data.DataSource, function (key, val) {       //查询已存在公司的坐标位置
					pointX.push(val['SS204_A03']);
					pointY.push(val['SS204_A02']);
					pointName.push(val["SS204_A01"]);
					pointAds.push(val["SS204_A06"]);
				});
				var ptarr = new $.server.queryOptions();
				ptarr.PrimaryTable = "SS204";
				ptarr.FieldNameList = "*";
				ptarr.ConditionExpr = "SS204.A05=1";
				$.server.query(ptarr, function (op) {					//查询所有的公司坐标
					var comname = [];
					var comaddress = [];
					$.each(op.DataSource, function (key1, val1) {				
						_that._compute({ x: val1['SS204_A03'], y: val1['SS204_A02'] }, { x: pointX[0], y: pointY[0] });  // 所有公司坐标与地图中心点公司进行距离计算						
						if (_that._dist > 0 && _that._dist < 3000) {
							comname.push(val1['SS204_A01']);
							comaddress.push(val1['SS204_A06']);
							_that._potlnlg.push([val1['SS204_A03'], val1['SS204_A02']]);//这里要把x,y转换成直接用坐标表示，地图加点数据格式所需						
						}					
					});
					var $gdmap = $("<div id='gdmap' style='border:1px solid gray;width:" + _that._mapwidth + "px;height:" + _that._mapheight + "px;'></div><div class='button-group' style='top:260px;'><input type='button' id='ad' value='叠加google地图'/><input type='button' id='de' value='移除google地图'/></div><div id='panel'>周边客户：<br></div>");
					_that._dialog.addContent($gdmap);
					_that._dialog.open();
					_that._gdmap = new AMap.Map('gdmap', { resizeEnable: true, zoom: 15 });
					lnglatXY = [pointX[0], pointY[0]]; //已知点坐标
					_that._gdmap.plugin(['AMap.ToolBar'], function () {
						//设置地位标记为自定义标记
						var toolBar = new AMap.ToolBar();
						_that._gdmap.addControl(toolBar);
					});								
					var marker = new AMap.Marker({  //加点
						map: _that._gdmap,
						position: lnglatXY,
						icon: new AMap.Icon({
							size: new AMap.Size(40, 50),  //图标大小
							image: "http://gr.wodeoa.com/images/1.png",
							imageOffset: new AMap.Pixel(0,0)
						})
					});
					marker.on('click', function () {
						_that._openInfo(options, pointAds, lnglatXY);
					});
					_that._gdmap.setFitView();

					var infoWindow = new AMap.InfoWindow({ offset: new AMap.Pixel(0, -30) });
					for (var i = 0; i < _that._potlnlg.length; i++) {
						zbmarker = new AMap.Marker({
							map: _that._gdmap,
							position: _that._potlnlg[i],
							offset: new AMap.Pixel(-15,-29),
						});
						//_that._markers.push(zbmarker[i]);
						$p = $('<p>客户名称：' + comname[i] + '<br>客户地址：' + comaddress[i] + "</p>");
						$("#panel").append($p);						
						zbmarker.content = '名称：' + comname[i] + "&nbsp;&nbsp" + '<br/>地址：' + comaddress[i];
						zbmarker.on('click', markerClick);
						zbmarker.emit('click', { target: zbmarker });
						$p.data("position",_that._potlnlg[i]);
						console.log($p);
						$p.bind("click", function (e) {
							infoWindow.setContent(e.target.outerText);
							infoWindow.open(_that._gdmap, $(this).data("position"));
						});
					}
					function markerClick(e) {
						infoWindow.setContent(e.target.content);
						infoWindow.open(_that._gdmap, e.target.getPosition());
					}
					$("#ad").bind("click", function () {
						_that._addGoogleLayer();
					});
					$("#de").bind("click", function () {
						_that._googleLayer.setMap(null);
					});
				});
			});
			this._DialogCL();
		} else if (options.data.table == 'KQ106' && options.data.enable == true) {
			this._DialogAD(options);
			var $gdmap = $("<div id='gdmap' style='border:1px solid gray;width:" + _that._mapwidth + "px;height:" + _that._mapheight + "px;'></div><div id='tip'><span id='result'></span></div><div id='TextArea'style='display: none' onMouseout='hidden();'>名称：<input type='text' id='name'/><br/>经度：<input type='text' id='a1'/><br/>纬度：<input type='text' id='b1'/><br/>地址：<input type='text' id='address'/>省份：<input type='text' id='p1'/><input type='text' id='c1'/><input type='text' id='d1'/><input type='file' capture='camera' accept='image/*'/></div>");
			_that._dialog.addContent($gdmap);
			_that._dialog.open();
			_that._gdmap = new AMap.Map('gdmap', { resizeEnable: true, zoom: 9 });
			lnglatXY = [118.10388605, 24.48923061]; //已知点坐标
			_that._gdmap.plugin(['AMap.ToolBar'], function () {
				//设置地位标记为自定义标记
				var toolBar = new AMap.ToolBar();
				_that._gdmap.addControl(toolBar);
			});
			$("#name").val(options.data.MC);
			_that._gdmap.plugin('AMap.Geolocation', function () {
				_that._geolocation = new AMap.Geolocation({
					enableHighAccuracy: true,       //默认使用高精度定位
					timeout: 10000,                 //超过10秒后停止定位
					convert: true,
					showMarker: false,
					buttonOffset: new AMap.Pixel(10, 20), //定位按钮与设置的停靠位置的偏移量
					zoomToAccuracy: true,           //定位成功后调整地图视野范围使定位位置及精度范围视野内可见
					buttonPosition: 'RB'
				});
				_that._gdmap.addControl(_that._geolocation);
				_that._geolocation.getCurrentPosition();
				AMap.event.addListener(_that._geolocation, 'complete', _that._onComplete);//返回定位成功信息
			});
			_that._gdmap.on('click', function (e) {
				_that._point = [e.lnglat.getLng(), e.lnglat.getLat()];
				// 实例化点标记
				_that._regeocoder();
			});
		} else if (options.data.table == "KQ106" && options.data.enable == false) {
			var query = new $.server.queryOptions();
			query.PrimaryTable = "SS204";
			query.FieldNameList = "*";
			var bm = options.data.BM;
			var BMS = "'0'";
			if (options.data.BM == null) {
				$.util.info("当天尚无签到记录！！");
			} else {
				for (var i = 0; i < bm.length; i++) {
					BMS += ",'" + bm[i] + "'";
				}
				query.ConditionExpr = "SS204.ID IN (" + BMS + ")";
				$.server.query(query, function (data) {
					var lineArr = [];
					var pointName = [];
					var pointAds = [];
					var pointTime = [];
					var pointXY = [];
					var marker = [];
					var pointJL = [];
					var label = [];
					var infoWindow = [];
					$.each(data.DataSource, function (key, val) {       //数组循环
						lineArr = [val["SS204_A03"], val['SS204_A02']];
						marker.push(new AMap.Marker(lineArr));
						pointName.push(val["SS204_A01"]);
						pointAds.push(val["SS204_A06"]);
						pointTime = options.data.MC;
						pointJL = options.data.MCS;
						pointXY.push(lineArr);
					});
					_that._completeEventHandler = function () {
						_that._marker = new AMap.Marker({
							map: _that._gdmap,
							position: pointXY[0],
							icon: "http://code.mapabc.com/images/car_03.png",
							offset: new AMap.Pixel(-26, -13),
							autoRotation: true
						});
						// 绘制轨迹
						_that._polyline = new AMap.Polyline({
							path: pointXY,
							strokeColor: "#3366FF",  //线颜色
							strokeOpacity: 5,     //线透明度
							strokeWeight: 2,      //线宽
							strokeStyle: "solid"  //线样式
						});
						_that._polyline.setMap(_that._gdmap);
					}
					var $gdmap = $("<div id='gdmap' style='border:1px solid gray;width:" + _that._mapwidth + "px;height:" + _that._mapheight + "px;'></div><div id='tip'><span id='result'></span></div><div class='button-group'><input type='button' class='butto' value='开始回放' id='start'/></div>");
					_that._dialog.addContent($gdmap);
					_that._dialog.open();
					_that._gdmap = new AMap.Map('gdmap', { resizeEnable: true, zoom: 9 });
					lnglatXY = [24.48923061, 118.10388605]; //已知点坐标
					_that._gdmap.on('complete', _that._completeEventHandler);
					_that._gdmap.plugin(['AMap.ToolBar'], function () {
						//设置地位标记为自定义标记
						var toolBar = new AMap.ToolBar();
						_that._gdmap.addControl(toolBar);
					});
					_that._gdmap.setFitView();
					for (var i = 0; i < data.DataSource.length; i++) {
						if (i == 0 || i == (data.DataSource.length - 1)) {
							_that._marker = new AMap.Marker({
								map: _that._gdmap,
								position: pointXY[i]
							});
							_that._marker.setLabel({ offset: new AMap.Pixel(20, 5), content: pointJL[i] });
						}
					}
					$("#start").bind("click", function () {
						_that._marker.moveAlong(pointXY, 500);
					});
				});
				this._DialogCL();
			}
		}
	}

	this.getGrid = function () {
		return $("#gdmap", this._dialog.getContent()).ctl();
	}

	this.afterClose = function (ev) {
		if ($.isFunction(ev)) {
			this._options.afterClose = ev;
		}
	}
}
