function LookupMap(options) {
	var _that = this;
	this._$k = null;
	this._data = null;
	this._parms = null;
	this._options = $.extend({
		title: "请选择",
		data: null,
		afterClose: function (op) { }
	}, options);
	this._lmap = null;
	this._mkrTool = null;
	this._curMkr = null;
	this._infoWin = null;

	////地图控件添加函数：
	this._addMapControl = function () {
		//向地图中添加缩放控件
		var ctrl_nav = new BMap.NavigationControl({ anchor: BMAP_ANCHOR_TOP_LEFT, type: BMAP_NAVIGATION_CONTROL_LARGE });
		this._lmap.addControl(ctrl_nav);
		//向地图中添加缩略图控件
		//var ctrl_ove = new BMap.OverviewMapControl({ anchor: BMAP_ANCHOR_BOTTOM_RIGHT, isOpen: 1 });
		//this._lmap.addControl(ctrl_ove);
		//向地图中添加比例尺控件
		var ctrl_sca = new BMap.ScaleControl({ anchor: BMAP_ANCHOR_BOTTOM_LEFT });
		this._lmap.addControl(ctrl_sca);
	}
	//点击获取经纬度  
	this._get_point = function () {
		this._lmap.addEventListener("click", function (e) {   //由于baidu和google经纬度放置顺序不一样，在这统一为google的顺序  
			var point = new BMap.Point(e.point.lng, e.point.lat);   //创建要标注的点  
			var marker = new BMap.Marker(point);  // 创建标注 
			$("#a1").val(e.point.lng);
			$("#b1").val(e.point.lat);
		});
	}
	//用经纬度设置地图中心
	this._theLocation = function () {
		if (document.getElementById("a1").value != "" && document.getElementById("b1").value != "") {
			this._lmap.clearOverlays();
			var new_point = new BMap.Point(document.getElementById("a1").value, document.getElementById("b1").value);
			var marker = new BMap.Marker(new_point);  // 创建标注
			this._lmap.addOverlay(marker);              // 将标注添加到地图中
			this._lmap.panTo(new_point);
		}
	}

	//////打开样式面板
	//this._openStylePnl = function() {
	//	document.getElementById("divStyle").style.display = "block";
	//}

	//选择样式
	this._selectStyle = function (index) {
		this._mkrTool.open(); //打开工具
		//var icon = BMapLib.MarkerTool.SYS_ICONS[index]; //设置工具样式，使用系统提供的样式BMapLib.MarkerTool.SYS_ICONS[0] -- BMapLib.MarkerTool.SYS_ICONS[23]
		//this._mkrTool.setIcon(icon);
		//document.getElementById("divStyle").style.display = "none";
	}



	this.open = function (query, options) {
		_that._options = $.extend(_that._options, options);
		this._dialog = new DialogWindow({
			afterClose: function (op) {
				console.log(op);
				var name = $("#name").val();
				var lng = $("#a1").val();
				var lat = $("#b1").val();

				var data = new Array();
				data.push(name);	//名称
				data.push(lng);		//横坐标
				data.push(lat);		//纵坐标

				var op = {
					path: "Permission/GetMap/getMap",
					parms: data
				}
				$.server.api(op, function (result) {
					result = $.date.objParseDate(result);
					if (result != null) {
						$.util.info("位置定位成功!");
					} else {
						$.util.error("定位失败!");
					}

				});

				var result = {
					datas: [],
					dialogResult: op
				};
				var data = {};
				result.datas.push(data);
				if ($.isFunction(_that._options.afterClose)) {
					_that._options.afterClose(result);
				}
			}
		});
		$.util.debug();
		var $lmap = $("<div id='lkmap'style='border:1px solid gray'></div><div id='putinfo'>名称：<input type='text' id='name'/><br/>经度：<input type='text' id='a1'/><br/>纬度：<input type='text' id='b1'/><input type='button' id='Search' value='定位'/></div>");
		this._dialog.addContent($lmap);
		$lmap.width(570);
		$lmap.height(280);
		this._dialog.open();
		this._lmap = new BMap.Map("lkmap");
		this._lmap.centerAndZoom(new BMap.Point(118.10388605, 24.48923061), 15);
		this._lmap.enableScrollWheelZoom();
		this._addMapControl();
		//拼接infowindow内容字串
		var html = [];
		html.push('<span style="font-size:12px">属性信息: </span><br/>');
		html.push('<table border="0" cellpadding="1" cellspacing="1" >');
		html.push('  <tr>');
		html.push('      <td align="left" class="common">名 称：</td>');
		html.push('      <td colspan="2"><input type="text" maxlength="50" size="18"  id="txtName"></td>');
		html.push('  </tr>');
		html.push('  <tr>');
		html.push('	     <td  align="center" colspan="3">');
		html.push('          <input type="button" id="btnOK" value="确定">&nbsp;&nbsp;');
		html.push('		     <input type="button" id="btnClear" value="重填">');
		html.push('	     </td>');
		html.push('  </tr>');
		html.push('</table>');
		var infoWin = new BMap.InfoWindow(html.join(""), { offset: new BMap.Size(0, -10) });
		this._curMkr = null; // 记录当前添加的Mkr
		this._mkrTool = new BMapLib.MarkerTool(this._lmap, { autoClose: false });
		this._mkrTool.addEventListener("markend", function (evt) {
			var mkr = evt.marker;
			mkr.openInfoWindow(infoWin);
			//重填数据
			$.util.debug();
			$("#btnOK").bind("click", function () {
				//var name = encodeHTML(document.getElementById("txtName").value);
				var name = document.getElementById("txtName").value;
				if (!name) {
					alert("星号字段必须填写");
					return;
				}
				$("#name").val(name);
				if (infoWin.isOpen()) {
					mkr.closeInfoWindow();
				}
				//在此用户可将数据提交到后台数据库中
			});
			$("#btnClear").bind("click", function () {
				$("#txtName").val("");
			});

			$("#Search").bind("click", function () {
				this._theLocation();
			});
			this._curMkr = mkr;

		});

		this._selectStyle();
		this._get_point();
		//$("#bt1").onclick
		//this._dialog.open();

	}

	this.getMap = function () {
		return $("#lkmap", this_dialog.getContent()).ctl();
	}

	this.afterClose = function (ev) {
		if ($.isFunction(ev)) {
			this._options.afterClose = ev;
		}
	}
}
