function DialogWindow(options) {
    var _that = this;
    this._options = $.extend({
        isFilter: false
    }, options);
    this._id = $.util.guid();
    this._$that = $("<div id='" + this._id + "'></div>");
    this._dialog = null;

    this._init = function () {
        var html = [];
        html.push("<div class='widget' style='margin:0;' id='pnl_" + _that._id + "'>");
        html.push("<div class='widget-header' style='" + (_that._options.isFilter ? "" : "display:none;") + "'>");
        html.push("<span class='widget-caption' style='margin-right: 10px;'></span>");
        html.push("<span class='widget-caption custom'></span>");
        html.push("<span class='widget-caption filters'></span>");
        html.push("</div>");
        html.push("<div class='widget-body' style='padding:0'></div>");
        html.push("</div>");
        _that._$that.append($.util.join("", html));
        return $(".widget-body", _that._$that);
    }

    this.getContent = function () {
        return this._$content;
    };

    this.open = function () {
        _that._dialog = bootbox.dialog({
            message: _that._$that,
            title: _that._options.title,
            className: "modal-palegreen",
            buttons: {
                "确认": {
                    className: "btn-primary",
                    callback: function (e) {
                        if ($.isFunction(_that._options.beforeClose)) {
                            return options.beforeClose(true);
                        }
                        _that.close(true);
                        return false;
                    }
                },
                "取消": {
                    className: "btn-warning",
                    callback: function (e) {
                        if ($.isFunction(_that._options.beforeClose)) {
                            return options.beforeClose(false);
                        }
                        _that.close(false);
                        return false;
                    }
                }
            }
        });
    }

    this.close = function (ret) {
        _that._dialog.modal("hide");
        if ($.isFunction(_that._options.afterClose)) {
            options.afterClose(ret);
        }
    }

    this.addContent = function ($content) {
        $content.appendTo(_that._$content);
        return this;
    }

    this._$content = _that._init();

}
