function Grid($this) {
    var _that = this;
    this._$that = $this;
    this._$that.data("ctrl", _that);
    this._$that.empty();
    this._$k = null;
    this._frm = null;
    this._init = 0;
    this._query = null;
    this._table = null;
    this._data = null;
    this._total = 0;
    ///创建架构
    this._createSchema = function (cols) {
        var fields = {};
        $(cols).each(function () {
            var fName = this.TableName + "_" + this.ColName;
            fields[fName] = {};
            if (this.ColVisible == 2) {
                fields[fName].editable = false;
            }
            else {
                fields[fName].editable = true;
            }
            if (!this.ColNull) {
                //fields[fName].validation = { required: true };
            }
            switch (this.ColType) {
                case "INT IDENTITY":
                case "SMALLINT":
                case "INT":
                case "INTYINT":
                case "NUMERIC":
                    fields[fName].type = "number";
                    fields[fName].format = "{0:d}";
                    break;
                case "DATETIME":
                    fields[fName].type = "date";
                    fields[fName].format = "{0:" + (this.DisplayFormat || "yyyy-MM-dd") + "}";
                    break;
                default:
                    fields[fName].type = "string";
                    break;
            }
        });

        return fields;
    };
    ///控制显示数据及其格式
    this._createCols = function (cols) {
        var defWidth = 46;
        var i = 0;
        var fields = [];
        fields.push({
            field: "ROW_NUM",
            title: "序",
            filterable: false,
            width: 35,
            editor: function (container, model) {
                container.append("<span class='row-number'>" + (container.parent().index() + 1) + "</span>");
            },
            template: "<span class='row-number'></span>",

        });
        i++;
        var isLocked = false;
        //if (_that.afterRowDetails != null)
        //    isLocked = false;
        if (_that._options.isMulti) {
            var chk = {
                id: "chk",
                headerTemplate: "<label style='margin-bottom: 0'><input id='chkAll' type='checkbox'><span class='text'></span></label>",
                template: "<div><input type='checkbox' style='opacity:100;position:static;margin:0' class='colored-blue chk-select' /></div>",
                editor: "#<div></div>#",
                width: 35,
                locked: isLocked
            }
            fields.push(chk);
            i++;
        }
        defWidth += 60;

        if (_that._options.formMode == 2 || _that._options.command) {
            var cmds = {
                groupable: false,
                attributes: {
                    style: "white-space:nowrap;"
                },
                headerTemplate: "",
                locked: isLocked
            }
            var cmdHeader = [];
            cmdHeader.push("<div>");
            var cmd = [];
            cmd.push("<div>");
            var width = 10;
            if (_that._options.formMode == 2) {
                width += 24 * 2;
                cmdHeader.push("<a style='padding:0 4px;font-size: 16px;' href='javascript:void(0)' class='tooltips tooltip-primary gray icon fa fa-plus-square-o' data-toggle='tooltip' data-placement='right' data-original-title='新增'></a>");
                cmd.push("<a style='padding:0 4px;font-size: 16px;' href='javascript:void(0)' class='cmd themeprimary icon fa fa-plus-square-o' cmd-name='add' guid='#=uid #'></a>");
                cmdHeader.push("<a style='padding:0 4px;font-size: 16px;' href='javascript:void(0)' class='tooltips tooltip-primary gray icon fa fa-minus-square-o' data-toggle='tooltip' data-placement='right' data-original-title='删除'></a>");
                cmd.push("<a style='padding:0 4px;font-size: 16px;' href='javascript:void(0)' class='cmd themeprimary icon fa fa-minus-square-o' cmd-name='del' guid='#=uid #'></a>");
            }
            if (_that._options.command) {
                $(_that._options.command).each(function (index) {
                    width += 24;
                    cmdHeader.push("<a style='padding:0 4px;font-size: 16px;' href='javascript:void(0)' class='tooltips tooltip-primary gray icon " + this.icon + "' data-toggle='tooltip' data-placement='right' data-original-title='" + this.text + "'></a>");
                    cmd.push("<a style='padding:0 4px;font-size: 16px;' href='javascript:void(0)' class='cmd themeprimary icon " + this.icon + "' cmd-name='" + this.text + "' guid='#=uid #'></a>");
                });
            }
            cmdHeader.push("</div>");
            cmd.push("</div>");
            cmds.headerTemplate = $.util.join("", cmdHeader);
            cmds.template = $.util.join("", cmd);
            cmds.width = width;
            fields.push(cmds);

            i++;
            defWidth += cmds.width;
        }
        var tWidth = 0;
        var fieldlist = cols.sort(function (a, b) {
            return a.ProjectOrder - b.ProjectOrder;
        });
        $(fieldlist).each(function () {
            if (this.GridVisible() == 0)
                return;
            var dbField = this;
            var field = {
                groupable: false,
                attributes: {
                    style: "white-space:nowrap;"
                }
            };
            if (_that._options.formMode == 2) {
                field.editor = function (container, options) {
                    var field = dbField;
                    switch (field.ColVisible) {
                        /*不可见*/
                        case 0:
                            field.editable = false;
                        case 1:
                            field.editable = true;
                            break;
                        case 2:
                            field.editable = false;
                            break;
                        case 3:
                            field.editable = data["_ROWSTATE"] == 1 ? true : false;
                            break;
                    }
                    if (this.ColRight == 2) {
                        field.editable = false;
                    }
                    if (_that._options.opeMode == 0) {
                        field.editable = false;
                    }
                    if (!field.editable)
                        return;

                    var data = options.model;
                    var isHandle = false;
                    if (field.EditFormat) {
                        var edits = field.EditFormat.replace('(', '|').replace(')', '|').split('|');
                        if (edits[0] == "CHECK") {
                            $.field.createCheckBox(field, container);
                            isHandle = true;
                        }
                        else if (edits[0] == "MEMO") {
                            $.field.createTextarea(field, container);
                            isHandle = true;
                        }
                        else if (edits[0] == "AUTO" || edits[0] == "CODE" || edits[0] == "LOOK") {
                            if (edits[0] == "AUTO" || edits[0] == "CODE") {
                                edits[2] = "BM0000";
                                edits[3] = "MC0000";
                            }
                            var ps = {};
                            if (field.Parms) {
                                ps = $.evalJSON(field.Parms);
                            }
                            $.field.createLookup(field, container, data, edits, ps, fieldlist, true);
                            isHandle = true;
                        }
                    }
                    if (!isHandle) {
                        switch (field.ColType) {
                            case "INT":
                            case "NUMERIC":
                            case "DECIMAL":
                                $.field.createNumericTextBox(field, container);
                                break;
                            case "DATETIME":
                                $.field.createDateTimePicker(field, container);
                                break;
                            default:
                                $.field.createTextbox(field, container);
                                break;
                                //日期 短日期 富文本 
                        }
                    }
                }
            }
            var fotmat = "";
            switch (this.ColType) {
                case "INT IDENTITY":
                case "SMALLINT":
                case "INT":
                case "INTYINT":
                case "NUMERIC":
                    if (_that._options.isTotal && this.EditFormat != "CHECK(|1|0)") {
                        field.footerTemplate = "合计: #: sum == null ? 0 : sum.toFixed(2) #";
                    }
                    field.ttype = "number";
                    break;
                case "DATETIME":
                    field.ttype = "date";
                    fotmat = (this.DisplayFormat || "yyyy-MM-dd");
                    break;
                default:
                    field.ttype = "string";
                    break;
            }
            field.defaultValue = this.ColDefault;
            field.field = this.TableName + "_" + this.ColName;

            if (this.EditFormat.startsWith("LOOK") || this.EditFormat.startsWith("CODE") || this.EditFormat.startsWith("AUTO")) {
                field.field += "MC";
            }

            if (this.EditFormat == "CHECK(|1|0)") {
                field.template = "<label><input type='checkbox' disabled='disabled' #= " + this.TableName + "_" + this.ColName + " == 1 ? 'checked': ''#><span class='text'></span></label>";
            } else {
                var fv = "#= $.util.toString(" + field.field + ",'" + fotmat + "')#"
                if (_that._options.linkField && _that._options.linkField.indexOf(this.TableName + "_" + this.ColName) > -1) {
                    fv = "<a href='javascript:void(0)' class='grid-command' field='" + this.TableName + "_" + this.ColName + "'>" + fv + "</a>";
                }
                if (_that._options.isWarp) {
                    field.template = "<pre style='padding: 0px;margin: 0;background-color: initial;border:0'>" + fv + "</pre>";
                } else {
                    field.template = "<span title='#= $.util.toString(" + field.field + ",'" + fotmat + "')#'>" + fv + "</span>";
                }
            }
            field.title = this.DisplayLabel;
            field.width = this.DisplayWidth || 100;
            tWidth += field.width;
            fields.push(field);
        });
        var cWidth = _that._$that.width() - defWidth - tWidth - 5;
        if (cWidth > 0) {
            if (fields.length > i) {
                var t = i;
                for (; i < fields.length; i++) {
                    fields[i].width += cWidth / (fields.length - t);
                }
            }
        }

        return fields;
    };

    ///控制显示合计
    this._createAggregate = function (cols) {
        var aggregates = null;
        if (_that._options.isTotal) {
            aggregates = [];
            $(cols).each(function () {
                if (this.GridVisible() == 0)
                    return;
                switch (this.ColType) {
                    case "INT IDENTITY":
                    case "SMALLINT":
                    case "INT":
                    case "INTYINT":
                    case "NUMERIC":
                        if (this.EditFormat != "CHECK(|1|0)") {
                            aggregates.push({
                                field: this.TableName + "_" + this.ColName,
                                aggregate: "sum"
                            })
                        }
                        break;
                    default:
                        break;
                }
            });
        }

        return aggregates;
    };
    ///获取K控件
    this._getKGrid = function () {
        if (_that._$k == null)
            return null;
        return _that._$k.data("kendoGrid");
    };

    ///新增一个空对象
    this._createNew = function (index) {
        if (index === undefined) {
            index = _that.getDatas().length;
        }
        var newData = $.server.create(_that.getTable());
        $.util.trigger(this.beforeAdd, { datas: [newData] }, function () {
            newData = _that.getDataSource().insert(index, newData);
            var table = _that._getKGrid().lockedContent ? _that._getKGrid().lockedTable : _that._getKGrid().table;
            var row = table.find("tr:eq(" + index + ")");
            _that.select([newData]);
            var $locked = _that._$k.find(".k-grid-content-locked");
            $locked.removeAttr("style");
            _that._getKGrid().cancelRow();
            _that._getKGrid().editRow(row);
            $(row).removeClass("k-state-selected");
        });
    }

    this._openForm = function (q, options) {
        var $pnl = null;
        if (_that._options.formId) {
            $pnl = $("#" + _that._options.formId);
        } else {
            var $pnl = $C(".grid-form", _that._$that)
            if ($pnl.length == 0) {
                var $pnl = $("<div class='grid-form'></div>");
                $pnl.prependTo(_that._$that);
            }
            _that._$k.hide();
        }
        $pnl.empty();

        _that._frm = $.ctrl.openForm($pnl, q, $.extend({}, options, {
            afterClose: function () {
                _that._frm = null;
                _that._$k.show();
            },
            isSave: _that._options.formIsSave,
            isCancel: _that._options.formIsCancel,
        }));
        _that._frm.afterSave = function (op) {
            $.util.info("保存成功");
            _that.refresh();
        }
        return _that._frm;
    };

    this._initCtrl = function () {
        $(_that._getKGrid().items()).each(function () {
            var index = $(this).index() + 1;
            $($(this).find(".row-number")).html(index);
        });

        var $locked = _that._$k.find(".k-grid-content-locked");
        var width = $locked.width();
        $locked.removeAttr("style");
        $locked.width(width);
        var chks = _that._$k.find(".chk-select");
        chks.click(function () {
            var trsLock = $(".k-grid-content-locked tr", _that._$k)
            var trs = $(".k-grid-content tr", _that._$k);
            for (var i in chks) {
                if (chks[i] === this) {
                    var isSelected = $(this).prop("checked");
                    if (isSelected) {
                        $(trsLock[i]).attr("aria-selected", "true").addClass("k-state-selected");
                        $(trs[i]).attr("aria-selected", "true").addClass("k-state-selected");
                    } else {
                        $(trsLock[i]).attr("aria-selected", "false").removeClass("k-state-selected");
                        $(trs[i]).attr("aria-selected", "false").removeClass("k-state-selected");
                    }
                }
            }
            $.util.trigger(_that.afterSelect, {
                datas: _that.select()
            });
        });
        _that._$that.find(".grid-command").click(function () {
            var $tr = $(this).closest("tr");
            var data = _that._getKGrid().dataItem($tr);
            $.util.trigger(_that.afterLinkClick, {
                field: $(this).attr("field"),
                data: data
            });
            return false;
        });

        $C('.tooltips').tooltip();
        $C('.cmd', _that._$that).click(function (e) {
            var tr = $(this).closest("tr");
            var data = _that._getKGrid().dataItem(tr);
            if ($(this).attr("guid") != data.uid) {
                return false;
            }
            var cmdName = $(this).attr("cmd-name");
            if (cmdName == "add") {
                var index = _that.getDataSource().indexOf(data)
                _that._createNew(index + 1);
                return false;
            } else if (cmdName == "del" && $(this).attr("guid") == data.uid) {
                if (_that._options.formMode == 2) {
                    _that.getDataSource().remove(data);
                    if (_that.getDataSource()._data.length == 0) {
                        _that._createNew(0);
                    }
                    return false;
                }
            }
            else {
                $(_that._options.command).each(function () {
                    if (this.text == cmdName) {
                        if ($.isFunction(this.click)) {
                            this.click({
                                text: cmdName,
                                data: data
                            })
                        }
                    }
                });
            }
        })

        if (_that._frm != null) {
            if (_that._frm._$that)
                _that._frm._$that.parent().remove();
            _that._frm = null;
        }
    }

    this._validate = function (data) {
        for (var i = 0; i < _that.getTable().FieldList.length; i++) {
            var f = _that.getTable().FieldList[i];
            if (f.ColVisible != 0 && f.ColNull == 0) {
                if (data[f.TableName + "_" + f.ColName] == null || data[f.TableName + "_" + f.ColName].length == 0) {
                    return f.DisplayLabel + "不能为空";
                }
            }
        }
        return null;
    }

    ///列生成前事件
    this.beforeField = $.util.defaultEvent;
    ///绑定前事件
    this.beforeLoad = $.util.defaultEvent;
    ///绑定后事件
    this.afterLoad = $.util.defaultEvent;
    ///选中后事件
    this.afterSelect = $.util.defaultEvent;
    ///数据改变后事件
    this.afterChange = $.util.defaultEvent;
    ///更新前事件
    this.beforeSave = $.util.defaultEvent;
    ///更新后事件
    this.afterSave = $.util.defaultEvent;
    ///新增数据前事件
    this.beforeAdd = $.util.defaultEvent;
    ///行展开事件
    this.afterRowDetails = null;
    ///行展开事件
    this.afterLinkClick = $.util.defaultEvent;

    ///获取查询参数
    this.getQuery = function () {
        return _that._query;
    };
    ///获取表结构
    this.getTable = function () {
        return _that._table;
    };
    ///获取数据源
    this.getDataSource = function () {
        if (_that._getKGrid()) {
            return _that._getKGrid().dataSource;
        }
        return null;
    };
    ///获取数据
    this.getDatas = function () {
        if (_that._getKGrid()) {
            return _that._getKGrid().dataSource.data();
        }
        return null;
    };
    ///获取查询参数
    this.getOptions = function () {
        return _that._options;
    };
    ///全选
    this.selectAll = function (isSelect) {
        this.select(isSelect ? _that.getDatas() : []);
    };
    ///获取选中
    this.select = function (datas) {
        if (datas === undefined) {
            var result = [];
            var kgrd = _that._getKGrid();
            if (kgrd) {
                var trs = kgrd.select();
                $(trs).each(function (i) {
                    var d = kgrd.dataItem(trs[i]);
                    if (d) {
                        var isExists = false;
                        for (var i in result) {
                            if (result[i].uid == d.uid)
                                isExists = true;
                        }
                        if (!isExists) {
                            result.push(d);
                        }
                    }
                });
            }
            return result;
        } else {
            _that._$k.find(".chk-select").prop("checked", false);
            $("tr", _that._$k).attr("aria-selected", "false").removeClass("k-state-selected");

            var kgrd = _that._getKGrid();
            if (kgrd) {
                var chks = _that._$k.find(".chk-select");
                $("tbody tr", _that._$k).each(function (index) {
                    var d = kgrd.dataItem(this);
                    for (var i = 0; i < datas.length; i++) {
                        if (d === datas[i]) {
                            $(chks[index]).prop("checked", true);
                            $(this).attr("aria-selected", "true").addClass("k-state-selected");
                        }
                    }
                })
            }
            $.util.trigger(_that.afterSelect, {
                datas: _that.select()
            });
        }
        return false;
    };

    ///数据加载
    this.load = function (q, options) {
        _that._oriQuery = $.extend(new $.server.queryOptions(), q);
        if (!$.util.isMobile()) {
            $page.addFilters({
                query: _that._oriQuery,
                widget: _that._$that.hasClass("grid-row-details") ? null : _that._$that.parents(".widget")
            }, function (query) {
                _that._query = $.extend(new $.server.queryOptions(), query);
                _that._options = $.extend({
                    formMode: 1, //1为表单编辑，2为表格编辑
                    formId: "",
                    formIsSave: true,
                    formIsCancel: true,
                    isWarp: false,//是否单元格换行
                    isTotal: false, //是否合计
                    isMenu: true,
                    isCache: true,
                    isFull: false, //是否匹配满屏
                    isMulti: true, //是否多选
                    isPage: true, //是否分页
                    command: null, // 格式为数组 [{ text: "按钮名称", click: null},{ text: "按钮名称2", click: null}]
                    linkFiled: null, //格式为 字段名称1|字段名称2|字段名称3
                }, options);
                if (_that._query != null && _that._query.PageSize == 10000 && _that._options.formMode == 1 && _that._options.isPage) {
                    _that._query.PageSize = 10;
                }
                $.server.query(_that._query, function (data) {
                    _that.bind(data, _that._options);
                }, _that._options.isCache);
            });
        } else {
            _that._query = $.extend(new $.server.queryOptions(), q);
            _that._options = $.extend({
                formMode: 1, //1为表单编辑，2为表格编辑
                formId: "",
                formIsSave: true,
                formIsCancel: true,
                isWarp: false,//是否单元格换行
                isTotal: false, //是否合计
                isMenu: true,
                isCache: true,
                isFull: false, //是否匹配满屏
                isMulti: true, //是否多选
                isPage: true, //是否分页
                command: null, // 格式为数组 [{ text: "按钮名称", click: null},{ text: "按钮名称2", click: null}]
                linkFiled: null, //格式为 字段名称1|字段名称2|字段名称3
            }, options);
            if (_that._query != null && _that._query.PageSize == 10000 && _that._options.formMode == 1 && _that._options.isPage) {
                _that._query.PageSize = 10;
            }
            $.server.query(_that._query, function (data) {
                _that.bind(data, _that._options);
            }, _that._options.isCache);
        }
    };

    ///数据绑定
    this.bind = function (data, options) {
        _that._init = 0; // 避免重复查询 zxilu 2015-10-02
        if (_that._$k != null) {
            _that._$k.remove();
        }
        _that._$k = $("<div></div>");
        _that._$k.appendTo(_that._$that);
        _that._options = $.extend({
            formMode: 1, //1为表单编辑，2为表格编辑
            formId: "",
            formIsSave: true,
            formIsCancel: true,
        }, options);
        if (_that._options.isFull) {
            var height = $(window).height() - _that._$that.offset().top - 20;
            if (height > 0) {
                _that._options.height = height;
            }
        }

        if (_that._options.height)
            _that._$k.height(_that._options.height);
        _that._table = data.Table;
        _that._data = data.DataSource;
        _that._total = data.Total;
        $.util.trigger(_that.beforeField, {
            table: _that._table,
            data: _that._data
        }, function () {
            var dataSource = {
                data: [],
                aggregate: _that._createAggregate(data.Table.FieldList),
                schema: {
                    model: {
                        id: _that._table.FieldList[0].TableName + "_ID",
                        fields: _that._createSchema(data.Table.FieldList)
                    },
                    total: function () {
                        return _that._total;
                    }
                },
                pageSize: _that._query ? _that._query.PageSize : 10000,
                page: _that._query ? _that._query.PageIndex : 1,
                serverPaging: _that._query ? true : false,
                batch: true,
                transport: {
                    read: function (op) {
                        $.util.trigger(_that.beforeLoad, {
                            table: _that._table,
                            data: _that._data
                        }, function () {
                            if (_that._init == 0 || _that._query == null) {
                                _that._init = 1;
                                op.success(_that._data);
                                if (_that._data == null || _that._data.length == 0) {
                                    $C(".k-grid-content tbody", _that._$that).append("<td class='td-empty' colspan='" + $C(".k-grid-content col", _that._$that).length + "'>没有查询到相关数据!</td>");
                                } else {
                                    $C(".k-grid-content tbody .td-empty", _that._$that).remove();
                                }

                                $.util.trigger(_that.afterLoad, {
                                    table: _that._table,
                                    data: _that.getDatas()
                                });
                                $("a[href='#']", _that._$k).attr("href", "javascript:void(0)");
                            }
                            else {
                                _that._query.PageSize = op.data.pageSize;
                                _that._query.PageIndex = op.data.page;
                                $.server.query(_that._query, function (data) {
                                    _that._total = data.Total;
                                    op.success(data.DataSource);

                                    if (_that._data == null || _that._data.length == 0) {
                                        $C(".k-grid-content tbody", _that._$that).append("<td colspan='" + $C(".k-grid-content col", _that._$that).length + "'>没有查询到相关数据!</td>");
                                    }
                                    $.util.trigger(_that.afterLoad, {
                                        table: _that._table,
                                        data: _that.getDatas()
                                    });
                                });
                                $("a[href='#']", _that._$k).attr("href", "javascript:void(0)");
                            }
                        });

                    },
                    submit: function (op) {
                        var dataList = [];
                        for (var i = 0; i < op.data.created.length; i++) {
                            op.data.created[i]["_ROWSTATE"] = 1;
                            var msg = _that._validate(op.data.created[i]);
                            if (msg != null) {
                                $.util.warn(msg);
                                return;
                            }
                            dataList.push(op.data.created[i]);
                        }
                        for (var i = 0; i < op.data.updated.length; i++) {
                            if (op.data.updated[i]["_ROWSTATE"] != 1)
                                op.data.updated[i]["_ROWSTATE"] = 2;
                            var msg = _that._validate(op.data.updated[i]);
                            if (msg != null) {
                                $.util.warn(msg);
                                return;
                            }
                            dataList.push(op.data.updated[i]);
                        }
                        for (var i = 0; i < op.data.destroyed.length; i++) {
                            op.data.destroyed[i]["_ROWSTATE"] = 3;
                            dataList.push(op.data.destroyed[i]);
                        }
                        $.util.trigger(_that.beforeSave, {
                            table: _that.getTable(),
                            datas: dataList
                        }, function () {
                            var datas = $.server.updateOptions(_that.getTable(), dataList, _that._query.PrimaryTable, _that._query.PrimaryKeyField);
                            $.server.update(datas, function (data) {
                                $.util.trigger(_that.afterSave, { datas: data }, function () {
                                    op.success(null, "update");
                                    _that.refresh();
                                    $.util.info("操作成功");
                                })
                            });
                        });
                    },
                    total: function () {
                        alert(1);
                    }
                },
                change: function (op, bb) {
                    if (op.action == "itemchange") {
                        $.util.trigger(_that.afterChange, {
                            data: op.items[0],
                            field: op.field
                        });
                    }
                },
                type: "json",
            };
            var gridOptions = {
                dataSource: dataSource,
                allowCopy: true,
                resizable: true,
                filterable: true,
                excel: {
                    fileName: _that._table.TableLabel
                },
                //scrollable: _that._options.height ? true : false,
                columns: _that._createCols(data.Table.FieldList),
                editable: _that._options.formMode == 1 ? false : { mode: "inline" },
                selectable: (_that._options.isMulti ? "multiple," : "") + "row",
                sortable: true,
                change: function (e) {
                    _that._$k.find(".chk-select").prop("checked", false);
                    var selectedRows = _that._getKGrid().select();
                    for (var i = 0; i < selectedRows.length; i++) {
                        $(selectedRows[i]).find(".chk-select").prop("checked", true);
                    }
                    if (_that._options.formMode == 2) {
                        _that._getKGrid().cancelRow();
                        _that._getKGrid()._footer();
                        _that._getKGrid().editRow(selectedRows[0]);
                        $(selectedRows[0]).removeClass("k-state-selected");
                    }
                    $.util.trigger(_that.afterSelect, {
                        datas: _that.select()
                    });
                    return false;
                },
                dataBound: function (e) {
                    _that._initCtrl();
                }
            };
            if (_that._options.isMulti) {
                gridOptions.selectable = "multiple,row";
            }
            else {
                gridOptions.selectable = "row"
            }
            if (_that.afterRowDetails != null) {
                gridOptions.detailTemplate = "<div class='grid-row-details'></div>",
                gridOptions.detailInit = function (e) {
                    var detailRow = e.detailRow;
                    var $details = detailRow.find(".grid-row-details");
                    $.util.trigger(_that.afterRowDetails, {
                        div: $details,
                        data: e.data
                    });
                }
            }

            if (_that._query != null && _that._options.formMode == 1 && _that._options.isPage) {
                gridOptions.pageable = {
                    extra: false,
                    buttonCount: 0,
                    input: true,
                    numeric: false,
                    messages: {
                        empty: "总数:0",
                        page: "第",
                        of: "/{0}页",
                        itemsPerPage: "条",
                        first: "",
                        last: "",
                        next: "",
                        previous: "",
                        display: "总数:{2}"
                    },
                    pageSizes: [10, 20, 50, 100, 200],
                    refresh: true,
                }
            } else {
                dataSource.serverPaging = false;
            }

            _that._$k.kendoGrid(gridOptions);
            if (_that._options.isMenu) {
                $.smartMenu.remove();
                var btns = [[{
                    text: "查看",
                    func: function () {
                        _that.view();
                    }
                }, {
                    text: "刷新",
                    func: function () {
                        _that.refresh();
                    }
                }], [{
                    text: "导出",
                    data: [[{
                        text: "导出Excel",
                        func: function () {
                            _that.excel();
                        }
                    }, {
                        text: "导出Pdf",
                        func: function () {
                            _that.pdf();
                        }
                    }]]
                }, {
                    text: "打印",
                    func: function () {
                        $.util.warn("未实现功能");
                    }
                }], [{
                    text: "列表显示方案",
                    func: function () {
                        new FieldSet({
                            type: _that._query.PrimaryTable + "_" + _that._query.ProjectType,
                            table: _that._table,
                            afterClose: function (ret) {
                                _that._oriQuery.ProjectId = ret.projectId;
                                _that.refresh();
                            }
                        }).open();
                    }
                }]];
                if ($.server.cache.CurrentUser.UserNo == "00000000") {
                    btns.push([{
                        text: "列表查询方案",
                        func: function () {
                            new Filters({
                                type: _that._query.PrimaryTable + "_" + _that._query.ProjectType,
                                table: _that._table,
                                afterClose: function (ret) {
                                    //_that.refresh();
                                }
                            }).open();
                        }
                    }]);
                }
                _that._$k.smartMenu(btns, {
                    textLimit: 100
                });
            }
            $("#chkAll", _that._$k).click(function () {
                _that.selectAll($(this).prop("checked"));
            });
        });
    };
    ///重新绑定
    this.refresh = function (options) {
        _that._options = $.extend(_that._options, options);
        _that.load(_that._oriQuery, _that.getOptions());
    };

    ///返回frm对象，可进行事件的注册。
    this.view = function () {
        var datas = _that.select();
        if (datas.length != 1) {
            $.util.info("请选择一条数据");
            return;
        }
        return _that._openForm({
            Table: _that.getTable(),
            DataSource: datas
        }, {
            opeMode: 0
        });
    };

    ///返回frm对象，可进行事件的注册。
    this.add = function () {
        if (_that._options.formMode == 1) {
            var q = $.extend({}, _that.getQuery(), { PageSize: 1, PageIndex: 1 });
            q.Conditions = [];
            q.AddCondition("0", q.PrimaryTable + "." + q.PrimaryKeyField, $.server.opeType.Equal, "0");
            return _that._openForm(q, { opeMode: 1 });
        } else {
            _that._createNew();
        }

    };
    ///返回frm对象，可进行事件的注册。
    this.edit = function () {
        if (_that._options.formMode == 1) {
            var q = $.extend({}, _that.getQuery(), { PageSize: 1, PageIndex: 1 });
            q.Conditions = [];
            var datas = _that.select();
            if (datas.length == 0) {
                $.util.info("请选择要操作的数据");
                return;
            }
            q.AddCondition("0", q.PrimaryTable + "." + q.PrimaryKeyField, $.server.opeType.Equal, datas[0][q.PrimaryTable + "_" + q.PrimaryKeyField]);
            return _that._openForm(q, { opeMode: 2 });
        }
    };
    this.del = function (op) {
        var sels = _that.select();
        if (sels.length == 0) {
            $.util.info(op.message || "请选择要操作的数据");
            return;
        }
        op = $.extend({ msg: "确认删除所选数据?" }, op);
        if (_that._options.formMode == 1) {
            $.util.confirm(op.msg, function (options) {
                if (options) {
                    $(sels).each(function (i) {
                        _that._getKGrid().dataSource.remove(this);
                    });
                    _that.save();
                }
            });
        } else {
            $(sels).each(function (i) {
                _that._getKGrid().dataSource.remove(this);
            });
        }
    };
    this.save = function () {
        if ($(".k-invalid-msg", _that._$k).length > 0) {
            return;
        }
        _that._getKGrid().dataSource.sync();
    };

    this.excel = function () {
        if (_that._getKGrid())
            _that._getKGrid().saveAsExcel();
    }

    this.pdf = function () {
        if (_that._getKGrid())
            _that._getKGrid().saveAsPdf();
    }

    this.import = function () {
        if (_that._query) {
            $.server.navigate("DT02", {
                table: _that._query.PrimaryTable,
                title: _that._table.TableLabel,
                init: _that._options.importParms
            });
        }
    }
}
