function Lookup($this) {
    var _that = this;
    this._$that = $this;
    this._$that.data("ctrl", _that);
    this._query = new $.server.queryOptions();
    this._options = {};
    this._bind = {
        BM : null,
        MC : null
    };

    this._initCtrl = function() {
        _that._$that.empty();
        var bindStr = (_that._$that.attr("data-bind") || "").replaceAll(" ", "");
        $(bindStr.split(',')).each(function() {
            var kv = this.split(":");
            if (kv.length == 2) {
                _that._bind[kv[0]] = kv[1];
            }
        });
        _that._$that.attr("data-bind", "");

        if (_that._options.parms["OPEN"] == "Photo") {
            var $photo = $("<div></div>");
            $photo.appendTo(_that._$that);
            var photo = new Photo($photo);
            photo.load({
                guid : _that._options.data[_that._bind["BM"]],
                enable : _that._options.enable
            })
            photo.afterSave = function(data) {
                _that._options.data[_that._bind["BM"]] = data.guid;
            }
            _that.enable(_that._options.enable);
            _that.required(_that._options.required);
            var $a = $('<div class="uinn lkp-search fa fa-angle-right sc-text"></div>');
            $a.appendTo(_that._$that.parent().parent());
            _that._$that.parent().parent().click(function() {
                if (_that._options.enable)
                    photo.open();
                return false;
            });
        } else {
            _that._$bm = $("<input type='text' name='" + _that._options.name + "' style='display:none' />");
            _that._$bm.appendTo(_that._$that);
            if (_that._bind["BM"]) {
                _that._$bm.attr("data-bind", "value:" + _that._bind["BM"]);
            }

            _that._$mc = $("<textarea placeholder='请输入"+_that._options.DisplayLabel+"...' type='text' style='width:100%' class='ub-f1' Readonly='readonly' ></textarea>");
            _that._$mc.appendTo(_that._$that);
            _that._$mc.flexText();
            if (_that._bind["MC"]) {
                _that._$mc.attr("data-bind", "value:" + _that._bind["MC"]);
            }

            var $a = $('<div class="uinn lkp-search fa fa-angle-right sc-text"></div>');
            $a.appendTo(_that._$that.parent().parent());
            _that._$that.parent().parent().click(function() {
                if (_that._options.enable || _that._options.parms["OPEN"] == "GaodeMap" || _that._options.parms["OPEN"] == "Doc")
                    _that._open();
                return false;
            });
            _that.enable(_that._options.enable);
            _that.required(_that._options.required);
        }
    }

    this._parseDatas = function(datas) {
        var result = [];
        $(datas).each(function() {
            result.push({
                BM : this[_that._options.tableName + "_" + _that._options.valueField],
                MC : this[_that._options.tableName + "_" + _that._options.textField]
            })
        });
        return result;
    }

    this._open = function() {
        var lkpgrd = null;
        if (_that._options.parms["OPEN"] && _that._options.parms["OPEN"] != "DDL") {
            lkpgrd = eval("new " + _that._options.parms["OPEN"]);
        } else {
            lkpgrd = new LookupGrid();
        }

        if (_that._options.relationRule != null && _that._options.relationRule != "") {
            var relationCondition = _that._options.relationRule;
            var r = new RegExp(/\{([^\}]*)\}/);
            while (true) {
                var match = r.exec(relationCondition);
                if (match == null)
                    break;
                var field = match[0].replaceAll("{", "").replaceAll("}", "");
                if (_that._options.data[field] == null || _that._options.data[field] == "") {
                    var fieldLabel = "";
                    $(_that._options.fieldList).each(function() {
                        if (field == this.TableName + "_" + this.ColName)
                            fieldLabel = this.DisplayLabel;
                    })
                    $.util.info("请先输入字段【" + fieldLabel + "】的数据");
                    return;
                }
                relationCondition = relationCondition.replaceAll(match[0], "'" + _that._options.data[field] + "'")
            }
            _that._options.condition = "(" + _that._options.oldCondition + ") AND " + relationCondition;
        }

        lkpgrd._options.afterClose = function(result) {
            if (result.dialogResult) {
                //var selDatas = _that._parseDatas(result.datas);
                //var bms = $.util.join(",", selDatas, "BM");
                //var mcs = $.util.join(",", selDatas, "MC");
                var ret = {
                    //BM: bms,
                    //MC: mcs
                };
                for (var p in _that._bind) {
                    if (_that._bind[p]) {
                        if (p == "BM") {
                            ret[p] = $.util.join(",", result.datas, _that._options.tableName + "_" + _that._options.valueField);
                        } else if (p == "MC") {
                            ret[p] = $.util.join(",", result.datas, _that._options.tableName + "_" + _that._options.textField);
                        } else {
                            ret[p] = $.util.join(",", result.datas, _that._bind[p]);
                        }
                    }
                }
                _that.val(ret);
            }
            _that._$that.find("textarea").focus();
        }
        var mc = "";
        if (_that._options.parms["SOURCE"] != null && _that._options.parms["SOURCE"] != "") {
            $(_that._options.parms["SOURCE"].split('|')).each(function() {
                var tmp = _that._options.data[_that._options.table + "_" + this];
                if ( tmp instanceof Date) {
                    tmp = $.date.format(tmp, "yyyy-MM-dd HH:mm");
                }
                mc += tmp + " ";
            });
        } else {
            mc = _that.val().MC;
        }
        _that._query.ConditionExpr = _that._options.condition;
        var data = {
            table : _that._options.table,
            enable : _that._options.enable,
            BM : _that.val().BM,
            MC : mc
        }
        if (_that._options.parms["FOR"]) {
            var obj = _that._options.parms["FOR"].splitObj();
            for (var k in obj) {
                data[obj[k]] = _that._options.data[k];
            }
        }

        lkpgrd.open({
            query : _that._query,
            data : data,
            valueField : _that._options.tableName + "_" + _that._options.valueField,
            textField : _that._options.tableName + "_" + _that._options.textField,
            enable : data.enable
        });
    }

    this._addCondition = function(value) {
        _that._query.Conditions = [];
        _that._query.addCondition("0", _that._options.tableName + "." + _that._options.textField, $.server.opeType.AllMatch, value);
        //$(options.Filters).each(function (index) {
        //    this._query.addCondition(options.TableName, this.split('.')[1], index, $.server.EOperatorType.AllMatch, value);
        //});
    }

    this.load = function(options) {
        _that._options = $.extend({
            data : null,
            enable : true,
            table : null, //当前表
            tableName : null, //目标表
            valueField : null,
            textField : null,
            type : null,
            condition : null,
            relationRule : null,
            fieldList : null,
        }, options);
        if (!_that._options.condition) {
            _that._options.condition = "1=1";
        }
        _that._options.oldCondition = _that._options.condition;

        _that._query = new $.server.queryOptions();
        _that._query.PrimaryTable = _that._options.tableName;
        _that._query.PrimaryKeyField = _that._options.valueField;
        _that._query.ProjectType = _that._query.PrimaryTable + "_LOOKUP";
        //_that._query.FieldNameList = _that._options.tableName + "." + _that._options.valueField + "," + _that._options.tableName + "." + _that._options.textField;
        if (_that._options.parms && _that._options.parms["FOR"]) {
            _that._bind = $.extend(_that._bind, _that._options.parms["FOR"].splitObj());
        }

        this._initCtrl();

    }

    this.required = function(required) {
        // _that._options.required = required;
        // if (_that._options.required) {
            // var $input = _that._$bm;
            // $input.attr("required", "required");
            // $input.attr("validationMessage", " ");
            // $input.parent().css("border-color", "#e7bebe");
            // $input.parent().children().first().css("border-color", "#e7bebe");
        // } else {
            // //_that._$mc.attr("required", "");
            // //_that._$mc.attr("validationMessage", "");
            // //$span.css("border-color", "");
        // }
    }

    this.enable = function(state) {
        _that._options.enable = state;
        if (_that._k) {
            _that._k.enable(state);
        } else {
            if (!_that._options.enable) {
                //$("span", $this).removeClass("k-textbox");
                $("a", $this).hide();
            } else {
                //$("span", $this).addClass("k-textbox");
                $("a", $this).show();
            }
        }
    };

    this.val = function(data) {
        if (data != undefined) {
            if (_that._$bm[0].kendoBindingTarget) {
                for (var p in data) {
                    if (_that._bind[p]) {
                        if (p == "BM" || p == "MC") {
                            _that._$bm[0].kendoBindingTarget.source.set(_that._bind[p], data[p]);
                        } else {
                            _that._$bm[0].kendoBindingTarget.source.set(p, data[p]);
                        }
                    }
                }
            } else {
                _that._$bm.val(data.BM);
                _that._$mc.val(data.MC);
            }
        } else {
            return {
                BM : _that._$bm.val(),
                MC : _that._$bm.val()
            }
        }
    }
}
