function MobileList($this) {
    var _that = this;
    this._$that = $this;
    this._$that.empty();
    this._$that.parent().find(".km-scroller-pull").remove();

    this._$that.data("ctrl", _that);
    this._$k = null;
    this._frm = null;
    this._init = 0;
    this._query = null;
    this._table = null;
    this._data = null;
    this._total = 0;
    ///创建架构
    this._createSchema = function (cols) {
        var fields = {};
        $(cols).each(function () {
            var fName = this.TableName + "_" + this.ColName;
            fields[fName] = {};
            if (this.ColVisible == 2) {
                fields[fName].editable = false;
            }
            else {
                fields[fName].editable = true;
            }
            if (!this.ColNull) {
                //fields[fName].validation = { required: true };
            }
            switch (this.ColType) {
                case "INT IDENTITY":
                case "SMALLINT":
                case "INT":
                case "INTYINT":
                case "NUMERIC":
                    fields[fName].type = "number";
                    fields[fName].format = "{0:d}";
                    break;
                case "DATETIME":
                    fields[fName].type = "date";
                    fields[fName].format = "{0:" + (this.DisplayFormat || "yyyy-MM-dd") + "}";
                    break;
                default:
                    fields[fName].type = "string";
                    break;
            }
        });

        return fields;
    };
    ///控制显示数据及其格式
    this._createCols = function (cols) {
        var fields = [];
        //var chk = {
        //    id: "chk",
        //    headerTemplate: "<div><input type='checkbox' style='opacity:100;position:static;margin:0' id='chkAll' /></div>",
        //    template: "<div><input type='checkbox' style='opacity:100;position:static;margin:0' class='colored-blue chk-select' /></div>",
        //    editor: "#<div></div>#",
        //    width: 35,
        //    aggregates: ["count"],
        //    groupFooterTemplate: "age total: #: count #"
        //}
        //fields.push(chk);

        if (_that._options.formMode == 2) {
            fields.push({
                command: [{
                    name: " ",
                    className: "k-grid-cmd glyphicon glyphicon-plus",
                    click: function (e) {
                        var tr = $(e.target).closest("tr");
                        var data = this.dataItem(tr);
                        var index = _that.getDataSource().indexOf(data)
                        _that._createNew(index + 1);
                        return false;
                    }
                }, {
                    name: "-",
                    className: "k-grid-cmd",
                    click: function (e) {
                        var tr = $(e.target).closest("tr");
                        var data = this.dataItem(tr);
                        _that.getDataSource().remove(data);
                        return false;
                    }
                }],
                width: 80
            });
        }
        var tWidth = 54;
        $(cols).each(function () {
            if (this.ColVisible == 0)
                return;
            var dbField = this;
            var field = {
                groupable: false,
                aggregates: ["count", "min", "max"],
                groupFooterTemplate: "age total: #: count #, min: #: min #, max: #: max #",
            };
            if (_that._options.formMode == 2) {
                field.editor = function (container, options) {
                    var field = dbField;
                    var data = options.model;
                    var isHandle = false;
                    if (field.EditFormat) {
                        var edits = field.EditFormat.replace('(', '|').replace(')', '|').split('|');
                        if (edits[0] == "CHECK") {
                            $.field.createCheckBox(field, container);
                            isHandle = true;
                        }
                        else if (edits[0] == "MEMO") {
                            $.field.createTextarea(field, container);
                            isHandle = true;
                        }
                        else if (edits[0] == "AUTO" || edits[0] == "CODE" || edits[0] == "LOOK") {
                            if (edits[0] == "AUTO" || edits[0] == "CODE") {
                                edits[2] = "BM0000";
                                edits[3] = "MC0000";
                            }
                            var ps = {};
                            if (field.Parms) {
                                ps = $.evalJSON(field.Parms);
                            }
                            $.field.createLookup(field, container, data, edits, ps);
                            isHandle = true;
                        }
                    }
                    if (!isHandle) {
                        switch (field.ColType) {
                            case "INT":
                            case "NUMERIC":
                            case "DECIMAL":
                                $.field.createNumericTextBox(field, container);
                                break;
                            case "DATETIME":
                                $.field.createDateTimePicker(field, container);
                                break;
                            default:
                                $.field.createTextbox(field, container);
                                break;
                                //日期 短日期 富文本 
                        }
                    }
                }
            }

            switch (this.ColType) {
                case "INT IDENTITY":
                case "SMALLINT":
                case "INT":
                case "INTYINT":
                case "NUMERIC":
                    field.ttype = "number";
                    field.format = "{0:0." + "".padLeft(this.ColPrecision, "0") + "}";
                    break;
                case "DATETIME":
                    field.ttype = "date";
                    field.format = "{0:" + (this.DisplayFormat || "yyyy-MM-dd") + "}";
                    break;
                default:
                    field.ttype = "string";
                    break;
            }
            field.defaultValue = this.ColDefault;
            field.field = this.TableName + "_" + this.ColName;
            if (this.EditFormat.startsWith("LOOK") || this.EditFormat.startsWith("CODE") || this.EditFormat.startsWith("AUTO")) {
                field.field += "MC";
            }
            field.title = this.DisplayLabel;
            field.width = this.ColWidth || 120;
            tWidth += field.width;
            fields.push(field);
        });
        var cWidth = _that._$that.width() - tWidth;
        if (cWidth > 0) {
            var count = 0;
            $(fields).each(function () {
                if (!this.locked) {
                    count++;
                }
            });
            $(fields).each(function () {
                if (!this.locked) {
                    this.width += Math.floor(cWidth / count) - 1.5;
                }
            });
        }

        return fields;
    };
    ///获取K控件
    this._getKGrid = function () {
        if (_that._$k == null)
            return null;
        return _that._$k.data("kendoMobileListView");
    };
    ///新增一个空对象
    this._createNew = function (index) {
        if (index === undefined) {
            index = _that.getDatas().length;
        }
        var newData = $.server.create(_that.getTable());
        $.util.trigger(this.beforeAdd, { datas: [newData] }, function () {
            newData = _that.getDataSource().insert(index, newData);
            //var table = _that._getKGrid().lockedContent ? _that._getKGrid().lockedTable : _that._getKGrid().table;
            //var row = table.find("tr:eq(" + index + ")");
            //_that.select([newData]);
            //_that._getKGrid().editRow(row);
            _that._Data.DataSource.push(newData);
            _that._Data.Total += 1;
            _that.bind(_that._Data, _that._options);
        });
    };

    this._openForm = function (q, options) {
        if (_that._frm == null) {
            var $pnl = null;
            if (_that._options.formId) {
                $pnl = $("#" + _that._options.formId);
            } else {
                var $pnl = $("<div></div>");
                $pnl.prependTo(_that._$that);
                _that._$k.hide();
            }
            _that._frm = $.ctrl.openForm($pnl, q, $.extend(options, {
                afterClose: function () {
                    _that._frm = null;
                    _that._$k.show();
                }
            }));
            _that._frm.afterSave = function (op) {
                $.util.info("保存成功");
                _that.refresh();
            }
        }
        _that._frm.load(q, options);
        return _that._frm;
    };

    this._initCtrl = function () {
        var $locked = _that._$k.find(".k-grid-content-locked");
        var width = $locked.width();
        $locked.removeAttr("style");
        $locked.width(width);
        var chks = _that._$k.find(".chk-select");
        chks.click(function () {
            var trsLock = $(".k-grid-content-locked tr", _that._$k)
            var trs = $(".k-grid-content tr", _that._$k);
            for (var i in chks) {
                if (chks[i] === this) {
                    var isSelected = $(this).prop("checked");
                    if (isSelected) {
                        $(trsLock[i]).attr("aria-selected", "true").addClass("k-state-selected");
                        $(trs[i]).attr("aria-selected", "true").addClass("k-state-selected");
                    } else {
                        $(trsLock[i]).attr("aria-selected", "false").removeClass("k-state-selected");
                        $(trs[i]).attr("aria-selected", "false").removeClass("k-state-selected");
                    }
                }
            }
            $.util.trigger(_that.afterSelect, {
                datas: _that.select()
            });
        });
        if (_that._frm != null) {
            if (_that._frm._$that)
                _that._frm._$that.parent().remove();
            _that._frm = null;
        }
    };

    this._validate = function (data) {
        for (var i = 0; i < _that.getTable().FieldList.length; i++) {
            var f = _that.getTable().FieldList[i];
            if (f.ColVisible != 0 && f.ColNull == 0) {
                if (data[f.TableName + "_" + f.ColName] == null || data[f.TableName + "_" + f.ColName].length == 0) {
                    return f.DisplayLabel + "不能为空";
                }
            }
        }
        return null;
    };

    this._getTemplate = function () {
        var html = [];
        html.push("<div class='container-fluid'>");
        if (_that._options.template.length < 1) {
            $.util.info("没有设置需要显示的数据，请返回设置！");
            return false;
        }
        $.each(_that._options.template, function (key, val) {
            if (key == 0)
                html.push("<div class='row' style='padding:0'><div class='col-xs-11' style='padding:0'><B>" + val + "</B></div><div class='col-xs-1' style='padding:0'></div></div>");
            else if (key == 1)
                html.push("<div class='row' style='padding:0'><div class='col-xs-11' style='padding:0'>" + val + "</div><div class='col-xs-1' style='padding:0'><a href='javascript:void(0);' class='blue' style='float:right'><i class='fa fa-chevron-right'></i></a></div></div>");
            else
                html.push("<div class='row' style='padding:0'><div class='col-xs-11' style='padding:0'>" + val + "</div><div class='col-xs-1' style='padding:0'></div></div>");
        });
        html.push("</div>");
        return $.util.join("", html);

    };

    this._createTemplate = function (FieldList) {
        //console.log(FieldList);
        var html = [];
        html.push("<div class='container-fluid'>");

        if (_that._options.formMode == 1) {
            $C.each(FieldList, function (key, val) {
                this.field = this.TableName + "_" + this.ColName;
                if (this.EditFormat.startsWith("LOOK") || this.EditFormat.startsWith("CODE") || this.EditFormat.startsWith("AUTO")) {
                    this.field += "MC";
                }
                if (val.ColVisible != 0) {
                    if (key == FieldList.length - 1)
                        html.push("<div class='row' style='padding:0;'><div class='col-xs-4' style='padding:0; line-height:22px; font-weight:700;'>" + val.DisplayLabel + "：</div><div class='col-xs-8' style='padding:0'>#:$.util.toString(" + val.field + ")#</div></div>");
                    else
                        html.push("<div class='row' style='padding:0; border-bottom:1px dashed; border-color:LightGrey'><div class='col-xs-4' style='padding:0; line-height:22px; font-weight:700;'>" + val.DisplayLabel + "：</div><div class='col-xs-8' style='padding:0'>#:$.util.toString(" + val.field + ")#</div></div>");
                };
            });
        } else if (_that._options.formMode == 2) {
            $C.each(FieldList, function (key, val) {
                //this.field = this.TableName + "_" + this.ColName;
                //if (this.EditFormat.startsWith("LOOK") || this.EditFormat.startsWith("CODE") || this.EditFormat.startsWith("AUTO")) {
                //    this.field += "MC";
                //}
                var input = _that._create2(val, {},FieldList);
                if (val.ColVisible != 0) {
                    if (key == FieldList.length - 1)
                        html.push("<div class='row' style='padding:0;'><div class='col-xs-4' style='padding:0; line-height:34px; font-weight:700;'>" + val.DisplayLabel + "：</div><div class='col-xs-8' style='padding:0;line-height:34px;'>" + input + "</div></div>");
                    else
                        html.push("<div class='row' style='padding:0; border-bottom:1px dashed; border-color:LightGrey'><div class='col-xs-4' style='padding:0; line-height:34px; font-weight:700;'>" + val.DisplayLabel + "：</div><div class='col-xs-8' style='padding:0;line-height:34px;'>" + input + "</div></div>");
                    //var $row = $("<div class='row' style='padding:0;'></div>");
                    ////var $r = $("<div class='col-xs-4' style='padding:0; line-height:34px; font-weight:700;'>" + val.DisplayLabel + "：</div>");
                    ////var $s = $("<div class='col-xs-8' style='padding:0;line-height:34px;'>" + input + "</div>");
                    //_that._createField($row, val, FieldList); console.log($row);
                    ////if (key == FieldList.length - 1) {
                    ////    html.push($row);
                    ////} else {
                    ////    html.push($row);
                    ////}
                    //return $row;
                };
            });
        }

        html.push("</div>");
        return $.util.join("", html);
    };

    this._createField = function ($pnl, field, fieldList) {
        var label = field.DisplayLabel;
        if (field.ColNull == 0) {
            label = "<span style='color:red'>" + label + "*</span>";
        }
        var wl = 4, wt = 8;
        if ($pnl.hasClass("col-sm-12")) {
            wl = 2;
            wt = 10;
        }
        var $label = $("<div class='col-xs-" + wl + "' style='padding-right:0'><span>" + label + "</span></div>");
        $label.appendTo($pnl);
        var $field = $("<div class='col-xs-" + wt + "' style='margin-bottom:0;'></div>");
        $pnl.append($field);
        _that._create($field, field, fieldList);
        $field.append($("<span data-for='" + field.TableName + "_" + field.ColName + "' class='k-invalid-msg' style='    position: absolute;top: 7px;right: 5px;' ></span>"));
    };

    //this._create = function ($field, field, fieldList) {
    //    var isHandle = false;
    //    if (field.EditFormat) {
    //        var edits = field.EditFormat.replace('(', '|').replace(')', '|').split('|');
    //        if (edits[0] == "CHECK") {
    //            $C.field.createCheckBox(field, $field);
    //            isHandle = true;
    //        }
    //        else if (edits[0] == "MEMO") {
    //            $C.field.createTextarea(field, $field);
    //            isHandle = true;
    //        }
    //        else if (edits[0] == "AUTO" || edits[0] == "CODE" || edits[0] == "LOOK") {
    //            if (edits[0] == "AUTO" || edits[0] == "CODE") {
    //                edits[2] = "BM0000";
    //                edits[3] = "MC0000";
    //            }
    //            var ps = {};
    //            if (field.Parms) {
    //                ps = $C.evalJSON(field.Parms);
    //            }
    //            //$C.field.createLookup(field, $field, data, edits, ps, fieldList);
    //            isHandle = true;
    //        }
    //    }
    //    if (!isHandle) {
    //        switch (field.ColType) {
    //            case "INT":
    //            case "NUMERIC":
    //            case "DECIMAL":
    //                $C.field.createNumericTextBox(field, $field);
    //                break;
    //            case "DATETIME":
    //                $C.field.createDateTimePicker(field, $field);
    //                break;
    //            default:
    //                $C.field.createTextbox(field, $field);
    //                break;
    //                //日期 短日期 富文本 
    //        }
    //    }
    //////};

    this._create2 = function (field, fieldList) {
        var input;
        var isHandle = false;
        if (field.EditFormat) {
            var edits = field.EditFormat.replace('(', '|').replace(')', '|').split('|');
            if (edits[0] == "CHECK") {
                //$C.field.createCheckBox(field, $field);
                isHandle = true;
            }
            else if (edits[0] == "MEMO") {
                //$C.field.createTextarea(field, $field);
                isHandle = true;
            }
            else if (edits[0] == "AUTO" || edits[0] == "CODE" || edits[0] == "LOOK") {
                if (edits[0] == "AUTO" || edits[0] == "CODE") {
                    edits[2] = "BM0000";
                    edits[3] = "MC0000";
                }
                var ps = {};
                if (field.Parms) {
                    ps = $C.evalJSON(field.Parms);
                }
                //$C.field.createLookup(field, $field, data, edits, ps, fieldList);
                isHandle = true;
            }
        }
        if (!isHandle) {
            switch (field.ColType) {
                case "INT":
                case "NUMERIC":
                case "DECIMAL":
                    input = _that._createNumericTextBox(field);
                    break;
                case "DATETIME":
                    //$C.field.createDateTimePicker(field, $field);
                    break;
                default:
                    input = _that._createTextbox(field);
                    break;
                    //日期 短日期 富文本 
            }
        }
        return input;
    };

    this._createTextbox = function (field) {
        var required = "";
        if (field.ColNull == 0) {
            required = "required validationMessage='不能为空'";
            //$pnl.addClass("form-group has-error has-feedback");
        }
        var $ctl = "<input name='" + field.TableName + "_" + field.ColName
            + "' type='text'style='width:100%' data-bind='value:" + field.TableName + "_" + field.ColName + "' " + required + "/>";
        return $ctl;
        //$ctl.appendTo($pnl);
        //$ctl.kendoMaskedTextBox({});
        //$ctl.data("kendoMaskedTextBox").enable(field.editable);
    };

    this._createNumericTextBox = function (field) {
        var required = "";
        if (field.ColNull == 0) {
            required = "required validationMessage='不能为空'";
            //$pnl.addClass("form-group has-error has-feedback");
        }
        var ctl = "<input class='kendoNumericTextBox' name='" + field.TableName + "_" + field.ColName
            + "' type='text'style='width:100%;margin-bottom:0px;' data-bind='value:" + field.TableName + "_" + field.ColName + "' " + required + "/>";
        //$ctl.appendTo($pnl);
        //$ctl.kendoNumericTextBox({ format: "{0:0." + "".padLeft(field.ColPrecision, "0") + "}" });
        //$ctl.data("kendoNumericTextBox").enable(field.editable);
        return ctl;
    }

    //单击查看列表上的添加按钮时
    this.afterClickAdd = $.util.defaultEvent;

    ///列生成前事件
    this.beforeField = $.util.defaultEvent;
    ///绑定前事件
    this.beforeLoad = $.util.defaultEvent;
    ///绑定后事件
    this.afterLoad = $.util.defaultEvent;
    ///选中后事件
    this.afterSelect = $.util.defaultEvent;
    ///数据改变后事件
    this.afterChange = $.util.defaultEvent;
    ///更新前事件
    this.beforeSave = $.util.defaultEvent;
    ///更新后事件
    this.afterSave = $.util.defaultEvent;
    ///新增数据前事件
    this.beforeAdd = $.util.defaultEvent;

    ///获取查询参数
    this.getQuery = function () {
        return _that._query;
    };
    ///获取表结构
    this.getTable = function () {
        return _that._table;
    };
    ///获取数据源
    this.getDataSource = function () {
        if (_that._getKGrid()) {
            return _that._getKGrid().dataSource;
        }
        return null;
    };
    ///获取数据
    this.getDatas = function () {
        if (_that._getKGrid()) {
            return _that._getKGrid().dataSource.data();
        }
        return null;
    };
    ///获取查询参数
    this.getOptions = function () {
        return _that._options;
    };
    ///全选
    this.selectAll = function (isSelect) {
        this.select(isSelect ? _that.getDatas() : []);
    };
    ///获取选中
    this.select = function (datas) {
        if (datas === undefined) {
            var result = [];
            var kgrd = _that._getKGrid();
            if (kgrd) {
                var trs = kgrd.select();
                $(trs).each(function (i) {
                    var d = kgrd.dataItem(trs[i]);
                    if (d) {
                        var isExists = false;
                        for (var i in result) {
                            if (result[i].uid == d.uid)
                                isExists = true;
                        }
                        if (!isExists) {
                            result.push(d);
                        }
                    }
                });
            }
            return result;
        } else {
            _that._$k.find(".chk-select").prop("checked", false);
            $("tr", _that._$k).attr("aria-selected", "false").removeClass("k-state-selected");

            var kgrd = _that._getKGrid();
            if (kgrd) {
                var chks = _that._$k.find(".chk-select");
                $("tbody tr", _that._$k).each(function (index) {
                    var d = kgrd.dataItem(this);
                    for (var i = 0; i < datas.length; i++) {
                        if (d === datas[i]) {
                            $(chks[index]).prop("checked", true);
                            $(this).attr("aria-selected", "true").addClass("k-state-selected");
                        }
                    }
                })
            }
            $.util.trigger(_that.afterSelect, {
                datas: _that.select()
            });
        }
        return false;
    };

    ///数据绑定
    this.load = function (q, options) {
        _that._query = $.extend(new $.server.queryOptions(), q);
        _that._options = $.extend({
            formMode: 3, //1为表单编辑、查看列表，2为表格编辑，3为页面列表
            formId: "",
            //formIsSave: true,
            //formIsCancel: true,
            //isTotal: false, //是否合计
            //isMenu: true,
            //isFull: false, //是否匹配满屏
            //isMulti: true, //是否多选
            isPage: true, //是否分页
            isAdd: false,//是否要添加
            //command: null, // 格式为[{ text: "按钮名称", click: null},{ text: "按钮名称2", click: null}]
            //linkFiled: null, //格式为 字段名称1|字段名称2|字段名称3
        }, options);
        
        $.server.query(_that._query, function (data) {
            _that.bind(data, _that._options);
        });
    };

    ///数据绑定
    this.bind = function (data, options) {
        _that._init = 0;// 避免重复查询 zxilu 2015-10-02
        if (_that._$k != null) {
            _that._$k.remove();
        }
        _that._options = $.extend({
            formMode: 3, //1为表单编辑，2为表格编辑，3为页面列表
            formId: "",
            isPage: true, //是否分页
            isAdd: false,//是否要添加按钮
        }, options);

        if (_that._options.formMode != 3) {
            if (_that._$h != null) {
                _that._$h.remove();
            }
            _that._$h = $('<div class="header-fluid" style="padding-right:15px; padding-left:15px;line-height:30px;background-color:#D0D0D0"></div>');
            _that._$h.html(data.Table.TableLabel);
            _that._$h.appendTo(_that._$that);
            if (_that._options.formMode == 1 && _that._options.isAdd == true) {
                _that._$add = $("<a href='javascript:void(0);' class='blue' style='float:right'><i class='fa fa-plus'></i></a>");
                _that._$add.appendTo(_that._$h);
                _that._$add.bind("click", function () {
                    $.util.trigger(_that.afterClickAdd, {
                    });
                });
            }
        };

        _that._$k = $("<div></div>");
        _that._$k.appendTo(_that._$that);

        if (_that._query != null && _that._query.PageSize == 10000 && _that._options.formMode == 1 && _that._options.isPage) {
            _that._query.PageSize = 50;
        }
        if (_that._options.height)
            _that._$k.height(_that._options.height);

        _that._Data = data;
        _that._table = data.Table;
        _that._data = data.DataSource;
        _that._total = data.Total;

        $.util.trigger(_that.beforeField, {
            table: _that._table,
            data: _that._data
        }, function () {
            var dataSource = {
                data: [],
                schema: {
                    total: function () {
                        return _that._total;
                    }
                },
                pageSize: _that._query.PageSize,
                page: _that._query.PageIndex,
                serverPaging: true,
                batch: true,
                transport: {
                    read: function (op) {
                        $.util.trigger(_that.beforeLoad, {
                            table: _that._table,
                            data: _that._data
                        }, function () {
                            if (_that._init == 0) {
                                _that._init = 1;
                                op.success(_that._data);

                                _that._initCtrl();
                                $.util.trigger(_that.afterLoad, {
                                    table: _that._table,
                                    data: _that.getDatas()
                                });
                                $("a[href='#']", _that._$k).attr("href", "javascript:void(0)");
                            }
                            else {
                                _that._query.PageSize = op.data.pageSize;
                                _that._query.PageIndex = op.data.page;
                                $.server.query(_that._query, function (data) {
                                    _that._total = data.Total;
                                    op.success(data.DataSource);
                                    _that._initCtrl();
                                    $.util.trigger(_that.afterLoad, {
                                        table: _that._table,
                                        data: _that.getDatas()
                                    });
                                });
                                $("a[href='#']", _that._$k).attr("href", "javascript:void(0)");
                            }
                        });

                    },
                    submit: function (op) {
                        var dataList = [];
                        for (var i = 0; i < op.data.created.length; i++) {
                            op.data.created[i]["_ROWSTATE"] = 1;
                            var msg = _that._validate(op.data.created[i]);
                            if (msg != null) {
                                $.util.warn(msg);
                                return;
                            }
                            dataList.push(op.data.created[i]);
                        }
                        for (var i = 0; i < op.data.updated.length; i++) {
                            if (op.data.updated[i]["_ROWSTATE"] != 1)
                                op.data.updated[i]["_ROWSTATE"] = 2;
                            var msg = _that._validate(op.data.updated[i]);
                            if (msg != null) {
                                $.util.warn(msg);
                                return;
                            }
                            dataList.push(op.data.updated[i]);
                        }
                        for (var i = 0; i < op.data.destroyed.length; i++) {
                            op.data.destroyed[i]["_ROWSTATE"] = 3;
                            dataList.push(op.data.destroyed[i]);
                        }
                        $.util.trigger(_that.beforeSave, {
                            table: _that.getTable(),
                            datas: dataList
                        }, function () {
                            var datas = $.server.updateOptions(_that.getTable(), dataList, _that._query.PrimaryTable, _that._query.PrimaryKeyField);
                            $.server.update(datas, function (data) {
                                $.util.trigger(_that.afterSave, { datas: data }, function () {
                                    op.success(null, "update");
                                    _that.refresh();
                                    $.util.info("操作成功");
                                })
                            });
                        });
                    }
                },
                change: function (op, bb) {
                    if (op.action == "itemchange") {
                        $.util.trigger(_that.afterChange, {
                            data: op.items[0],
                            field: op.field
                        });
                    }
                },
                type: "json",
            };
            var gridOptions = {
                dataSource: dataSource,
                template: _that._options.formMode == 3 ? _that._getTemplate() : _that._createTemplate(data.Table.FieldList),
                click: function (e) {
                    if (_that._options.formMode == 3) {
                        e.item.siblings().css("background", "");
                        e.item.css("background", "#0094ff");
                        $.util.trigger(_that.afterSelect, { datas: [e.dataItem] });
                    } else if (_that._options.formMode == 1) {
                        e.item.siblings().css("background", "");
                        e.item.css("background", "#0094ff");
                        $.util.trigger(_that.afterSelect, { datas: [e.dataItem] });
                    }
                },
                //dataBinding: function (e) {

                //},
                //allowCopy: true,
                appendOnRefresh: true,
                pullToRefresh: true,
                messages: {
                    pullTemplate: "下拉刷新",
                    releaseTemplate: "释放刷新",
                    refreshTemplate: "刷新中"
                },
                virtualViewSize: _that._query.PageSize,
                endlessScroll: true,
                //columnResize: true,
                resizable: true,
                //filterable: true,
                //scrollable: _that._options.height ? true : false,
                //columns: _that._createCols(data.Table.FieldList),
                //editable: _that._options.formMode == 1 ? false : { mode: "inline" },
                //selectable: "multiple,row",
                //pageable: {
                //    extra: false,
                //    buttonCount: 5,
                //    input: true,
                //    messages: {
                //        empty: "没有查询到相关数据！",
                //        page: "第",
                //        of: "/{0}页",
                //        itemsPerPage: "条",
                //        first: "",
                //        last: "",
                //        next: "",
                //        previous: "",
                //        display: "总数:{2}"
                //    },
                //    pageSizes: [10, 20, 50, 100, 200],
                //    refresh: true,
                //},
                //sortable: true,
                //change: function (e) {
                //    _that._$k.find(".chk-select").prop("checked", false);
                //    var selectedRows = _that._getKGrid().select();
                //    for (var i = 0; i < selectedRows.length; i++) {
                //        $(selectedRows[i].cells[0]).find(".chk-select").prop("checked", true);
                //    }
                //    if (_that._options.formMode == 2) {
                //        _that._getKGrid().editRow(selectedRows);
                //    }
                //    $.util.trigger(_that.afterSelect, {
                //        datas: _that.select()
                //    });
                //    return false;
                //},
                save: function (e) {
                    //if (e.values.name) {
                    // the user changed the name field
                    //if (e.values.name != e.model.name) {
                    //    console.log("name is modified");
                    //}
                    //}
                }
            };

            if(_that._options.formMode == 2)
                gridOptions = $.extend(gridOptions, { pullToRefresh: false,});
            _that._$k.kendoMobileListView(gridOptions);
            $("#chkAll", _that._$k).click(function () {
                _that.selectAll($(this).prop("checked"));
            });
        });
    };

    ///重新绑定
    this.refresh = function (options) {
        _that._options = $.extend(_that._options, options);
        _that.load(_that.getQuery(), _that.getOptions());
    };
    ///返回frm对象，可进行事件的注册。
    this.view = function () {
        var q = $.extend({ PageSize: 1, PageIndex: 1 }, _that.getQuery());
        q.Conditions = [];
        var datas = _that.select();
        if (datas.length == 0) {
            $.util.info("请选择要操作的数据");
            return;
        }
        q.AddCondition("0", q.PrimaryTable + "." + q.PrimaryKeyField, $.server.opeType.Equal, datas[0][q.PrimaryTable + "_" + q.PrimaryKeyField]);
        return _that._openForm(q, { opeMode: 0 });
    };
    ///返回frm对象，可进行事件的注册。
    this.add = function () {
        if (_that._options.formMode == 1 || _that._options.formMode == 3) {
            var q = $.extend({}, _that.getQuery(), { PageSize: 1, PageIndex: 1 });
            q.Conditions = [];
            q.AddCondition("0", q.PrimaryTable + "." + q.PrimaryKeyField, $.server.opeType.Equal, "0");
            return _that._openForm(q, { opeMode: 1 });
        } else {
            _that._createNew();
        }

    };
    ///返回frm对象，可进行事件的注册。
    this.edit = function () {
        if (_that._options.formMode == 1) {
            var q = $.extend({}, _that.getQuery(), { PageSize: 1, PageIndex: 1 });
            q.Conditions = [];
            var datas = _that.select();
            if (datas.length == 0) {
                $.util.info("请选择要操作的数据");
                return;
            }
            q.AddCondition("0", q.PrimaryTable + "." + q.PrimaryKeyField, $.server.opeType.Equal, datas[0][q.PrimaryTable + "_" + q.PrimaryKeyField]);
            return _that._openForm(q, { opeMode: 2 });
        }
    };
    this.del = function (op) {
        var sels = _that.select();
        if (sels.length == 0) {
            $.util.info(op.message || "请选择要操作的数据");
            return;
        }
        op = $.extend({ msg: "确认删除所选数据?" }, op);
        if (_that._options.formMode == 1) {
            $.util.confirm(op.msg, function (options) {
                if (options) {
                    $(sels).each(function (i) {
                        _that._getKGrid().dataSource.remove(this);
                    });
                    _that.save();
                }
            });
        } else {
            $(sels).each(function (i) {
                _that._getKGrid().dataSource.remove(this);
            });
        }
    };
    this.save = function () {
        if ($(".k-invalid-msg", _that._$k).length > 0) {
            return;
        }
        _that._getKGrid().dataSource.sync();
    };
}
