function MyFullcalendar($this) {
    var _that = this;
    this._$that = $this;
    this._options = {};


    this.afterLoad = $C.util.defaultEvent;

    ///数据加载
    this.load = function (query, options) {
        _that.query = $C.extend(new $.server.queryOptions(), query);
        _that._$that.data("query", query);
        _that._options = $C.extend({}, options);

        $C.server.query(_that.query, function (data) {
            //console.log(data);
            //_that.bind(data, _that._options);
            $C.util.trigger(_that.afterLoad, { data: data }, _that.bind(data, _that._options));
        });
    };

    ///数据绑定
    this.bind = function (data, options) {
        _that._options = $C.extend({}, options);
        var height = $(window).height() - _that._$that.offset().top - 65;
        if (height > 0) {
            _that._options.height = height;
        }

        $C(data.DataSource).each(function (i) {
            this.id = data.DataSource[i]['RC101_ID'];
            this.title = data.DataSource[i]['RC102_A01'];
            this.start = data.DataSource[i]['RC101_A01'];
            this.end = $C.date.format(data.DataSource[i]['RC101_A02'], "yyyy-MM-dd HH:mm:ss");
            //this.end = data.DataSource[i]['RC101_A02'];
            this.allDay = "true";
            //this.textColor = "white";
            //if ($C.date.format(data.DataSource[i]['RC101_A02'], "yyyy-MM-dd") < $C.date.format($C.server.currentDate(), "yyyy-MM-dd")) {
            //    this.color = "#aabbcc";
            //} else {
            //    this.color = data.DataSource[i]['RC102_A05']?data.DataSource[i]['RC102_A05']:"#FF9966";
            //}
            if ($C.date.format(data.DataSource[i]['RC101_A02'], "yyyy-MM-dd") < $C.date.format($C.server.currentDate(), "yyyy-MM-dd")) {//已经过去的
                this.borderColor = "#aabbcc";
                this.textColor = "#aabbcc";
            } else {
                this.borderColor = data.DataSource[i]['RC102_A05'] ? data.DataSource[i]['RC102_A05'] : "#FF9966";
                this.textColor = data.DataSource[i]['RC102_A05'] ? data.DataSource[i]['RC102_A05'] : "#FF9966";
            }
            //this.textColor = '#5db2ff';
            //this.borderColor = '#5db2ff';
            if (data.DataSource[i]['RC101_A04'] != "00005WT59OHT0000000000") {//如果不等于日志
                //this.editable = true;
            }
            //this.roomId = data.DataSource[i]['RC101_A04'];
        });

        var fullCalendarOptions = {
            events: data.DataSource,//事件数据

            //theme: true,//是否允许使用jquery的ui主题


            //defaultDate: $C.server.currentDate(),
            //editable: true,//事件是否可编辑，可编辑是指可以移动, 改变大小等。
            selectable: true,//允许拖动
            buttonIcons: true,//设置header中使用的prev, next等变量对应按钮的样式
            header: {//设置日历头部信息。
                left: 'prev,next today',
                center: 'title',
                right: 'month,agendaWeek,agendaDay'
            },
            monthNames: ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"],//月份全称
            monthNamesShort: ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"],//月份名称简写
            dayNames: ["周日", "周一", "周二", "周三", "周四", "周五", "周六"],//星期全称
            dayNamesShort: ["日", "一", "二", "三", "四", "五", "六"],//星期名称简写
            weekNumbers: true,//是否在日历中显示周次
            weekNumberCalculation:"iso",//周次的显示格式。
            weekNumberTitle: "周",//周次，即一年中的第几周
            today: ["今天"],
            buttonText: {
                today: '今天',
                month: '月',
                week: '周',
                day: '日'
            },
            allDaySlot: true,//在agenda视图模式下，是否在日历上方显示all-day(全天)
            allDayText: "全天",//定义日历上方显示全天信息的文本
            axisFormat: "HH:mm",//设置日历agenda视图下左侧的时间显示格式，默认显示如：5:30pm
            slotEventOverlap: true,
            columnFormat: {//设置显示日历每列表头信息的格式文本
                month: 'dddd'
            },
            titleFormat: {//设置用于显示日历头部的文本信息
                //month: 'YYYY-MM', // September 2013
                //week: "MM-DD", // Sep 7 - 13 2013
                //day: 'YYYY-MM-DD,dddd' // Tuesday, Sep 8, 2013
            },
            firstDay: 1,//0每行第一天为周日 、1为周一
            dragOpacity: {//拖动时候的不透明度。
                agenda: .5,//对于agenda视图
                '': .6//其它视图
            },
            aspectRatio: 1.35,//设置日历单元格宽度与高度的比例。
            //height: 650,//设置日历的高度，包括header日历头部
            //contentHeight:500,//设置日历主体内容的高度，不包括header部分
            handleWindowResize: true,//是否随浏览器窗口大小变化而自动变化。

            //dayClick: function (date, allDay, jsEvent, view) { //点击某天，添加日程
            //    //console.log(date);
            //    $C.server.navigate("RC02", { start: $C.date.format(date._d, 'yyyy-MM-dd'), end: $C.date.format(date._d, 'yyyy-MM-dd') });
            //},

            eventClick: function (calEvent, jsEvent, view) { //点击某日程事件，编辑
                //console.log(calEvent);
                $C.server.navigate("RC04", { id: calEvent.RC101_A05, sch_type: calEvent.RC101_A04, sch_name: calEvent.RC101_A04MC, sch_source: "RC01", allDatas: data.DataSource });
            },

            select: function (startDate, endDate, allDay, jsEvent, view) {//选中事件
                //console.log(view.name);
                $C.server.navigate("RC02", { start: startDate, end: endDate, sch_source: "RC01", sch_view:view.name });
            },

            eventDrop: function (event, dayDelta, minuteDelta, allDay, revertFunc) {//拖动事件
                //console.log("拖动");
            },
            eventResize: function (event, dayDelta, minuteDelta, revertFunc) {//缩放
                //console.log("缩放");
            },
            windowResize: function (view) {
                //console.log("窗口改变");
            },
            eventAfterRender: function (event, element, view) {
                //$C(".fc-event").removeClass("fc-event-hori");
                //console.log("事件绑定后");
            },
            loading: function (isloading, view) {
                if (isloading) {
                    console.log("载入完成");
                } else {
                    console.log("loading");
                }
            },
        };

        fullCalendarOptions = $C.extend(fullCalendarOptions, _that._options);
        _that._$that.fullCalendar(fullCalendarOptions);
    };
}
