function MyScheduler($this) {
    var _that = this;
    this._$that = $this;
    this._options = {};

    this.getResources = function (callback) {

        var q = new $.server.queryOptions();
        q.PrimaryTable = "RC102";
        q.PrimaryKeyField = "ID";
        q.FieldNameList = "*";

        $.server.query(q, function (d) {

            var resources = [];
            var Arr = {};
            var dataSource = [];

            $(d.DataSource).each(function (i) {
                var tmp = {};
                tmp.text = d.DataSource[i]["RC102_A01"];
                tmp.value = d.DataSource[i]["RC102_ID"];
                tmp.key = d.DataSource[i]["RC102_A05"] || "#FF9966";
                dataSource.push(tmp);
            });

            Arr.field = 'roomId';
            Arr.dataColorField = 'key';
            Arr.dataSource = dataSource;

            resources.push(Arr);
            callback(resources);

        });

    };

    ///数据加载
    this.load = function (query, options) {
        _that.query = $.extend(new $.server.queryOptions(), query);
        _that._$that.data("query", query);
        _that._options = $.extend({}, options);

        $.server.query(_that.query, function (data) {
            _that.bind(data, _that._options);
        });
    };

    ///数据绑定
    this.bind = function (data, options) {
        _that._options = $.extend({}, options);

        this.getResources(function (resources) {
            $(data.DataSource).each(function (i) {
                this.title = data.DataSource[i]['RC102_A01'];
                this.start = data.DataSource[i]['RC101_A01'];
                this.end = data.DataSource[i]['RC101_A02'];
                this.isAllDay = true;
                this.id = data.DataSource[i]['RC101_ID'];
                this.roomId = data.DataSource[i]['RC101_A04'];
            });

            var dataSource = {
                data: data.DataSource,
                batch: true,
                type: "json",
            };
            var SchedulerOptions = {
                dataSource: dataSource,
                date: $C.server.currentDate(),
                workDayStart: new Date(2013,1,1,8,0,0),//工作开始时间
                workDayEnd: new Date(2013,1,1,18,0,0),//工作结束时间
                //height: 800,//设置高度
                showWorkHours: true,//工作视图，default: false
                //mobile: true,//如果设置为真，并且在移动浏览器上使用该程序，它将使用自适应渲染。
                //workWeekStart: 2,//周开始

                //toolbar: ["pdf"],//导出PDF按键
                //pdf: {
                //    fileName: "日程事件.pdf",//导出PDF的文件名
                //},
                views: [
                    { title: "日", type: "day", selectedDateFormat: "{0:yyyy-MM-dd}" },
                    { title: "周", type: "week", workWeekStart: 1, workWeekEnd: 5 },
                    { title: "月", type: "month", selected: true },
                ],
                selectable: true,
                editable: {
                    //confirmation: false,//删除是否需要提醒
                    confirmation: "确定要删除事件吗？",//事件删除提醒消息
                    create: true,//是否可创建
                    destroy: false,//是否可删除
                    move: false,//移动
                    resize: false,//拖动大小
                    update: true,//更新
                    editRecurringMode: "dialog",//循环事件编辑方式"dialog" (default), "series" and "occurrence".
                    window: {
                        title: "日程",//弹出窗口标题
                        //animation: false,//没发现什么用
                        //open: myOpenEventHandler,//弹出窗口时触发的事件
                    },
                    //template: $("#editor").html(),//自定义编辑窗口
                },
                messages: {
                    showFullDay: "显示整天",
                    showWorkDay: "显示营业时间",
                },

                resources: resources,

                //自定义add方法
                add: function (e) {
                    scheduler_add(e);
                },
                edit: function (e) {
                    scheduler_edit(e);
                },
                //change: function (e) {
                //    console.log(e);
                //}
                //change: function (e) {
                //    //console.log(e);
                //    //console.log(e.events.length);
                //    //console.log(e.slots[0].element);
                //    if (e.events.length > 0) {
                //        app.navigate("Rc/Rcbj.aspx?id=" + e.events[0].RC101_A05 + "&sch_type=" + e.events[0].RC101_A04);
                //    } else if (e.slots.length > 0) {
                //        //console.log("准备新增");
                //        $("#buttonClickAddRc").attr("data-start", e.start);
                //        $("#buttonClickAddRc").attr("data-end", e.end);
                //    }
                //}
            };
            SchedulerOptions = $.extend(SchedulerOptions, _that._options);

            _that._$that.kendoScheduler(SchedulerOptions);
            _that._$that.bind("mouseup", function (e) {
                //console.log(_that._$that.data("kendoScheduler").select());
                var select = _that._$that.data("kendoScheduler").select(); 
                if (_that._$that.data("kendoScheduler").select().events.length > 0) {
                    //console.log("编辑");
                    //_that._$that.data("kendoScheduler").select("");
                    $.server.navigate("RC04", { id: select.events[0]['RC101_A05'], sch_type: select.events[0]['RC101_A04'], sch_name: select.events[0]['RC101_A04MC'], });
                } else {
                    //console.log("新增");
                    //$.server.navigate("RC02", { start: e.event.start, end: e.event.end });
                    $.server.navigate("RC02", { start: select.start, end: select.start });
                }
            });
            //var $k = $this.data("kendoScheduler");
            //$k.bind("change", function (e) {
            //    console.log(e);
            //    //console.log(e.events.length);
            //    //console.log(e.slots[0].element);
            //    if (e.events.length > 0) {
            //        console.log("编辑");
            //    } else if (e.slots.length > 0) {
            //        console.log("准备新增");
            //        $("#buttonClickAddRc").attr("display", "none");
            //    }
            //})
        });
    };
}

function scheduler_add(e) {
    e._defaultPrevented = true;//不要默认弹窗
    //console.log(e.event);
    $C.server.navigate("RC02", { start: e.event.start, end: e.event.end });
}

function scheduler_edit(e) {
    e._defaultPrevented = true;
    //console.log(e.event);
    $C.server.navigate("RC04", { id: e.event.RC101_A05, sch_type: e.event.RC101_A04, sch_name: e.event.RC101_A04MC, });
}
