function Tree($this) {
    var _that = this;
    this._$that = $this;
    this._$that.data("ctrl", _that);
    this._$that.empty();
    this._$k = null;
    this._init = 0;
    this._query = null;
    this._table = null;

    ///获取K控件
    this._getKTree = function () {
        return _that._$k.data("kendoTreeView");
    };
    //数据转换
    this._parseData = function (dataSource, parent) {
        var datas = [];
        $(dataSource).each(function () {
            if (parent == null) {
                if (!this[_that._options.parentField]) {
                    var root = {
                        id: this[_that._options.valueField],
                        text: (datas.length + 1) + "." + this[_that._options.textField],
                        spriteCssClass: "k-icon k-i-restore",
                        items: [],
                        data: this
                    };
                    datas.push(root);
                    _that._parseData(dataSource, root);
                    if (root.items.length == 0) {
                        root.spriteCssClass = ""//"k-icon k-i-excel";
                    }
                }
            } else {
                if (this[_that._options.parentField] && parent.id == this[_that._options.parentField]) {
                    var child = {
                        id: this[_that._options.valueField],
                        text: (parent.items.length + 1) + "." + this[_that._options.textField],
                        spriteCssClass: "k-icon k-i-restore",
                        items: [],
                        data: this
                    };
                    parent.items.push(child);
                    _that._parseData(dataSource, child);
                    if (child.items.length == 0) {
                        child.spriteCssClass = ""//"k-icon k-i-excel";
                    }
                }
            }
        });
        if (datas.length == 1) {
            datas[0].expanded = true;
        }
        return datas;
    };


    ///绑定前事件
    this.beforeLoad = $.util.defaultEvent;
    ///绑定后事件
    this.afterLoad = $.util.defaultEvent;
    ///选中后事件
    this.afterSelect = $.util.defaultEvent;
    ///复选选中后事件
    this.afterCheck = $.util.defaultEvent;
    ///展开后事件
    this.afterExpand = $.util.defaultEvent;
    ///收缩后事件
    this.afterCollapse = $.util.defaultEvent;

    ///获取查询参数
    this.getQuery = function () {
        return _that._query;
    };
    ///获取表结构
    this.getTable = function () {
        return _that._table;
    };
    ///获取数据源
    this.getDatas = function () {
        return _that._getKTree().dataSource.data();
    };
    ///获取选中
    this.select = function (datas) {
        if (datas === undefined) {
            var result = [];
            var k = _that._getKTree();
            var trs = k.select();
            $(trs).each(function (i) {
                var d = k.dataItem(trs[i]);
                if (d) {
                    result.push(d.data);
                }
            });
            return result;
        } else {
            var ktree = _that._getKTree();
            if (ktree) {
                ktree.select(ktree.findByUid(datas.uid));
            }
            $.util.trigger(_that.afterSelect, {
                datas: _that.select()
            });
        }
        return false;
    };

    ///获取选中
    this.selectItem = function () {
        var k = _that._getKTree();
        return k.dataItem(k.select());
    };

    ///获取选中
    this.check = function () {
        var result = [];
        var datas = $.util.parseArray(_that._getKTree().dataSource.data(), "items");
        $(datas).each(function () {
            if (this.checked) {
                result.push(this.data);
            }
        });
        return result;
    };

    ///数据绑定
    this.load = function (q, options) {
        _that._query = $.extend(new $.server.queryOptions(), q);
        $.server.query(_that._query, function (data) {
            _that._table = data.Table;
            _that.bind(data.DataSource, options);
        });
    };

    ///绑定数据
    this.bind = function (data, options) {
        _that._options = $.extend({
            valueField: "",
            textField: "",
            parentField: "",
            endField: "",
            selectMode: 1//1为单选2为多选
        }, _that._options, options);

        if (_that._$k != null) {
            _that._$k.remove();
        }
        _that._$k = $("<div></div>");
        if (_that._$that.css("height") != "0px") {
            _that._options.height = _that._$that.css("height");
        }
        if (_that._options.height) {
            _that._$k.height(_that._options.height);
            _that._$that.css("color", "#444");
            _that._$that.css("background-color", "#fff");
            _that._$that.css("border-color", "#ccc");
        }
        _that._$k.appendTo(_that._$that);

        $.util.trigger(_that.beforeLoad, {
            table: _that._table,
            datas: data
        }, function () {
            var datas = _that._parseData(data);
            var dataSource = new kendo.data.HierarchicalDataSource({
                data: datas,
                model: {
                    id: _that._query == null ? null : _that._query.PrimaryKeyField
                },
                change: function (aa, bb) {
                    var aaa = aa;
                },
                type: "json",
            });

            var treeOptions = {
                dataSource: dataSource,
                loadOnDemand: false,
                dragAndDrop: _that._options.drag,
                check: function (e) {
                    $.util.trigger(_that.afterCheck, {
                        datas: _that.check()
                    });
                },
                select: function (e) {
                    var datas = [];
                    datas.push(_that._getKTree().dataItem(e.node).data);
                    $.util.trigger(_that.afterSelect, {
                        datas: datas
                    });
                },
                expand: function (e) {
                    var datas = [];
                    datas.push(_that._getKTree().dataItem(e.node).data);
                    $.util.trigger(_that.afterExpand, {
                        datas: datas
                    });
                },
                collapse: function (e) {
                    var datas = [];
                    datas.push(_that._getKTree().dataItem(e.node).data);
                    $.util.trigger(_that.afterCollapse, {
                        datas: datas
                    });
                }
            };
            if (_that._options.selectMode == 2) {
                treeOptions.checkboxes = {
                    checkChildren: true,
                    name: "chk"
                };
            }
            _that._$k.kendoTreeView(treeOptions);
            //_that._getKTree().bind("dragstart", function (e) {
            //    e._defaultPrevented = true;
            //});
            //_that._getKTree().bind("dragend", function (e) {
            //    e._defaultPrevented = true;
            //});
            //_that._getKTree().bind("drag", function (e) {
            //    e._defaultPrevented = true;
            //});
            if (_that._options.drag) {
                _that._getKTree().bind("drop", function (e) {
                    if (e.dropPosition === "over") {
                        e._defaultPrevented = true;
                    }
                });
            }

            $.util.trigger(_that.afterLoad, {
                table: _that._table,
                datas: _that.getDatas()
            });
        });
    }

    ///重新绑定
    this.refresh = function () {
        _that.load(_that.getQuery());
    };

    this.add = function () {
        var q = $.extend(_that.getQuery(), { PageSize: 1, PageIndex: 1, Conditions: [] });
        q.AddCondition("0", q.PrimaryTable + "." + q.PrimaryKeyField, $.server.opeType.Equal, "0");
        $.server.navigate('GK01', { mode: 1, queryOptions: q });
    };
    this.edit = function () {
        var q = $.extend(_that.getQuery(), { PageSize: 1, PageIndex: 1, Conditions: [] });
        var datas = _that.select();
        if (datas.length == 0) {
            $.util.info("请选择要操作的数据");
            return;
        }
        q.AddCondition("0", q.PrimaryTable + "." + q.PrimaryKeyField, $.server.opeType.Equal, datas[0][q.PrimaryTable + "_" + q.PrimaryKeyField]);
        $.server.navigate('GK01', { mode: 2, queryOptions: q });
    };
    this.del = function (op) {
        var sels = _that.select();
        if (sels.length == 0) {
            $.util.info("请选择要操作的数据");
            return;
        }
        op = $.extend({ msg: "确认删除所选数据?" }, op);
        $.util.confirm(op.msg, function (options) {
            if (options) {
                $(sels).each(function () {
                    this["_ROWSTATE"] = 3;
                });
                var up = $.server.updateOptions(_that._table, sels, _that._query.PrimaryTable, _that._query.PrimaryKeyField)
                $.server.update(up, function () {
                    _that.refresh();
                });
            }
        });
    };

}
