appcan.ready(function() {
    var url = $.gr.getServer();
    url = url.split("//")[1].split("/")[0];
    
    function autoLogin() {
        window.location = '/login.html';
    }

    function setState($ele, msg, hide) {
        var $c = $ele.parent().parent();
        $(".reg-error-box", $c).remove();
        if (msg) {
            var $error = $("<div class='reg-error-box'><em class='reg-error-icon'></em><span>" + msg + "</span></div>");
            $("#btnNext").addClass("reg-btn-loading");
            $("#btnReset").addClass("reg-btn-loading");
            $c.append($error);
            if (hide) {
                $error.hide();
            } else {
                $("#btnNext").removeClass("reg-btn-loading");
                $("#btnReset").removeClass("reg-btn-loading");
            }
        }
        if ($(".reg-error-box").length == 0) {
            $("#btnNext").addClass("reg-btn-active");
            $("#btnNext").removeClass("reg-btn-loading");
            $("#btnReset").addClass("reg-btn-active");
            $("#btnReset").removeClass("reg-btn-loading");
        } else {
            $("#btnNext").removeClass("reg-btn-active");
            $("#btnReset").removeClass("reg-btn-active");
        }
    }

    function timeToVerify() {
        var sec = $("#btnVerify").data("sc");     
        if (sec > 0) {
            $("#btnVerify").data("sc", sec - 1);
            $("#btnVerify").html("<span style='color:red'>" + sec + "</span><span>秒后重新获取</span>");
            setTimeout(timeToVerify, 1000);
        } else {
            $("#btnVerify").html("<span style='color:red'>获取短信验证码</span>");
        }
    }


    $(document).ready(function() {
        $("#phone").blur(function() {
            var phone = $("#phone").val();
            if (!phone) {
                setState($("#phone"), "请输入手机号码");
            } else if (!phone.isPhone()) {
                setState($("#phone"), "请输入有效的手机号码");
            } else {
                setState($("#phone"), "正在校验手机号...", true);
                $.server.phoneExists({
                    phone : phone
                }, function(ret) {
                    if (ret) {
                        setState($("#phone"));
                        $("#btnVerify").click();
                    } else {
                        setState($("#phone"), "该手机未注册，无法找回密码");
                    }
                });
            }
        });

        $("#verify").blur(function() {
            if (!$("#verify").val()) {
                setState($("#verify"), "请输入短信验证码");
            } else {
                setState($("#verify"));
            }
        });

        $("#pwd").blur(function() {
            if (!$("#pwd").val()) {
                setState($("#pwd"), "请输入密码");
            } else {
                setState($("#pwd"));
            }
        });

        $("#repwd").blur(function() {
            if (!$("#repwd").val()) {
                setState($("#repwd"), "请再次确认密码");
            } else if ($("#pwd").val() != $("#repwd").val()) {
                setState($("#repwd"), "两次输入的密码不一致");
            } else {
                setState($("#repwd"));
            }
        });

        $("#btnVerify").click(function() {
            if ($("#phone").parent().parent().find(".reg-error-box").length > 0) {
                return;
            }
            var $vali = $(this);
            if ($vali.data("sc") > 0) {
                return;
            } else {
                $vali.data("sc", 60);
                $vali.html("<span style='color:#ccc'>获取短信验证码</span>");
                $.server.sendVerify({
                    phone : $("#phone").val()
                }, function(ret) {
                    if (!ret) {
                        $vali.data("sc", 0);
                    }
                    timeToVerify();
                })
            }
            return false;
        })

        $("#btnNext").click(function() {
            $("#verify").trigger("blur");
            if ($(".reg-error-box").length > 0) {
                return;
            }
            setState($("#verify"), "正在加载...", true);

            var data = {
                phone : $("#phone").val(),
                verify : $("#verify").val()
            }

            var op = {
                type : 'POST',
                url : "/api/Base/PhoneVerify?" + Math.random(),
                data : data,
                async : true
            };
            $.server.validateVerify(data, function(ret) {
                if (ret) {
                    $(".reg-step1").hide();
                    $(".reg-step2").show();
                    $("#pwd").focus();
                    setState($("#verify"));
                } else {
                    setState($("#verify"), "验证码校验失败，请检查后重新输入");
                }
            });
        })

        $("#btnReset").click(function() {
            $("#pwd").trigger("blur");
            $("#repwd").trigger("blur");
            if ($(".reg-error-box").length > 0) {
                return;
            }
            setState($("#btnNext"), "正在加载...", true);

            var data = {
                phone : $("#phone").val(),
                verify : $("#verify").val(),
                pwd : $("#pwd").val()
            }

            var op = {
                type : 'POST',
                url : "/api/Base/forget?" + Math.random(),
                data : data,
                async : true
            };
            $.server.forgetPwd(data, function(data) {
                //注册成功
                setState($("#btnReset"), "重置成功!", true);
                $("#btnReset").val("重置成功!3秒后自动跳转到登录");
                setTimeout(function() {
                    if ($.util.isMobile()) {
                        appcan.window.close(-1);
                    } else {
                        window.location = "/login.html";
                    }
                }, 3000);
            });
        })

        $(".f_login").click(function() {
            if ($.util.isMobile()) {
                appcan.window.close(-1);
            } else {
                window.location = "/login.html";
            }
        });
        $.server.companyInfo(url, function (ret) {
            if (ret) {
                $("#imgLogo").attr("src", $.mobile.imgUrl(ret[0]["A09"], "logo"));
                $("#imgLogo").attr("alt", ret[0]["A02"]);
            }
        })
    })
});
