appcan.ready(function() {
    function setState($ele, msg, hide) {
        var $c = $ele.parent().parent();
        $(".reg-error-box", $c).remove();
        if (msg) {
            var $error = $("<div class='reg-error-box'><em class='reg-error-icon'></em><span>" + msg + "</span></div>");
            $("#btnNext").addClass("reg-btn-loading");
            $("#btnReg").addClass("reg-btn-loading");
            $c.append($error);
            if (hide) {
                $error.hide();
            } else {
                $("#btnNext").removeClass("reg-btn-loading");
                $("#btnReg").removeClass("reg-btn-loading");
            }
        }
        if ($(".reg-error-box").length == 0) {
            $("#btnNext").addClass("reg-btn-active");
            $("#btnNext").removeClass("reg-btn-loading");
            $("#btnReg").addClass("reg-btn-active");
            $("#btnReg").removeClass("reg-btn-loading");
        } else {
            $("#btnNext").removeClass("reg-btn-active");
            $("#btnReg").removeClass("reg-btn-active");
        }
    }

    function timeToVerify() {
        var sec = $("#btnVerify").data("sc");
        if (sec > 0) {
            $("#btnVerify").data("sc", sec - 1);
            $("#btnVerify").html("<span style='color:red'>" + sec + "</span><span>秒后重发</span>");
            setTimeout(timeToVerify, 1000);
        } else {
            $("#btnVerify").html("<span style='color:red'>获取验证码</span>");
        }
    }


    $(document).ready(function() {
        $("#phone").blur(function() {
            var phone = $("#phone").val();
            if (!phone) {
                setState($("#phone"), "请输入手机号码");
            } else if (!phone.isPhone()) {
                setState($("#phone"), "请输入有效的手机号码");
            } else {
                setState($("#phone"), "正在校验手机号...", true);
                $.server.phoneExists({
                    phone : phone
                }, function(ret) {
                    if (ret) {
                        setState($("#phone"), "该手机已经注册，请返回登录");
                    } else {
                        setState($("#phone"));
                        $("#btnVerify").click();
                    }
                });
            }
        });

        $("#verify").blur(function() {
            if (!$("#verify").val()) {
                setState($("#verify"), "请输入短信验证码");
            } else {
                setState($("#verify"));
            }
        });

        $("#name").blur(function() {
            if (!$("#name").val()||!$.trim($("#name").val())) {
                setState($("#name"), "请输入公司全称");
            } else {
                setState($("#name"));
            }
        });

        $("#pwd").blur(function() {
            if (!$("#pwd").val()) {
                setState($("#pwd"), "请输入密码");
            } else {
                setState($("#pwd"));
            }
        });

        $("#repwd").blur(function() {
            if (!$("#repwd").val()) {
                setState($("#repwd"), "请再次确认密码");
            } else if ($("#pwd").val() != $("#repwd").val()) {
                setState($("#repwd"), "两次输入的密码不一致");
            } else {
                setState($("#repwd"));
            }
        });

        $("#btnVerify").click(function() {
            if ($("#phone").parent().parent().find(".reg-error-box").length > 0) {
                return;
            }
            var $vali = $(this);
            if ($vali.data("sc") > 0) {
                return;
            } else {
                $vali.data("sc", 60);
                $vali.html("<span style='color:#ccc'>获取验证码</span>");
                $.server.sendVerify({
                    phone : $("#phone").val()
                }, function(ret) {
                    if (!ret) {
                        $vali.data("sc", 0);
                    }
                    timeToVerify();
                })
            }
            return false;
        })

        $("#btnNext").click(function() {
            $("#verify").trigger("blur");
            if ($(".reg-error-box").length > 0) {
                return;
            }
            setState($("#verify"), "正在加载...", true);

            var data = {
                phone : $("#phone").val(),
                verify : $("#verify").val()
            }

            var op = {
                type : 'POST',
                url : "/api/Base/PhoneVerify?" + Math.random(),
                data : data,
                async : true
            };
            $.server.validateVerify(data, function(ret) {
                if (ret) {
                    $(".reg-step1").hide();
                    $(".reg-step2").show();
                    $("#name").focus();
                    setState($("#verify"));
                } else {
                    setState($("#verify"), "验证码校验失败，请检查后重新输入");
                }
            });
        })

        $("#btnReg").click(function() {
            $("#pwd").trigger("blur");
            $("#repwd").trigger("blur");
            if ($(".reg-error-box").length > 0) {
                return;
            }
            setState($("#btnNext"), "正在加载...", true);
            var isYx = '0';
            var data = {
                phone : $("#phone").val(),
                verify : $("#verify").val(),
                name : $("#name").val(),
                pwd : $("#pwd").val(),
                isYx :isYx
            }

            var op = {
                url : "/api/Base/Register?" + Math.random(),
                data : data
            };
            $.server.register(data, function(data) {
                        //注册成功
                        setState($("#btnReg"), "注册成功!", true);
                        $("#btnReg").val("注册成功!3秒后自动跳转到登录");
                        setTimeout(function() {
                            appcan.window.close(-1);
                        }, 3000);
            });
        })

        $(".login").click(function() {
            appcan.window.close(-1);
        })
    })
}); 
